alsp.class('ALSPAdminConfigAdvanced', function (name, alsp, $) {
	const { ajax, dialog } = alsp;

	return class extends alsp.class('ALSPAdminAbstract') {
		constructor(container) {
			super(container);

			this.$onBehalf = this.$container.find('#on_behalf_roles_select');
			this.$onBehalfRegister = this.$container.find('#on_behalf_register_role_select');

			this.$onBehalf.on('change', e => this.onBehalfChange(e)).triggerHandler('change');
		}

		onBehalfChange(e) {
			let roles = +this.$onBehalf.val();
			let registerRoles = +this.$onBehalfRegister.val();

			this.$onBehalfRegister.children('option').each((i, opt) => {
				opt.disabled = +opt.value > roles;
			});

			if (registerRoles > roles) {
				this.$onBehalfRegister.val(roles).trigger('change');
			}
		}
	};
});
