alsp.class('ALSPAdmin', function (name, alsp, $) {
	return class extends alsp.class('ALSPAbstract') {
		constructor(container) {
			super(container);

			this.$container.on('change', 'input[type=checkbox]', e =>
				this.onInputCheckboxChange(e)
			);
		}

		onCheckboxClick(e) {
			e.stopPropagation();

			let $toggle = $(e.currentTarget);
			let $checkbox = $toggle.next('input[type=checkbox]');

			if ($checkbox.length) {
				$checkbox.trigger('click');
			}
		}

		onInputCheckboxChange(e) {
			let $checkbox = $(e.currentTarget);
			let $toggle = $checkbox.prev('[data-alsp=checkbox]');

			if ($toggle.length) {
				if ($checkbox.is(':checked')) {
					$toggle.removeClass('alsp-i-toggle-off').addClass('alsp-i-toggle-on');
				} else {
					$toggle.removeClass('alsp-i-toggle-on').addClass('alsp-i-toggle-off');
				}
			}
		}
	};
});

jQuery(function ($) {
	let container = document.querySelector('[data-alsp=admin-page]');
	if (container) {
		new (alsp.class('ALSPAdmin'))(container);
	}
});
