(function (alsp) {
	let cache = {};

	/** Only save the following data. */
	let cacheTypes = {
		statuses: 'array',
		statuses_counts: 'object',
		ticket: 'object',
		ticket_messages: 'object',
		recent_tickets: 'array'
	};

	function get(name, key) {
		if (cacheTypes[name] && cache[name]) {
			if (key) return cache[name]?.[key];
			return cache[name];
		}
	}

	function clear(name, key) {
		if (cacheTypes[name] && cache[name]) {
			if (key) delete cache[name]?.[key];
			else delete cache[name];
		}
	}

	function set(name, key, data) {
		let type = cacheTypes[name];

		if ('array' === type) {
			data = key;
			if (data instanceof Array) cache[name] = data;
		} else if ('object' === type) {
			if ('undefined' === typeof data) {
				data = key;
				key = undefined;
			}

			if (data) {
				cache[name] ??= {};
				if (key) cache[name][key] = data;
				else cache[name] = data;
			}
		}
	}

	Object.assign(alsp, { cache: { get, set, clear } });
})(window.alsp);
