alsp.class('ALSPUnsubscribe', function (name, alsp, $) {
	const { data: config } = alsp;

	return class extends alsp.class('ALSPAbstract') {
		constructor(container) {
			container = container.appendChild(document.createElement('div'));
			super(container, config('templates.unsubscribe'));

			this.$container.hide();
			this.$success = this.$container.find('[data-alsp=success]').hide();
			this.$error = this.$container.find('[data-alsp=error]').hide();
		}

		onSectionMatch(section, parts) {
			if (parts[0] === 'unsubscribe') {
				section = ['unsubscribe', parts[1]];
			}

			return section;
		}

		onToggleSection(section) {
			if ('unsubscribe' !== section[0]) {
				this.$container.hide();
				return;
			}

			let parts = (section[1] || '').split(':');
			let single = 'all' !== parts[0];
			let success = 'success' === parts[1];

			let $all = (success ? this.$success : this.$error).find('[data-alsp=message]');
			let $one = (success ? this.$success : this.$error).find('[data-alsp=message-single]');

			if (single) {
				$one.find('a').attr('href', `#ticket/${parts[0]}`).html(`#${parts[0]}`);
			}

			$all[single ? 'hide' : 'show']();
			$one[single ? 'show' : 'hide']();
			this.$success[success ? 'show' : 'hide']();
			this.$error[success ? 'hide' : 'show']();
			this.$container.show();
		}
	};
});
