alsp.class('ALSPTicketWatch', function (name, alsp, $) {
	const { ajax, hooks, data: config } = alsp;

	const USER_ID = +config('user_id');

	// class initialization hook
	hooks.addAction('init', (initName, container) => {
		if ('ALSPTicket' === initName) {
			new (alsp.class(name))(container);
		}
	});

	return class extends alsp.class('ALSPAbstract') {
		constructor(container) {
			super(container);

			this.ticket = null;

			hooks.addAction('ticket_loaded', ticket => (this.ticket = ticket));
		}

		onTicketWatchChange(e) {
			let checkbox = e.currentTarget;
			if (checkbox.loading) return;

			let params = { ticket: this.ticket.id, user: USER_ID };

			if (checkbox.checked) {
				ajax('almightysupport/v1/pro_ticket_watcher', params, 'POST')
					.always(() => delete checkbox.loading)
					.done(json => hooks.doAction('ticket_update', this.ticket.id));
			} else {
				ajax('almightysupport/v1/pro_ticket_watcher', params, 'DELETE')
					.always(() => delete checkbox.loading)
					.done(json => hooks.doAction('ticket_update', this.ticket.id));
			}
		}
	};
});
