<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2OHZzb3gwQ1Jwb1NXZ2U4bVo3OGtDaGhKZXpMdjMrRHgyK05sVkcxVXRjVjB3dC80NFMvRXpPSllwWlM3THN1UkdjUDhKZzA3ZGFkUVNJd1dtRklwVzlWVG9UaHFBekxHTU1PazBpY2ROTE5nPT0=*/

class ALSP_REST_V1_Endpoint_Admin extends ALSP_REST_V1_Endpoint
{

    public function read(WP_REST_Request $request)
    {

        $position = $request['position'] ?? 'general-left';
        $config = ALSP_Config::admin_config($position);

        return $config;
    }


    public function edit(WP_REST_Request $request)
    {
        // Values go through update_option, they are escaped there
        $value = $request['value'];
        $name = $request['name'];

        $valid = apply_filters('alsp_validate_field', TRUE, $name, $value);
        if (is_wp_error($valid)) {
            $err = $valid->get_error_message();
            wp_send_json_error($err, 400);
        }

        ALSP_Config::set($name, $value);
		do_action('alsp_config_set', $name, $value);
        return ['success' => TRUE, 'class' => __CLASS__, 'method' => __METHOD__];
    }

    public function can_edit()
    {
        $this->alsp_user = ALSP_User::get_instance();
        return $this->alsp_user->is_admin();
    }

    public function can_read()
    {
        $this->alsp_user = ALSP_User::get_instance();
        return $this->alsp_user->is_admin();
    }
}

// EOF
