<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2K1AxUUJqWDRySExleFpGUUVZN3dYMDFIU0toSDZRTjNWdWVSTklWaktoeXFnUXduaTZPR0hyeFpLMUJoQktQL3RKamdOdHJWNW90MnJKNW5zTEFNU0VNYUVFMUFzY1hYcExqOVhPdTZOOEdhV3hYMlc2NWxFdnd4WVN2REF4Z2ZjPQ==*/

class ALSP_REST_V1_Endpoint_Admin_Agent extends ALSP_REST_V1_Endpoint
{
    public function __construct()
    {
        parent::__construct();
    }

    public function read(WP_REST_Request $request)
    {
        $this->model = new ALSP_Model_Agents($request);
        $this->init($request);

        $this->items = $this->model->read();

        return $this->items_to_response();
    }

    public function edit(WP_REST_Request $request)
    {
        // Values go through update_option, they are escaped there
        $id = $request['id'];
        $role = $request['role'];
        $department = $request['department'];

        $user_obj = get_user_by('id', $id);
        if (!$user_obj) {
            return [
                'success' => FALSE,
                'error' => 'invalid_user',
                'reason' => 'get_user_by()',
                'message' => 'Something went wrong'
            ];
        }

        if (is_array($department)) {
            $agent_department = new ALSP_Model_Agent_Department(NULL);

            $agent_department->delete_by_agent($id);
            foreach ($department as $key => $dept) {
                $agent_department->create_item($id, $dept);
            }
        }

        // Save signature
        update_user_meta($id, 'alsp_signature', $request['signature']);

        // Save role
        $id = ALSP_User::update_user($id, $role);
        if (!$id) {
            return [
                'success' => FALSE,
                'error' => 'update_user_failed',
                'reason' => 'ALSP_User::update_user()',
                'message' => 'Something went wrong'
            ];
        }

        return ['success' => TRUE, 'class' => __CLASS__, 'method' => __METHOD__];
    }

    public function delete(WP_REST_Request $request)
    {
        $id = $request['id'];
        $user_obj = get_user_by('id', $id);
        if (!$user_obj) {
            return [
                'success' => FALSE,
                'error' => 'invalid_user',
                'reason' => 'get_user_by()',
                'message' => 'Something went wrong'
            ];
        }

        if ($this->model = new ALSP_Model_Agent($user_obj->ID)) {
            $ret = $this->model->delete($request);
            if (!$ret) {
                return [
                    'success' => FALSE,
                    'error' => 'failed_delete_agent',
                    'reason' => 'ALSP_Model_Agent->delete()',
                    'message' => 'Something went wrong'
                ];
            }

            $agent_department = new ALSP_Model_Agent_Department(NULL);
            $agent_department->delete_by_agent($id);

            // Clean default assignee for related department
            $department = new ALSP_Model_Department(NULL);
            $department->remove_default_assignee($id);
        }

        return ['success' => TRUE, 'class' => __CLASS__, 'method' => __METHOD__];
    }

    public function can_read()
    {
        return $this->wpuser->has_cap('alsp_ticket_list_agents');
    }

    public function can_edit()
    {
        return $this->wpuser->has_cap('alsp_ticket_edit_agents');
    }

    public function can_delete()
    {
        return $this->wpuser->has_cap('alsp_ticket_delete_agents');
    }
}

// EOF
