<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2L0FIbEVyL1Arek52eEtQeHR4NXlvRkF1TVZrM0xTdGR3MU1QSzVzN1IyL3RmTm5YWGlUOXBnK0lBc3JlNmNDYVZwYVJqN0JNdnI5emVZczFTMzAybUlzdjBIZC9NYlYwcmxiWmFEZEp4aVJuemwzNkswZjhMNFlMOVQyVS9XQkdVPQ==*/

class ALSP_REST_V1_Endpoint_Awedesk_Client_Log extends ALSP_REST_V1_Endpoint
{
    public function __construct()
    {
        parent::__construct();
    }

    public function read(WP_REST_Request $request)
    {
        $ip=ALSP_Utility_WP::get_option('awecloud_hub_ip');
        if(!strlen($ip) || $ip!=$_SERVER['REMOTE_ADDR']) {
            return FALSE;
        }

        global $wpdb;

        $table_name = $wpdb->prefix . 'alsp_log';

        if ($request['debug']) {
            $result = $wpdb->get_results("SELECT * FROM $table_name ORDER BY id DESC LIMIT 100");
            return rest_ensure_response($result);
        }

        // Validate and sanitize the 'interval' parameter
        $interval = is_numeric($request->get_param('interval')) ? intval($request->get_param('interval')) : 'all_time';

        // Get the plugin installation date from the options
        $install_date = ALSP_Config::get('install_date');
        $install_date_timestamp = strtotime($install_date);

        // Calculate the age of the plugin installation in days
        $plugin_age_in_days = $install_date ? round((time() - $install_date_timestamp) / (60 * 60 * 24)) : 0;

        // Ensure that the interval does not exceed the plugin age
        $interval = ($interval === 'all_time' || $interval > $plugin_age_in_days) ? $plugin_age_in_days : $interval;

        $date_conditions = '';

        if ($interval > 0) {
            // Use 'INTERVAL X DAY' directly in the query
            $date_conditions = "AND created >= CURDATE() - INTERVAL $interval DAY";
        }

        // Query to get the sum total of rows grouped by 'event' with date conditions
        $query = "
        SELECT 
            `event`, 
            COUNT(*) AS total, 
            COUNT(*) / $interval AS average
        FROM $table_name 
        WHERE 1 $date_conditions 
        GROUP BY `event`
    ";
        $results = $wpdb->get_results($query, ARRAY_A);

        // Prepare the response
        $response['data'] = $results;
        $response['meta'] = [
            'range' => $interval,
        ];

        return rest_ensure_response($response);
    }



    public function can_read()
    {
        return TRUE;
    }
}

// EOF
