<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2K3J3RUFPYkRaOEc0VlBCOFNIMkM0bHk4bmpKKzhCYUNBa2FiQlg4RjBSZWJMdEd3QjY2dFlTRUtIV3pDcjBHSmtxUCtDemR0dU1hcEZqWnFOU0s0MTFYWUdiWUU5Sng4Rk9zSTBCTld1ejNVUUpZUEtZS1c3S2I1WU1SeXR4aG5rPQ==*/

class ALSP_REST_V1_Endpoint_Client_Check extends ALSP_REST_V1_Endpoint
{
    public function __construct()
    {
        parent::__construct();
    }

    public function read(WP_REST_Request $request)
    {
        $email = $request['email'];
        if (!$email || !is_email($email)) {
            return [
                'success' => FALSE,
                'error' => 'invalid_email_address',
                'message' => __('Invalid email', 'awedesk'),
            ];
        }

        // Check if email is already registered
        $current_user = get_user_by('email', $email);

        return [
            'success' => TRUE,
            'is_registered' => ($current_user instanceof WP_User),
        ];
    }

    public function create(WP_REST_Request $request)
    {
        $email = $request['email'];
        if (!$email || !is_email($email)) {
            return [
                'success' => FALSE,
                'error' => 'invalid_email_address',
                'message' => __('Invalid email', 'awedesk'),
            ];
        }

        // Check if email is already registered
        $current_user = get_user_by('email', $email);
        if ($current_user) {
            return [
                'success' => FALSE,
                'error' => 'email_already_registered',
                'message' => __('Email already registered', 'awedesk'),
            ];
        }

        // Create user based on email if it's not registered
        $alsp_user_id = ALSP_User::create_user_from_email($email);
        if (!$alsp_user_id) {
            return [
                'success' => FALSE,
                'error' => 'failed_register_new_user',
                'reason' => 'create_user_from_email()',
                'message' => 'Something went wrong'
            ];
        }

        // Logging in the user
        wp_clear_auth_cookie();
        wp_set_current_user($alsp_user_id); // Set the current user detail
        wp_set_auth_cookie($alsp_user_id); // Set auth details in cookie

        return ['success' => TRUE, 'user_id' => $alsp_user_id, 'class' => __CLASS__, 'method' => __METHOD__];
    }

    public function can_read()
    {
        return !get_current_user_id();
    }

    public function can_create()
    {
        return !get_current_user_id();
    }
}

// EOF