<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2OVVZcjd2TjlJMElZMG5QdmVZelMzZzRtV1kreTg5blVpQ2NHdXlqUTBaUUR3S0dIY2FMcmw2WGp0MU5OMFNBdlFaNDhRaWoyaitZTi9RU2J5TkI4UE5wQUlDUWJ6UHdJK1dzaXZWRDRtSGJGR3d3bHZYNXFpODFvWHdzRDBlT2FvPQ==*/

class ALSP_REST_V1_Endpoint_Preferences extends ALSP_REST_V1_Endpoint
{

	private $preferences = [
		'timezone',
		'receive_emails',
        'signature',
	];


	# there are no params that require permissions checks
	public function read(WP_REST_Request $request)
	{
		$keys = $this->preferences;
		if ($request['id']) {
			$keys = [sanitize_key($request['id'])];
		}

		$preferences = [];
		$ALSP_User_Preferences = ALSP_User_Preferences::get_instance();
		foreach ($keys as $key) {
			if ($key == 'timezone') {
				// Defaults to WP timezone if not set
				$preferences[$key] = ALSP_Time::current();
				continue;
			}

			$value = $ALSP_User_Preferences->get($key);
			$preferences[$key] = strlen($value) ? $value : NULL;
		}

		return $preferences;
	}


	# there are no params that require permissions checks
	public function edit(WP_REST_Request $request)
	{
		(ALSP_User_Preferences::get_instance())->set(sanitize_key($request['id']), $request['value']);
		return ['success' => TRUE, 'class' => __CLASS__, 'method' => __METHOD__];
	}

    public function can_edit() {
        return get_current_user_id() > 0;
    }

    public function can_read() {
        return get_current_user_id() > 0;
    }
}

// EOF
