<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2OTc5dUJHUStBVncxWnpmVVJaT1RZNjhNNEVYc3NyNzZhK1Z2MkJ5a3lCd3VYYXBoMEt0TURURzBwVFVwUjZZQXJPSDRZOGI4Y2xRYStBYk9HQW8xTHFSQnJ6c0wrMWVVeHZjZ0xha3JwcnFPaUZDcDRNTUhGa0NsWm5zeU9jeXVEVzlYcTBaODVjaDlFVmxUUzdqcU4v*/

class ALSP_REST_V1_Endpoint_Pro_Admin_Department_EP_Me_Check extends ALSP_REST_V1_Endpoint
{
    public function __construct()
    {
        parent::__construct();
    }

    public function create(WP_REST_Request $request)
    {
        $department_id = $request['department_id'];
        if (!$department_id) {
            wp_send_json_error('Department ID should not be empty!', 400);
        }

        $obj_department = new ALSP_Model_Department($department_id);
        $department_details = $obj_department->get_item();
        if(!isset($department_details['id'])) {
            wp_send_json_error('Department not found!', 400);
        }

        $client_id = ALSP_Config::get($department_id . '_ep_me_client_id_label');
        $client_secret = ALSP_Config::get($department_id . '_ep_me_client_secret_label');
        $tenant_id = ALSP_Config::get($department_id . '_ep_me_tenant_id_label');

        // initialize the connection.
        set_transient($department_id . '_alsp_ep_connection_init', 'yes', MINUTE_IN_SECONDS * 60);

        $client_id = sanitize_text_field(wp_unslash($client_id));
        if (!$client_id) {
            wp_send_json_error('Client ID should not be empty!', 400);
        }

        $tenant_id = sanitize_text_field(wp_unslash($tenant_id));
        if (!$tenant_id) {
            wp_send_json_error('Tenant ID should not be empty!', 400);
        }

        $client_secret = sanitize_text_field(wp_unslash($client_secret));
        if (!$client_secret) {
            wp_send_json_error('Client Secret should not be empty!', 400);
        }

        // MS Graph oAuth URL.
        $url = ALSP_Config_EP_Config_Connection_Checker::generate_me_auth_url($client_id, $tenant_id, $department_id);

        wp_send_json(['redirectURL' => esc_url_raw($url)], 200);
    }

    public function can_create()
    {
        $this->alsp_user = ALSP_User::get_instance();
        return $this->alsp_user->is_admin();
    }
}

// EOF
