<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2OXh5YWQ3VktkVFRZYWFVVm83Q01tcHVZQzlpUE5KQzAwYjU4MG5MWmpPdndyZG1Sb25sejdmTmE5cE9CNDdsbmp2aWNSNm41SXlZY1Z5R29nZTdpK3BtZjBtWGswRGIyVHN2alhteVQyUVpBZndjYy81UWtmQVRUZFBDalhkOEM0PQ==*/

class ALSP_REST_V1_Endpoint_Pro_App extends ALSP_REST_V1_Endpoint
{
    public function __construct()
    {
        parent::__construct();
    }

    public function read(WP_REST_Request $request)
    {
        $error = true;
        $response = [
            'ok' => true,
            'message' => '',
            'url' => get_bloginfo('url'),
            'name' => '',
            'logo' => '',
            'color' => '',
        ];

        if(ALSP_Config::get('app_enabled') || apply_filters('awecloud_is_client', false)) {
            $logo_id = ALSP_Config::get('app_logo_image');
            $response['logo'] = $logo_id ? wp_get_attachment_url($logo_id) : '';
            $response['color'] = ALSP_Config::get('app_color');
            $response['name'] = ALSP_Config::get('app_name_label');

            // Notes
            $response['secret_enabled'] = ALSP_Config::get('secret_enabled');
            $response['staff_notes_clients_enabled'] = ALSP_Config::get('staff_notes_clients_enabled');
            $response['staff_notes_tickets_enabled'] = ALSP_Config::get('staff_notes_tickets_enabled');

            // On behalf
            $response['on_behalf_enabled'] = ALSP_Config::get('on_behalf_enabled');
            $response['on_behalf_roles_select'] = ALSP_Config::get('on_behalf_roles_select');

            // Integrations
            $response['edd_integration_enabled'] = ALSP_Config::get('edd_integration_enabled');
            $response['woo_integration_enabled'] = ALSP_Config::get('woo_integration_enabled');

            // Signatures
            $response['signatures_enabled'] = ALSP_Config::get('signatures_enabled');

			// Push
	        $response['push_enabled'] = ALSP_Config::get('app_push_enabled');

            // Awedesk version & features
            $response['awedesk_version'] = ALSP::PLUGIN_VERSION;
            $response['has_recent_tickets'] = '1';

            // Awedesk admin page URL
            $page_id_client = ALSP_Config::get('support_page_client_select', -1);
            $page_id_agent = ALSP_Config::get('support_page_agent_select', $page_id_client, TRUE);
            if($page_id_agent != -1) {
                $response['url_agent'] = trim(get_home_url(),'/').'/'.trim(get_page_uri($page_id_agent),'/').'/';
                $response['url_agent_embed'] = str_ireplace(get_page_uri($page_id_agent),''.get_page_uri($page_id_agent).'/share', $response['url_agent']);
            }

            $error = false;
        }

        if(apply_filters('awecloud_is_client', false)) {
            $logo_id = ALSP_Config::get('awecloud_bloglogo_image');
            $response['logo'] = $logo_id ? wp_get_attachment_url($logo_id) : '';
            $response['color'] = ALSP_Config::get('awecloud_color');
            $response['name'] = ALSP_Config::get('awecloud_blogname_label');
        }

        if(!strlen($response['name'])) {
            $response['name'] = get_bloginfo('name');
        }

        $readmore = " Please refer to the documentation or contact us.";

        if($error) {
            $response['ok'] = false;
            $response['message'] = 'Awedesk is not configured. '.$readmore;
        } else {
            $response = apply_filters('alsp_app_response', $response);
        }

        return rest_ensure_response($response);
    }

    public function can_read()
    {
        return true;
    }
}

// EOF
