<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2OHU5Z3ZVU0h4a3NpTzlmbXM0c2ppelg0eWNvekFGbDFiSklpWUZ0aTRPK1pvSEU3UFNKSmNBUlViTjl2bERnYXR0YWdTMjZUbFVmcnRDTmVqYktSMlVqVDRla0ttOTRIbnlobEZROXdaU0F4SmFPS3VmOExOT1BtRUZETFp4Ums4PQ==*/

class ALSP_REST_V1_Endpoint_Pro_App_Auth extends ALSP_REST_V1_Endpoint
{
    public function __construct()
    {
        parent::__construct();
        if(apply_filters('awecloud_is_client', false)) {
            // Enforce application passwords
            add_filter('wp_is_application_passwords_available', '__return_true');
        }
    }

    public function read(WP_REST_Request $request) {
        return rest_ensure_response(['status' => 'ok']);
    }

    public function create(WP_REST_Request $request)
    {
        $username = $request['username'] ?? '';
        $password = $request['password'] ?? '';

        // Validate user credentials
        $user = wp_authenticate($username, $password);

        $response = [
            'ok' => true,
            'message' => '',
            'user_id' => null,
            'username' => $username,
            'password' => '',
        ];

        if (is_wp_error($user)) {
            $response['ok'] = false;
            $response['message'] = strip_tags($user->get_error_message());
            return rest_ensure_response($response);
        }

        // Get the user ID from the authenticated user object
        $user_id = $user->ID;
        $response['user_id'] = $user_id;

        // Ensure the Application Passwords feature is available
        if (!function_exists('wp_generate_password')) {
            $response['ok'] = false;
            $response['message'] = 'Application passwords are not supported';
            return rest_ensure_response($response);
        }

        // Generate an application password
        $application_password = WP_Application_Passwords::create_new_application_password(
            $user_id,
            array(
                'name'   => 'Awedesk App (' . date('Y-m-d H:i:s').')',
                'app_id' => time(),
            )
        );

        if (is_wp_error($application_password)) {
            $response['ok'] = false;
            $response['message'] = strip_tags($application_password->get_error_message());
            return rest_ensure_response($response);
        }

        $response['password'] = $application_password[0]; // Get the generated password
        return rest_ensure_response($response);
    }

    public function can_create()
    {
        return true;
    }

    public function can_read() {
            return is_user_logged_in();
    }
}

// EOF
