<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2OFFva3JteWVhMVB4SU4vY0dYOVpZam5PYzAzemN6UXZYeldoejJuNEYrRlk3TlBVOEtDVU9qVDBWdUVFQTQvVUJxNGVPQnpqcFlUUk54NDdaYWwrNHdwWHlDenpuR0Q2RVREdk9tVThlUFF1LzNaSHVoNWs1OFpCakNCTm41WVljPQ==*/

class ALSP_REST_V1_Endpoint_Pro_App_Push_Token extends ALSP_REST_V1_Endpoint {

    public $state;

    public function __construct() {
        parent::__construct();
    }


    public function read(WP_REST_Request $request) {}

    public function create(WP_REST_Request $request) {
        global $wpdb;

        $token = $request->get_param('push_token');
        $device = $request->get_param('device_name');
        $user = get_current_user_id();
        $table_name = $wpdb->prefix . 'alsp_app_push';

        // Check if the user and token combination exists
        $existing_record = $wpdb->get_row(
            $wpdb->prepare(
                "SELECT * FROM $table_name WHERE user = %d AND token = %s",
                $user,
                $token
            )
        );

        $current_datetime = current_time('mysql',1);

        if ($existing_record) {
            // Update existing record
            $wpdb->update(
                $table_name,
                [
                    'device' => $device,
                    'updated' => $current_datetime
                ],
                [
                    'user' => $user,
                    'token' => $token
                ],
                ['%s', '%s'], // Data format
                ['%d', '%s']  // Where format
            );
        } else {
            // Insert new record
            $wpdb->insert(
                $table_name,
                [
                    'user' => $user,
                    'token' => $token,
                    'device' => $device,
                    'created' => $current_datetime
                ],
                ['%d', '%s', '%s', '%s'] // Data format
            );
        }

        return rest_ensure_response(
            [
                'user' => $user,
                'token' => $token,
                'device' => $device,
                'last_error' => $wpdb->last_error
            ]
        );
    }


    protected function can_read() {
        return TRUE;
    }

    protected function can_create() {
        return TRUE;
    }

    protected function can_edit() {
        return FALSE;
    }

    protected function can_delete() {
        return FALSE();
    }

}
