<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2L3EvZGZsNkFsZlFLS1RkdjFpM0dwNFVOSFR0ZGRVNVA3cTFaQ1FubmR0aURCOE9LQ1NKdlVaWEtjRmNIaUl5a3hkbkZtSG9vb2J6OFlEOGdlNlBLS1dKc0hWYUdTZDlPMmMvMkRzZkVrMytzd3BsV3FVWW13Z2VGMGhtTDJVOXE4PQ==*/

class ALSP_REST_V1_Endpoint_Pro_Staff_Notes extends ALSP_REST_V1_Endpoint
{
    private $type;
    private $client_id;
    private $ticket_id;

    public function __construct()
    {
        parent::__construct();
    }

    public function init(WP_REST_Request $request)
    {
        parent::init($request);

        $this->type = $request['type'] ?? 'ticket';
        $client_id = $request['client_id'] ?? FALSE;
        $ticket_id = $request['ticket_id'] ?? FALSE;

        if ($this->type == 'client') {
            $this->client_id = $client_id;
            $this->ticket_id = $ticket_id;
        } else {
            $this->ticket_id = $ticket_id;
            $this->client_id = (new ALSP_Model_Ticket($ticket_id))->client;
        }

        $this->ticket_id = (int) $this->ticket_id;
        $this->client_id = (int) $this->client_id;
    }

    public function read(WP_REST_Request $request)
    {
        $this->init($request);

        if (($this->client_id + $this->ticket_id) == 0) {
            return [
                'success' => FALSE,
                'error' => 'missing_mandatory_fields',
                'message' => __('Missing mandatory fields', 'awedesk'),
            ];
        }

        $model = new ALSP_Model_Staff_Notes($this->client_id, $this->ticket_id);

        return rest_ensure_response($model->read());
    }

    public function create(WP_REST_Request $request)
    {
        $this->init($request);
        $message = $request['message'] ?? '';

        if (($this->client_id + $this->ticket_id) == 0 || strlen($message) === 0) {
            return [
                'success' => FALSE,
                'error' => 'missing_mandatory_fields',
                'message' => __('Missing mandatory fields', 'awedesk'),
            ];
        }

        $model = new ALSP_Model_Staff_Notes($this->client_id, $this->ticket_id);
        return rest_ensure_response($model->create($message, $this->type));
    }

    public function delete(WP_REST_Request $request)
    {
        $this->init($request);
        $id = $request['id'] ?? FALSE;
        if (intval($id) === 0) {
            return [
                'success' => FALSE,
                'error' => 'missing_mandatory_fields',
                'message' => __('Missing mandatory fields', 'awedesk'),
            ];
        }

        $model = new ALSP_Model_Staff_Notes($this->client_id, $this->ticket_id);
        return rest_ensure_response($model->delete($id, $this->type));
    }

    public function can_read()
    {
        $this->alsp_user = ALSP_User::get_instance();
        return $this->alsp_user->is_staff();
    }

    public function can_create()
    {
        $this->alsp_user = ALSP_User::get_instance();
        return $this->alsp_user->is_staff();
    }

    public function can_delete()
    {
        $this->alsp_user = ALSP_User::get_instance();
        return $this->alsp_user->is_staff();
    }
}

// EOF
