<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2L0hSdi9PVkFYMTdvSzVnTzduTXl6U1lmazY2K3JyYTBUK21oM2NIQlAyM3d4LzRtaXNRcnpUN05IaVMwMWwvTzlJeEZVQWFSdm83SUdJWlhNQXU1ZVVWS1lUTVpwbjlnUERORXJaUTVrV3pWTGVnMVpzb2dRUHFiRmduTUc4WUljPQ==*/

class ALSP_REST_V1_Endpoint_Pro_Suggestions extends ALSP_REST_V1_Endpoint
{

    public function __construct()
    {
        parent::__construct();
    }

    public function init(WP_REST_Request $request)
    {
        parent::init($request);
    }

    public function read(WP_REST_Request $request)
    {
        global $wpdb;

        // Normalize search query to lowercase collection of unique words in alphabetic order
        $s = strtolower(sanitize_text_field($request->get_param('s')));

//        $from = ['-', '_', '.', ',', ';', ':', '!', '?', '(', ')', '[', ']', '{', '}', '"', "'", '“', '”', '‘', '’', '«', '»', '„', '…', '—', '–',];
//        $s = str_replace($from,' ', $s);

        $s = trim(str_replace("  "," ",$s));

        $cache_key = 'alsp_suggestions_' . md5($s);
        $cache = ALSP_Mayfly::get($cache_key);

        if(!isset($_GET['no_cache']) && is_array($cache) && array_key_exists('data', $cache) && array_key_exists('meta', $cache)) {
            $cache['meta']['from_cache'] = 1;
            return rest_ensure_response($cache);
        }

        $data = [
            'meta' => [
                'search' => $s,
            ],
            'data' => [],
        ];

        $cpts = ALSP_CPT_Integration::get_instance()->all_enabled(TRUE);
        $data['meta']['cpts'] = $cpts;

        if (count($cpts)) {

            // Search posts of this post_type based on $title
            foreach ($cpts as $cpt => $meta) {

                $query = $wpdb->prepare("SELECT ID, post_title, (MATCH(post_title,post_content) AGAINST (%s IN NATURAL LANGUAGE MODE)) as score
                    FROM {$wpdb->prefix}posts 
                    WHERE 
                        (MATCH(post_title,post_content) AGAINST (%s IN NATURAL LANGUAGE MODE))
                        AND post_type = %s 
                        AND post_status = 'publish'
                    ORDER BY score DESC
                    LIMIT %d", $s, $s, $cpt, ALSP_Config::get('docs_cpt_results_number'));
                $result = $wpdb->get_results($query, ARRAY_A);

                if (count($result)) {
                    $data['data'][$cpt] = [];
                    foreach ($result as $suggestion) {
                        $excerpt = wp_trim_words(
                                        strip_shortcodes(   wp_strip_all_tags(  get_post($suggestion['ID'])->post_content   )   ),
                                        AlSP_Config::get('docs_cpt_words_number')
                                    );
                        $excerpt = strlen($excerpt) ? $excerpt : __('Preview not available', 'awedesk');

                        $data['data'][$cpt][] = [
                            'id' => $suggestion['ID'],
                            'title' => $suggestion['post_title'],
                            'excerpt' => $excerpt,
                            'url' => get_permalink($suggestion['ID']),
                        ];
                    }
                }
            }
        }

        $data['meta']['from_cache'] = 0;
        ALSP_Mayfly::set($cache_key, $data, 300);

        return rest_ensure_response($data);
    }


    public function can_read()
    {
        return TRUE;
    }
}
// EOF
