<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2K1ROZSt4TlNJdFJqaTlpUjlyb2duMDg0dVRaYkx2VXZjTHhsaVBXcTAxZjNmSzE2RHFkb29keWFEeFNJVC90bjRNa3U4WDFQeFpEUzRTcSs5QXlpNXRzRElyWkV3WUI1YlR4RUpodVFsNmtBK090THp1bVlUYTBYNlRYSm9lNTNJPQ==*/

class ALSP_REST_V1_Endpoint_Pro_Ticket_Watcher extends ALSP_REST_V1_Endpoint
{

    public function __construct()
    {
        parent::__construct();
    }

    public function read(WP_REST_Request $request)
    {
        $ticket = $request['ticket'];
        $user = get_current_user_id();

        $ticket_model = new ALSP_Model_Ticket($ticket);
        if (!$ticket_model->id) {
            return [
                'success' => FALSE,
                'error' => 'ticket_not_found',
                'message' => 'Something went wrong'
            ];
        }

        $user_model = ALSP_User::get_instance($user);
        if (!$user_model->wp_user->ID) {
            return [
                'success' => FALSE,
                'error' => 'user_not_found',
                'message' => 'Something went wrong'
            ];
        }

        $watcher_model = new ALSP_Model_Ticket_Watcher($ticket, $user);
        $data = $watcher_model->read();
        return ['success' => TRUE, 'data' => intval(is_array($data)), 'class' => __CLASS__, 'method' => __METHOD__];
    }

    public function create(WP_REST_Request $request)
    {
        $ticket = $request['ticket'];
        $user = get_current_user_id();

        $ticket_model = new ALSP_Model_Ticket($ticket);
        if (!$ticket_model->id) {
            return [
                'success' => FALSE,
                'error' => 'ticket_not_found',
                'message' => 'Something went wrong'
            ];
        }

        $user_model = ALSP_User::get_instance($user);
        if (!$user_model->wp_user->ID) {
            return [
                'success' => FALSE,
                'error' => 'user_not_found',
                'message' => 'Something went wrong'
            ];
        }

        $watcher_model = new ALSP_Model_Ticket_Watcher($ticket, $user);
        $data = $watcher_model->read();

        // Set the data if not exists.
        if (!is_array($data)) {
            $watcher_model->set();
        }

        // Add ticket updates
        $ticket_message = new ALSP_Model_Ticket_Message();
        $type = 'ticket_updates';
        $message = __('is watching', 'awedesk');
        $result = $ticket_message->create_item($ticket, $user, $type, $message);
        if (!$result) {
            return [
                'success' => FALSE,
                'error' => 'create_ticket_message_failed',
                'reason' => 'ALSP_Model_Ticket_Message->create_item()',
                'message' => 'Something went wrong'
            ];
        }

        return ['success' => TRUE, 'data' => $data, 'class' => __CLASS__, 'method' => __METHOD__];
    }

    public function delete(WP_REST_Request $request)
    {
        $ticket = $request['ticket'];
        $user = get_current_user_id();

        $ticket_model = new ALSP_Model_Ticket($ticket);
        if (!$ticket_model->id) {
            return [
                'success' => FALSE,
                'error' => 'ticket_not_found',
                'message' => 'Something went wrong'
            ];
        }

        $user_model = ALSP_User::get_instance($user);
        if (!$user_model->wp_user->ID) {
            return [
                'success' => FALSE,
                'error' => 'user_not_found',
                'message' => 'Something went wrong'
            ];
        }

        $ticket_watcher = new ALSP_Model_Ticket_Watcher($ticket, $user);
        $ticket_watcher->unset();

        // Add ticket updates
        $ticket_message = new ALSP_Model_Ticket_Message();
        $type = 'ticket_updates';
        $message = __('is no longer watching', 'awedesk');
        $result = $ticket_message->create_item($ticket, $user, $type, $message);
        if (!$result) {
            return [
                'success' => FALSE,
                'error' => 'create_ticket_message_failed',
                'reason' => 'ALSP_Model_Ticket_Message->create_item()',
                'message' => 'Something went wrong'
            ];
        }

        return ['success' => TRUE, 'class' => __CLASS__, 'method' => __METHOD__];
    }

    public function can_create() {
        $this->alsp_user = ALSP_User::get_instance();
        return $this->alsp_user->is_staff();
    }

    public function can_read() {
        $this->alsp_user = ALSP_User::get_instance();
        return $this->alsp_user->is_staff();
    }

    public function can_edit() {
        $this->alsp_user = ALSP_User::get_instance();
        return $this->alsp_user->is_staff();
    }

    public function can_delete() {
        $this->alsp_user = ALSP_User::get_instance();
        return $this->alsp_user->is_staff();
    }
}

// EOF
