<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2OTE4dEhKajhnNmo2SnJqVDFUOXFUUm1SNkZlcVpqOEpUaVJka0dKVTZ1TjlmUkQ1SUsxN0FnWkZyTGtDS1JHZ0VNL0phdTJZMmNlSUowVENQSUFhVUs2a0JqcklzMXBMMGpCemNkVVYxcGVCZW10L2l5M1Y4UlErMWcrSzFuZHEwPQ==*/

class ALSP_REST_V1_Endpoint_Register extends ALSP_REST_V1_Endpoint
{

    public function __construct()
    {
        parent::__construct();
    }

    public function create(WP_REST_Request $request)
    {
        $first_name = isset($request['first_name']) ? $request['first_name'] : '';
        $last_name = isset($request['last_name']) ? $request['last_name'] : '';
        $email = isset($request['email']) ? $request['email'] : '';
        $passwd = isset($request['passwd']) ? $request['passwd'] : '';
        $passwd_verify = isset($request['passwd_verify']) ? $request['passwd_verify'] : '';

        if (!$first_name) {
            return [
                'success' => FALSE,
                'error' => 'invalid_first_name',
                'message' => __('Invalid first name', 'awedesk'),
            ];
        }

        if (!$last_name) {
            return [
                'success' => FALSE,
                'error' => 'invalid_last_name',
                'message' => __('Invalid last name', 'awedesk'),
            ];
        }

        if (!$email || !is_email($email)) {
            return [
                'success' => FALSE,
                'error' => 'invalid_email_address',
                'message' => __('Invalid email', 'awedesk'),
            ];
        }

        $id = get_user_by('email', $email);
        if (FALSE !== $id) {
            return [
                'success' => FALSE,
                'error' => 'email_already_registered',
                'message' => __('This email is already in use', 'awedesk'),
            ];
        }

        if (!$passwd) {
            return [
                'success' => FALSE,
                'error' => 'invalid_password',
                'message' => __('Invalid password', 'awedesk'),
            ];
        }

        if ($passwd !== $passwd_verify) {
            return [
                'success' => FALSE,
                'error' => 'passwordd_do_not_match',
                'message' => __('Password & verification don\'t match', 'awedesk'),
            ];
        }

        // Create user based on email if it's not registered
        $user_login = ALSP_Utility_String::strip_domain_from_email(sanitize_user($email));
        $user_login = ALSP_User::check_unique_username($user_login);
        $user_email = sanitize_email($email);

		// create the peepso_users table record
		$data = [
			'user_login' 		=> $user_login,
			'user_pass' 		=> $passwd,
			'user_email' 		=> $email,
			'first_name' 		=> $first_name,
			'last_name' 		=> $last_name,
			'user_registered' 	=> current_time('mysql'),
		];

        $user_id = wp_insert_user($data);
        if (is_wp_error($user_id)) {
            return [
                'success' => FALSE,
                'error' => 'failed_register_new_user',
                'reason' => 'register_new_user()',
                'message' => $user_id->get_error_message(),
            ];
        }

        $new_user = ALSP_User::get_instance($user_id);
        return $new_user->get_details();
    }

    public function can_create()
    {
        // valid for guest only
        return !get_current_user_id();
    }
}

// EOF
