<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2K0U1YW5CbkhFT3RsT0lKSnorOTJObXJhWDlZZUhHUDh1SWVpUDlGK1lWOVdhNkJ5SDcxdlBleHcyR2Y4dVJSQ0lWenY5UlBkbzVRd0ZpbU5WRFd0STdRQ0xtZnFNV2Q1ZWdCWlcxaUZ0aStnY0djS2hWNlMxQkpYZWRTOTZnNFMwPQ==*/ /*QW9Weng5ayt0UStQZ2dZRWxzTXVFbnBSUXdndVppUk16NEdrcGpMVUJzVEtwc0VSOWNiQU9vV0JhdDFWVzMyQXhmNlRtVFJmaFp6MVd5Yy9BbU1RR3dOcnFmWW5uK1RCTk5PVVRXQXRxUG1jSUYrQjFyMGd1aE4yaUt2RUxMVUpSU3NQM1pXSWVxcU1vR3lDQnl3SXFTY1NrNEZoLzhkRzJCa0xKMnJWSjJnPQ==*/

class ALSP_REST_V1_Endpoint_Ticket_Author extends ALSP_REST_V1_Endpoint
{

    public function __construct()
    {
        parent::__construct();
    }

    public function read(WP_REST_Request $request)
    {
        $client_id = isset($request['id']) ? $request['id'] : FALSE;
        if (!$client_id) {
            return [
                'success' => FALSE,
                'error' => 'missing_mandatory_fields',
                'message' => __('Missing mandatory fields', 'awedesk'),
            ];
        }

        $client = ALSP_User::get_instance($client_id);
        if (!$client->wp_user->ID) {
            return [
                'success' => FALSE,
                'error' => 'invalid_client',
                'message' => 'Something went wrong'
            ];
        }

        if($request['agent']) {
            $total = ALSP_Model_tickets::get_total_tickets_by_agent_and_status($client->wp_user->ID, []);
            $total_open = ALSP_Model_tickets::get_total_tickets_by_agent_and_status($client->wp_user->ID, ['new', 'client', 'agent', 'agent_escalated', 'agent_hold']);
            $total_closed = ALSP_Model_tickets::get_total_tickets_by_agent_and_status($client->wp_user->ID, ['closed']);
        } else {
            $total = ALSP_Model_tickets::get_total_tickets_by_client_and_status($client->wp_user->ID, []);
            $total_open = ALSP_Model_tickets::get_total_tickets_by_client_and_status($client->wp_user->ID, ['new', 'client', 'agent', 'agent_escalated', 'agent_hold']);
            $total_closed = ALSP_Model_tickets::get_total_tickets_by_client_and_status($client->wp_user->ID, ['closed']);
        }




        $count = $limit = 10;
        $request = new WP_REST_Request();
        $request['client'] = $client->wp_user->ID;
        $request['list'] = 'open';
        $request['page'] = 1;
        $request['per_page'] = $limit;

        $list_tickets = (new ALSP_Model_Tickets($request))->read();
        $list_tickets = array_merge($list_tickets, ALSP_Model_Tickets::get_tickets_by_client_and_status($client->wp_user->ID, ['closed'], $limit));
        $list_tickets = array_slice($list_tickets, 0, $limit);

        $count = count($list_tickets);

        $date_format = ALSP_Utility_WP::get_option('date_format');
        $data = [
            'id' => $client->wp_user->ID,
            'name' => $client->wp_user->display_name,
            'avatar' => get_avatar_url($client->wp_user->ID),
            'email' => $client->wp_user->user_email,
            'url' => $client->wp_user->user_url,
            'count' => $count,
            'registered' => date_i18n($date_format, strtotime($client->wp_user->user_registered)),
            'statistics' => [
                'total' => $total,
                'open' => $total_open,
                'closed' => $total_closed,
            ],
            'tickets' => $list_tickets
        ];


        $request = new WP_REST_Request;
        $request['list'] = 'watched';
        $data['statistics']['watched'] = (new ALSP_Model_Tickets($request))->count();


        return ['success' => TRUE, 'data' => $data, 'class' => __CLASS__, 'method' => __METHOD__];
    }

    public function can_read()
    {
        return get_current_user_id() > 0;
    }
}

// EOF
