<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2L2tob2N3cjVONCtVOCtSU2JzYWVtN1hpTGFwVlRib2wreUVqd3MwUUJaTXA4bXEyN09JTmIwWkZZS2phaE9qd2l4S0RGOEpVaW9CMitkQTBVYVBiOWQ2dkRYWEVTaDlqWlhxL3VEK2lkSUlHUlMzU2pjdmVMeTVRaVVZQStWSXU4PQ==*/

class ALSP_REST_V1_Endpoint_Ticket_Lock extends ALSP_REST_V1_Endpoint
{

    public function __construct()
    {
        parent::__construct();
    }

    public function read(WP_REST_Request $request)
    {
        $lock = 0;
        $agent = NULL;

        $ticket = $request['ticket'];
        $ticket_model = new ALSP_Model_Ticket($ticket);
        if (!$ticket_model->id) {
            return [
                'success' => FALSE,
                'error' => 'ticket_not_found',
                'message' => 'Something went wrong'
            ];
        }

        $data = ALSP_Model_Ticket_Lock::read($ticket);

        return ['success' => TRUE, 'data' => $data, 'class' => __CLASS__, 'method' => __METHOD__];
    }

    public function create(WP_REST_Request $request)
    {
        $ticket = $request['ticket'];
        $author = isset($request['author']) ? $request['author'] : get_current_user_id();
        $force = isset($request['force']) ? TRUE : FALSE;

        $ticket_model = new ALSP_Model_Ticket($ticket);
        if (!$ticket_model->id) {
            return [
                'success' => FALSE,
                'error' => 'ticket_not_found',
                'message' => 'Something went wrong'
            ];
        }

        $author_model = ALSP_User::get_instance($author);
        if (!$author_model->wp_user->ID) {
            return [
                'success' => FALSE,
                'error' => 'author_not_found',
                'message' => 'Something went wrong'
            ];
        }

        $data = ALSP_Model_Ticket_Lock::read($ticket);
        if ($data['lock'] && !empty($data['lock_agent'])) {
            if ($data['lock_agent']['id'] != $author && !$force) {
                return [
                    'success' => FALSE,
                    'error' => 'ticket_locked_by_another_agent',
                    'message' => __('Another agent is currently editing the ticket', 'awedesk'),
                ];
            }
        }

        $data = ALSP_Model_Ticket_Lock::set($ticket, $author);

        return ['success' => TRUE, 'data' => $data, 'class' => __CLASS__, 'method' => __METHOD__];
    }

    public function delete(WP_REST_Request $request)
    {
        $ticket = $request['ticket'];

        $ticket_model = new ALSP_Model_Ticket($ticket);
        if (!$ticket_model->id) {
            return [
                'success' => FALSE,
                'error' => 'ticket_not_found',
                'message' => 'Something went wrong'
            ];
        }

        $data = ALSP_Model_Ticket_Lock::unset($ticket);

        return ['success' => TRUE, 'class' => __CLASS__, 'method' => __METHOD__];
    }

    public function can_read()
    {
        $this->wpuser = wp_get_current_user();
        return $this->wpuser->has_cap('alsp_lock_ticket');
    }

    public function can_create()
    {
        $this->wpuser = wp_get_current_user();
        return $this->wpuser->has_cap('alsp_lock_ticket');
    }

    public function can_delete()
    {
        $this->wpuser = wp_get_current_user();
        return $this->wpuser->has_cap('alsp_lock_ticket');
    }
}

// EOF
