<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2OVN6Nm9LL2JXMnpuMEVHckxKRVhqWmFzNzM5SW5TOXNXRWFvb0hGWjVpd29CdVh6Z1NMTmdtVzgvbHF2Uno0Z2tQL3FRdUE0UXRNeHlzM2VxN2N6YVF4RmNiQy90ZXRiRWZTR3h1K1ZselRuM2Ivayt0RHB1aldHd3lIYVhjdDlrPQ==*/
class ALSP_REST_V1_Endpoint_Tickets_Count extends ALSP_REST_V1_Endpoint
{
    public function __construct()
    {
        parent::__construct();
    }

    public function read(WP_REST_Request $request)
    {
        $this->model = new ALSP_Model_Tickets($request);
        $this->init($request);
        $total = NULL;

        $list_all = ['mine', 'watched', 'open', 'new', 'pending',  'answered', 'closed', 'deleted', 'recent'];
        if ($this->request['list'] === 'all') {
            $lists = $list_all;
        } else {
            $lists = array_values(array_intersect($list_all, explode(',', $this->request['list'])));
        }

        if (count($lists) > 1) {
            foreach($lists as $list) {
                $this->request['list'] = $list;
                $total[$list] = $this->model->count();
            }
        } else {
            $this->request['list'] = $lists[0];
            $total = $this->model->count();
        }

        return [
            'success' => TRUE,
            'data' => $total,
        ];
    }

    public function can_read()
    {
        $can_access = FALSE;
        //@TODO: somehow like $this->request not always return a valid value,
        // since the WP REST API expected to run twice [https://github.com/WP-API/WP-API/issues/2400].
        // We need to get directly from the $_GET param.
        $id = isset($_GET['id']) ? $_GET['id'] : FALSE;
        $this->wpuser = wp_get_current_user();
        $this->alsp_user = ALSP_User::get_instance();

        if (!$id) {
            $can_access = $this->wpuser->has_cap('alsp_list_ticket');
        } else {
            $can_access = $this->wpuser->has_cap('alsp_view_ticket');
        }

        if ($this->alsp_user->is_client() && $id) {
            $ticket_model = new ALSP_Model_Ticket($id);
            if (!$ticket_model->id) {
                $can_access = FALSE;
            } else {
                $ticket_data = $ticket_model->get_item();
                if (intval($ticket_data['client']['id']) !== $this->wpuser->ID) {
                    $can_access = FALSE;
                }
            }
        }

        return $can_access;
    }
}

// EOF
