<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2K1RkeUJzYURueDlWRHdlVC9nV0Vkd1VNUENMU2JIYlNrYkJyVHFCbGxJNkRIM0VXR1I0Tmw4bWFKYmVzakxXSXVqVVpoNENPU3c1MmJkdjRGS0R0bG5ROUl0d3RudVViakxDNSt2LzJ4blNBPT0=*/

class ALSP_REST_V1_Endpoint_Users extends ALSP_REST_V1_Endpoint
{
    public function __construct()
    {
        parent::__construct();
    }

    public function read(WP_REST_Request $request)
    {
        $search = isset($request['search']) ? sanitize_text_field($request['search']) : '';
        $number = isset($request['per_page']) ? (int) $request['per_page'] : null;
        $exclude = isset($request['exclude']) ? $request['exclude'] : null;

        if ($exclude) {
            $exclude = is_array($exclude) ? $exclude : [$exclude];
            $exclude = array_filter(array_map('intval', $exclude), 'is_int');
        }

        $query = new WP_User_Query([
            'search' => '*' . $search . '*',
            'number' => $number,
            'exclude' => $exclude,
            'fields' => ['ID', 'display_name', 'user_email']
        ]);

        $this->items = array_map(function($user) {
            return [
                'id' => $user->ID,
                'name' => $user->display_name,
                'email' => $user->user_email
            ];
        }, $query->get_results());

        return $this->items_to_response();
    }

    public function can_read()
    {
        return current_user_can('administrator') || ALSP_User::get_instance()->is_staff();
    }
}

// EOF
