# Basic information

The PHP code is intended for AweDesk instances and is triggered only if `AWEDESK_CLIENT` is defined and the user ID is not 1.

So even if it's installed on `source.awedesk.com`, nothing changes for the main admin account.

But after deployment a new admin is created and the rule applies to them and all other users created afterwards.

# What it does

- We completely remove all items from the admin sidebar and the admin bar
- We then hide them with CSS
- Access to any URL that is not Almighty is blocked
- It modifies some aspects of the ALSP configuration
  - Changes the logo and menu items in the top bar
  - Modifies configuration to hide things that are irrelevant (cron config, licensing, integrations)


## .htaccess
Ensure that the root of the config panel, so `/` or `/index.php` loads the ALSP config instead:

```
<IfModule mod_rewrite.c>
    RewriteEngine On
    RewriteBase /
    RewriteRule ^wp-admin/$ /wp-admin/admin.php?page=alsp [L,QSA]
    RewriteRule ^wp-admin/index.php$ /wp-admin/admin.php?page=alsp [L,QSA]
</IfModule>
```

