<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2K3YvSWw2UGRGb2QrNEFWdE1mQ3FpZlJGVUtiT1hCOVBWaFN5ZFZlSkFBL2N4RGg4QXMyK1h5YU5mRS9VRmFlYjl1QzgzaFB6MDZLNmZyR1o3NjVvQlJQa080MUNaR0tZT0NDZlhmU05qVmNmL09scXA4d0gwWUwrL24wU3JBdjQ0PQ==*/

class ALSP_System_Requirements
{

    const PHP_REQUIRED = '7.2.0';
    const PHP_RECOMMENDED = '8.0.0';

    public static function php()
    {

        $php_required = self::PHP_REQUIRED;
        $php_recommended = self::PHP_RECOMMENDED;
        $php_current = phpversion();

        // uncomment to emulate wrong php version
        //$php_current = '7.4.0';

        $allow_activation = TRUE;
        $message = '';

        // Check required PHP version
        if (-1 == version_compare($php_current, $php_required)) {
            $allow_activation = FALSE;
            $message = "<strong>Awedesk can't be activated!</strong> You are using <strong>PHP $php_current</strong> - Awedesk requires PHP $php_required, but <strong>we recommend at least PHP $php_recommended</strong>!";
        }

        // Check recommended PHP version
        if ($allow_activation) {
            if (-1 == version_compare($php_current, $php_recommended)) {
                $message = "You are using <strong>PHP $php_current</strong> - <strong>Awedesk recommends at least PHP $php_recommended</strong>!";
            }
        }

        // Admin notice rendering and dismissal
        self::admin_notices($message, $allow_activation);

        if (!$allow_activation) {

            if (!function_exists('deactivate_plugins')) {
                $admin_path = str_replace(get_site_url() . '/', ABSPATH, get_admin_url());
                @include_once($admin_path . 'includes/plugin.php');
            }

            if (function_exists('deactivate_plugins')) {
                deactivate_plugins(plugin_basename(__FILE__));
            }
        }

        return $allow_activation;
    }

    public static function admin_notices($message, $allow_activation)
    {

        // Admin notice dismiss mechanic
        $key = 'alsp_hide_php_warning_' . str_replace('.', '', ALSP_System_Requirements::PHP_RECOMMENDED);
        if (isset($_GET[$key])) {
            $set = (0 == $_GET[$key]) ? 0 : 1;
            update_user_option(get_current_user_id(), $key, $set);
        }

        add_filter('wp_ajax_' . $key, function () use ($key) {
            update_user_option(get_current_user_id(), $key, 1);
        });

        // Admin notice rendering
        if (strlen($message)) {

            add_action('admin_notices', function () use ($message, $allow_activation, $key) {

                if (!current_user_can('install_plugins')) {
                    return;
                }

                global $alsp_did_warn_php;
                if (true == $alsp_did_warn_php)
                    return;
                $alsp_did_warn_php = TRUE;

                $dismissed = get_user_option($key, get_current_user_id());
                if ($dismissed)
                    return;
                ?>
                <div class="alert error" id="alsp_php_warning">
                    <div>
                        <h1>Read carefully - your website might be in danger!</h1>
                        <?php echo $message; ?><br /><br />
                        Please update your PHP version for better performance and security. <strong>Old PHP versions can be vulnerable to
                            attacks!</strong><br />

                        <?php if ($allow_activation) { ?>
                            <br>
                            <a href="#" id="alsp_dismiss_php_warning">Dismiss, I love living dangerously!</a>
                        <?php } ?>
                    </div>
                </div>
                <script>
                    setTimeout(function () {
                        if (! typeof jQuery) return;
                        var $warning = jQuery('#alsp_php_warning');
                        var $dismiss = jQuery('#alsp_dismiss_php_warning');
                        $dismiss.on('click', function (e) {
                            e.preventDefault();
                            $warning.hide();
                            jQuery.post({ url: ajaxurl, data: { action: '<?php echo $key; ?>' } });
                        });
                    }, 0);
                </script>
                <?php
            }, -900);

        }
    }
}

// EOF
