<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2ODJkQU9uM0ttZDFsMERJeFJWYWtaM1pxUExSQnRmTzZ1Vkx6VjRSUHNWb2x2cHdzNkZZdzJ3VjdEMTYzeEp0ZlA5YWc5cEozWUZqOThWK25nTzFCS0NBKzIrWnE1TG5qSzgvZE1TQVpKSHVQbHV2VEZFdU50UTE3blJVZkoyaUlBPQ==*/

class ALSP_Config_Advanced
{
    private static $instance;

    public static function get_instance()
    {
        return isset(self::$instance) ? self::$instance : self::$instance = new self;
    }

    private function __construct()
    {
        add_filter('alsp_config_menu', function ($menu) {
            $menu['advanced'] = [
                'id' => 'advanced',
                'label' => __('Advanced', 'awedesk'),
                'icon' => 'alsp-i-gears',
            ];

            return $menu;
        }, 90);

        add_filter('alsp_config_description', function ($desc) {

            //$desc['cron_autoclosed_interval_number'] = __('Interval in days for ticket inactivity to be automatically closed.', 'awedesk');
            $docs = ''; //'<br/><a href="https://peep.so/docs_cron" target="_blank">' . __('Documentation', 'awedesk') . '</a>';
            $descript = __('Disabled: use WP cron. Enabled: use external cron.', 'awedesk') . $docs;
            $desc['cron_mailqueue_enabled'] = $descript;
            $desc['cron_autoclosed_ticket_enabled'] = $descript;
            $desc['cron_needs_attention_ticket_enabled'] = $descript;
            $desc['cron_remove_private_notes_ticket_enabled'] = $descript;
            $desc['cron_empty_trash_enabled'] = $descript;

            $desc['on_behalf_enabled'] = __('Allows opening tickets "as client" by staff members', 'awedesk');
            $desc['on_behalf_roles_select'] = __('Who is allowed to create tickets on behalf of the clients','awedesk');
            $desc['on_behalf_register_role_select'] = __('Who is allowed to create new clients when submitting a ticket - if a valid email is provided and not found in the clients database','awedesk');
            $desc['debug_enabled'] = __('Used only for debugging, recommended to keep disabled', 'awedesk');
            $desc['loadmore_select'] = __('Controls automatic infinite loading of items. When disabled, a "load more" button needs to be clicked.', 'awedesk');
            $desc['loadmore_repeat_select'] = __('Disabled: after clicking "load more", items are loaded with an infinite scroll. Enabled: the "load more" button repeats after a determined batch is loaded.', 'awedesk');

            return $desc;
        });

        add_action('alsp_config', function ($config, $position) {
            if (!in_array($position, ['advanced-right', 'advanced-left'])) {
                return $config;
            }
            if(!apply_filters('awecloud_is_client', FALSE)) {
                $cron_interval = apply_filters('alsp_cron_interval_config', [
                    'cron_autoclosed_interval_number' => ALSP_Config_Panel::admin_item(
                        'cron_autoclosed_interval_number',
                        FALSE,
                        __('Auto-Close after', 'awedesk'),
                        ['min' => 1, 'max' => 365, 'after' => __('days', 'awedesk')],
                    ),
                    'cron_auto_delete_from_trash_interval_number' => ALSP_Config_Panel::admin_item(
                        'cron_auto_delete_from_trash_interval_number',
                        FALSE,
                        __('Delete from Trash after', 'awedesk'),
                        ['min' => 1, 'max' => 365, 'after' => __('days', 'awedesk')],
                    ),
                ]);

                $config['cron'] = [
                    'id' => 'cron',
                    'title' => __('Cron', 'awedesk'),
                    'icon' => 'alsp-i-refresh',
                    'position' => 'advanced-left',
                    'items' => array_merge($cron_interval, [
//                    'cron_needs_attention_interval_number' => ALSP_Config_Panel::admin_item(
//                        'cron_needs_attention_interval_number',
//                        FALSE,
//                        __('Set "needs attention" after', 'awedesk'),
//                        ['min' => 1, 'max' => 365, 'after' => __('days', 'awedesk')],
//                    ),
                        'cron_external_separator' => ALSP_Config_Panel::admin_item('cron_external_separator', FALSE, __('External Cron', 'awedesk')),
                        'cron_mailqueue_enabled' => ALSP_Config_Panel::admin_item('cron_mailqueue_enabled', FALSE, __('Mail Queue', 'awedesk')),
                        'cron_autoclosed_ticket_enabled' => ALSP_Config_Panel::admin_item('cron_autoclosed_ticket_enabled', FALSE, __('Auto-Close', 'awedesk')),
                        'cron_remove_private_notes_ticket_enabled' => ALSP_Config_Panel::admin_item('cron_remove_private_notes_ticket_enabled', FALSE, __('Private Notes', 'awedesk')),
                        'cron_empty_trash_enabled' => ALSP_Config_Panel::admin_item('cron_empty_trash_enabled', FALSE, __('Empty Trash', 'awedesk')),
                    ]),
                ];
            }

            $pro = apply_filters('alsp_is_pro', FALSE) ? '' : ALSP::pro_marker();
            $config['attachment'] = [
                'id' => 'attachment',
                'title' => __('Attachments', 'awedesk').$pro,
                'icon' => 'alsp-i-clip',
                'position' => 'advanced-left',
                'items' => [
                    'pro_attachments_enabled' => ALSP_Config_Panel::admin_item('pro_attachments_enabled', FALSE, __('Enabled', 'awedesk')),
                ],
            ];

            // Infinite scroll
            $options_load_more = [
                0 => __('Never', 'awedesk'),
                1 => __('Always', 'awedesk'),
                2 => __('Mobile', 'awedesk'),
                3 => __('Desktop', 'awedesk'),
            ];

            $options_repeat = [];
            for ($i = 0; $i <= 50; $i += 2) {
                $options_repeat[$i] = sprintf(__('Every %d items', 'awedesk'), $i);
                if ($i == 0) {
                    $options_repeat[$i] = __('No', 'awedesk');
                }
            }


            $options_roles = [
                '1' => __('Administrator','awedesk'),
                '2' => __('Manager','awedesk').' & '.__('Administrator','awedesk'),
                '3' => __('Agent','awedesk').', '.__('Manager','awedesk').' & '.__('Administrator','awedesk'),
            ];

            $config['on_behalf'] = [
                'id' => 'on_behalf',
                'title' => __('On Behalf', 'awedesk'),
                'icon' => 'alsp-i-comment-alt',
                'position' => 'advanced-right',
                'items' => [
                    // separate_support_page_enabled support_page_client_select
                    'on_behalf_enabled' => ALSP_Config_Panel::admin_item('on_behalf_enabled', FALSE),
                    'on_behalf_roles_select' => ALSP_Config_Panel::admin_item('on_behalf_roles_select', 'on_behalf_enabled',_n('Role', 'Roles', 2, 'awedesk'),['options' => $options_roles]),
                    'on_behalf_client_separator' => ALSP_Config_Panel::admin_item('on_behalf_client_separator', 'on_behalf_enabled',__('Create accounts', 'awedesk')),
                    'on_behalf_register_role_select' => ALSP_Config_Panel::admin_item('on_behalf_register_role_select', 'on_behalf_enabled',_n('Role', 'Roles', 2, 'awedesk'),['options' => $options_roles]),
                ],
            ];

            $config['performance'] = [
                'id' => 'performance',
                'title' => __('Performance', 'awedesk'),
                'icon' => 'alsp-i-dashboard',
                'position' => 'advanced-right',
                'items' => [
                    'chars_limit_separator' => ALSP_Config_Panel::admin_item('chars_limit_separator', FALSE, __('Length limits', 'awedesk')),
                    'chars_limit_subject_number' => ALSP_Config_Panel::admin_item(
                        'chars_limit_subject_number',
                        FALSE,
                        __('Subject', 'awedesk'),
                        ['min' => 10, 'max' => 255, 'after' => __('characters', 'awedesk')] // Based on varchar-type maxlength on database.
                    ),
                    'chars_limit_content_number' => ALSP_Config_Panel::admin_item(
                        'chars_limit_content_number',
                        FALSE,
                        __('Body', 'awedesk'),
                        ['min' => 100, 'max' => 65000, 'after' => __('characters', 'awedesk')] // Based on varchar-type maxlength on database.
                    ),
                    'loadmore_separator' => ALSP_Config_Panel::admin_item('loadmore_separator', FALSE, __('Infinite scroll', 'awedesk')),
                    'loadmore_select' => ALSP_Config_Panel::admin_item(
                        'loadmore_select',
                        FALSE,
                        __('Prefer a "load more" button', 'awedesk'),
                        ['options' => apply_filters('alsp_loadmore_select', $options_load_more)]
                    ),

                    'loadmore_repeat_select' => ALSP_Config_Panel::admin_item(
                        'loadmore_repeat_select',
                        'loadmore_select',
                        __('Repeat', 'awedesk'),
                        ['options' => apply_filters('alsp_loadmore_repeat_select', $options_repeat)]
                    ),
                ],
            ];
            if(!apply_filters('awecloud_is_client', FALSE)) {
                $config['advanced'] = [
                    'id' => 'general',
                    'title' => __('Debugging', 'awedesk'),
                    'icon' => 'alsp-i-terminal',
                    'position' => 'advanced-right',
                    'items' => [
                        'debug_enabled' => ALSP_Config_Panel::admin_item('debug_enabled', FALSE, __('Debug log', 'awedesk')),
                    ],
                ];
            }

            return $config;
        }, 20, 2);
    }
}

ALSP_Config_Advanced::get_instance();

// EOF
