<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2OUhaUk5hTUZUL2EzZ1ZGYjVPUGFjV2dtSmNUbDNzV3VpSHJtUmxVc2FycVYyZGJLcjlTWmpRaklJN25mVTRGbmR6enN6UHo0RXBXUmsrL3NuaURLbDhiekJadUNsMVZmd0QyazIvUmFxeitjZ3dQRk5WT1BWSDE5VDRjcVh4Ym5ZPQ==*/

class ALSP_Config_Email
{
    private static $instance;

    public static function get_instance()
    {
        return isset(self::$instance) ? self::$instance : self::$instance = new self;
    }

    private function __construct()
    {
        if (is_admin()) {
            add_action('admin_init', function () {
                if (0 == ALSP_Config::get('cron_mailqueue_enabled')) {
                    if (!stristr(json_encode(_get_cron_array()), ALSP::CRON_MAILQUEUE)) {
                        add_action('admin_notices',[$this, 'mailqueue_notice']);
                    }
                }
            });
        }

        add_action('wp_ajax_alsp_preview_email', function () {
            $override = ALSP_Config::get('emails_override_entire_html_template', '');
            if (strlen($override)) {
                echo stripslashes($override);
            } else {
                // load the general email template
                $assets = ALSP_Frontend_Assets::get_instance();
                echo $assets->get_template('general/email', []);
            }
            die();
        });

        add_filter('alsp_config_menu', function ($menu) {
            $menu['emails'] = [
                'id' => 'emails',
                'label' => __('Emails', 'awedesk'),
                'icon' => 'alsp-i-envelope',
            ];

            return $menu;
        }, 20);

        add_filter('alsp_config_description', function ($desc) {
            $desc['site_emails_sender_label'] = '';
            $desc['site_emails_admin_email_label'] = '';

            $override_html_template_desc = __('Text, HTML and inline CSS only (no PHP or shortcodes). Leave empty for the default layout.', 'awedesk')
                . '<br/><br/>'
                . sprintf(__('<a href="%s" target="_blank">Click here</a> after saving to test your changes.', 'awedesk'), admin_url('admin-ajax.php?action=alsp_preview_email'))
                . '<br/><br/>' .
                sprintf(__('Variables: %s','awedesk'), '<br/>{email_contents} *<br/>{email_footer} *<br/>{recipient_name}<br>{recipient_email}<br/>{site_name}<br/>{site_url}');

            $desc['emails_override_entire_html_template'] = $override_html_template_desc;

            return $desc;
        });

        add_filter('alsp_validate_field', function($valid, $name, $value){
            if ($name != 'emails_override_entire_html_template') {
                return $valid;
            }

            // Possibility empty value of HTML template
            if (strlen($value) === 0) {
                return $valid;
            }

            if (strpos($value, '{email_contents}') === FALSE) {
                return new WP_Error( 'alsp-config', 'Missing {email_contents}' );
            }

            if (strpos($value, '{email_footer}') === FALSE) {
                return new WP_Error( 'alsp-config','Missing {email_footer} was missing.');
            }

            return $valid;
        }, 10, 3);

        add_filter('alsp_config', function ($config, $position) {
            if ($position !== 'emails-left' && $position !== 'emails-right') {
                return $config;
            }

			// LEFT
	        $items = $items_advanced = [];
            $items['site_emails_sender_label'] = ALSP_Config_Panel::admin_item('site_emails_sender_label', FALSE, sprintf(__('From: %s', 'awedesk'),__('Name', 'awedesk')));
            $items['site_emails_admin_email_label'] = ALSP_Config_Panel::admin_item('site_emails_admin_email_label', FALSE, sprintf(__('From: %s', 'awedesk'),__('Email', 'awedesk')));

            $items_advanced['emails_override_entire_html_template'] = ALSP_Config_Panel::admin_item('emails_override_entire_html_template', FALSE, __('HTML template override', 'awedesk'));

            $config['emails'] = [
                'id' => 'emails',
                'title' => __('General', 'awedesk'),
                'icon' => 'alsp-i-settings-sliders',
                'position' => 'emails-left',
                'items' => $items,
            ];

            $config['advanced'] = [
                'id' => 'emails-advanced',
                'title' => __('Advanced', 'awedesk'),
                'icon' => 'alsp-i-gears',
                'position' => 'emails-left',
                'items' => $items_advanced,
            ];



			// RIGHT
	        $items = [];

	        // $options = [];
	        // foreach ($levels as $value => $level) {
	        //     $options[$value] = $level['label'] . ' - ' . $level['desc'];
	        // }

	        // $items['emails_intensity_separator'] = ALSP_Config_Panel::admin_item('emails_intensity_separator', FALSE, __('Email notification intensity', 'awedesk'));
	        // $items['default_email_intensity_select'] = ALSP_Config_Panel::admin_item('default_email_intensity_select', FALSE, __('Default', 'awedesk'), ['options' => apply_filters('alsp_default_email_intensity_select', $options)]);

	        $email_type = [

                // CONFIG
                'tokens_separator' => __('Tokens', 'awedesk'),
                'email_signature' => '{signature}',
                'email_link' => '{link}',

                // TO CLIENT
                'client_separator' => __('Client', 'awedesk'),
                'email_submission_confirmation' => __('New Ticket', 'awedesk'),
                'email_agent_reply' => __('Ticket Reply', 'awedesk'),
                'email_ticket_reopened_agent' => __('Ticket Reopened', 'awedesk'),

                // TO AGENT
                'agent_separator' => __('Agent', 'awedesk'),
		        'email_new_ticket' => __('New Ticket', 'awedesk'),
		        'email_ticket_assigned' => __('Ticket Assigned', 'awedesk'),
		        'email_client_reply' => __('Ticket Reply', 'awedesk'),
                'email_ticket_needs_attention' => __('Ticket Needs Attention', 'awedesk'),
                'email_ticket_reopened_client' => __('Ticket Reopened', 'awedesk'),
                'email_ticket_private_notes' => __('Ticket Private Notes', 'awedesk'),

                // GLOBAL
                'everyone_separator' => __('Client & Agent', 'awedesk'),
                'email_ticket_closed' => __('Ticket Auto-Closed', 'awedesk'),
		        'email_ticket_closed_agent' => __('Ticket Closed by Agent', 'awedesk'),
		        'email_ticket_closed_client' => __('Ticket Closed by Client', 'awedesk'),


	        ];

	        foreach ($email_type as $key => $label) {

                if(stristr($key,'separator')) {
                    $items[$key] = ALSP_Config_Panel::admin_item($key, FALSE, $label);
                    continue;
                }

		        $items[$key . '_template'] = ALSP_Config_Panel::admin_item($key . '_template', FALSE, $label);
	        }

	        $config['emails-templates'] = [
		        'id' => 'emails',
		        'title' => __('Templates', 'awedesk'),
		        'icon' => 'alsp-i-envelope-open-text',
		        'position' => 'emails-right',
		        'items' => $items,
	        ];

            return $config;
        }, 10, 2);
    }

    public static function mailqueue_notice()
    {
        $result = FALSE;
        if (!wp_next_scheduled(ALSP::CRON_MAILQUEUE)) {
            $result = wp_schedule_event(current_time('timestamp', TRUE), 'five_minutes', ALSP::CRON_MAILQUEUE);
        }

        if (!$result || $result instanceof WP_Error) {
            echo '<div class="alsp-alert alsp-alert--error">' .
                 'Awedesk: "Mail Queue" cron encountered some problems and was re-initialized.<br><small>If you see this message repeatedly, there might be something wrong with your WordPress Cron. Consider deactivating and re-activating Awedesk or contacting Support.</small>'
                . '</strong></div>';
        }
    }
}

ALSP_Config_Email::get_instance();

// EOF
