<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2L1dHY0pJT0R2Z0dUQWNvU1Z4dEtsYWRFRVIxbkV2SE1nb2xzWlI2NG8wOURGQVdrVEhOQWtCVU9MdEtMMW9BWHJGUm5sUUxrd3ovb0kxR1VCNmdtRERidkJMSk10NURlTDRTOGZ4WSt3b1pLeHlZdklvenpBeGpxWjZOaEdnUmh3PQ==*/

class ALSP_Config_License
{
    private static $instance;

    public static function get_instance()
    {
        return isset(self::$instance) ? self::$instance : self::$instance = new self;
    }

    private function __construct()
    {

        if(apply_filters('awecloud_is_client', false)) {
            return;
        }

        add_filter('alsp_config_description', function ($desc) {
            $desc['license_legacy_enabled'] = __('Keep this option enabled if you purchased your license via AlmightySupport.com (before the Awedesk.com rebranding).', 'awedesk');
            return $desc;
        });

        add_filter('alsp_config_menu', function($menu){

            $menu['license'] = [
                'id' => 'license',
                'label' => __('License', 'awedesk'),
                'icon' => 'alsp-i-key',
            ];

            return $menu;
        }, 90);

        add_action('alsp_config', function ($config, $position) {
            if (!in_array($position, ['license-right', 'license-left'])) {
                return $config;
            }

            $config['license'] = [
                'id' => 'license',
                'position' => 'license-left',
                'html' => ALSP_Frontend_Assets::get_instance()->get_template('admin/config_group_license'),
            ];

            $config['license-advanced'] = [
                'id' => 'license-advanced',
                'title' => __('Advanced', 'awedesk'),
                'icon' => 'alsp-i-refresh',
                'position' => 'license-right',
                'items' => [
                    'license_legacy_enabled' => ALSP_Config_Panel::admin_item('license_legacy_enabled', FALSE, __('Legacy license', 'awedesk')),
                ]
            ];

            return $config;
        }, 20, 2);
    }
}
add_action('init', function() {
    if (apply_filters('alsp_is_pro', false)) {
        ALSP_Config_License::get_instance();
    }
});
// EOF
