<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2OVFFZy8wV3ZZOFJkUFdiSVlOSFp6TVpqeEgvd2FTODlwRjJqRjFuUGF5THFGSUlZazhrTXc3WVJVOEd0anhjS1NmNDFiYWp5cXV5c2Z6SGZydWEyaWR0cW41dVI3aHBNM0tmeDZDNTRGRXhLK0czd1kyWWZ1Zmp2cWE2WHVpVU80VDNvWXpRSis4T2g0WGgrVmJEcStx*/

class ALSP_Integrations_Free
{
    private static $instance = NULL;

    public static function get_instance()
    {
        return (NULL == self::$instance) ? self::$instance = new self() : self::$instance;
    }

    private function __construct()
    {
        // Generic integrations menu
        add_filter('alsp_config_menu', function ($menu) {
                if (apply_filters('awecloud_is_client', FALSE)) {
                    return $menu;
                }
                $menu['integrations'] = [
                    'id' => 'integrations',
                    'label' => __('Integrations', 'awedesk') . ALSP::pro_marker(),
                    'icon' => 'alsp-i-code-compare',
                ];

                return $menu;
            }, PHP_INT_MAX);

        add_filter('alsp_config', function ($config, $position) {

                if ($position == 'integrations-left') {

                    $config['integrations_edd'] = [
                        'id' => 'integrations_edd',
                        'title' => 'Easy Digital Downloads',
                        'icon' => 'alsp-i-code-compare',
                        'position' => 'integrations-left',
                        'items' => [
                            'pro_edd_integration_enabled' => ALSP_Config_Panel::admin_item('pro_edd_integration_enabled'),
                        ],
                    ];

                    $config['integrations_woo'] = [
                        'id' => 'integrations_woo',
                        'title' => 'WooCommerce',
                        'icon' => 'alsp-i-code-compare',
                        'position' => 'integrations-left',
                        'items' => [
                            'pro_woo_integration_enabled' => ALSP_Config_Panel::admin_item('pro_woo_integration_enabled'),
                        ],
                    ];
                }

                if ($position == 'integrations-right') {

                    $config['docs'] = [
                        'id' => 'docs',
                        'title' => __('Suggested content', 'awedesk'),
                        'icon' => 'alsp-i-folder-tree',
                        'position' => 'integrations-right',
                        'items' => [
                            'pro_docs_enabled' => ALSP_Config_Panel::admin_item('pro_docs_enabled'),
                        ],
                    ];

                    $config['slack'] = [
                        'id' => 'slack',
                        'title' => __('Slack', 'awedesk'),
                        'icon' => 'alsp-i-slack',
                        'position' => 'integrations-right',
                        'items' => [
                            'pro_slack_enabled' => ALSP_Config_Panel::admin_item('pro_slack_enabled'),
                        ],
                    ];
                }

                return $config;
            }, 30, 2);
    }

    // Get all CPTS enabled in ALSP config, ordered by position
    public function all_enabled($ensure = FALSE){

        $enabled_post_types = ALSP_Mayfly::get('all_enabled_cpts');

        if(NULL === $enabled_post_types) {

            $post_types = get_post_types(['public' => TRUE], 'objects');

            $enabled_post_types = [];

            foreach ($post_types as $post_type) {
                $cfg_enabled = 'docs_cpt_' . $post_type->name . '_enabled';
                $cfg_position = 'docs_cpt_' . $post_type->name . '_order_number';
                $cfg_label = 'docs_cpt_' . $post_type->name . '_label';
                // Check if this CPT is enabled and still registered
                if (ALSP_Config::get($cfg_enabled) && post_type_exists($post_type->name)) {
                    $enabled_post_types[$post_type->name] = [
                        'order' => (int)ALSP_Config::get($cfg_position, 0, TRUE),
                        'label' => ALSP_Config::get($cfg_label, $post_type->label, TRUE),
                    ];
                }
            }

            uasort($enabled_post_types, function ($a, $b) {
                return $a['order'] - $b['order'];
            });

            ALSP_Mayfly::set('all_enabled_cpts', $enabled_post_types,60);
        }

        if($ensure) {
            foreach($enabled_post_types as $cpt => $data) {
                if(!post_type_exists($cpt)) {
                    unset($enabled_post_types[$cpt]);
                }
            }
        }

        return $enabled_post_types;
    }
}

add_action('init', function() {
    if (!apply_filters('alsp_is_pro', false)) {
        ALSP_Integrations_Free::get_instance();
    }
});

// EOF
