<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2L25GTE5jRjgrTzZZK2dDWGxjUStUN3lLQ3ZjMnVBNEdmMlRZNHdJNFFsekJkYmlCWEZCc3lqWjIvM1lPbUhYcmV0OGdIVDNiSWtPU2RJT21xUXhMak91RjdpTG9nTnpmUm9oajFwejBQMnRZSmhSQ2E4eUVOb0FoS20vU0E1Nk1vPQ==*/

class ALSP_Config_Notes_Free
{
    private static $instance;

    public static function get_instance()
    {
        return isset(self::$instance) ? self::$instance : self::$instance = new self;
    }

    private function __construct()
    {
        add_filter('alsp_config_menu', function ($menu) {
            $menu['notes'] = [
                'id' => 'notes',
                'label' => __('Notes', 'awedesk').ALSP::pro_marker(),
                'icon' => 'alsp-i-signature-pencil',
            ];

            return $menu;
        }, PHP_INT_MAX);

        add_filter('alsp_config', function ($config, $position) {
            if ($position !== 'notes-left' && $position !== 'notes-right') {
                return $config;
            }

            // LEFT
            $items = [];
            $items['pro_secret_enabled'] = ALSP_Config_Panel::admin_item('pro_secret_enabled');

            $config['notes'] = [
                'id' => 'notes',
                'title' => __('Private Notes', 'awedesk'),
                'icon' => 'alsp-i-file-signature',
                'position' => 'notes-left',
                'items' => $items,
            ];

            // RIGHT
            $items = [];
            $items['pro_staff_notes_clients_enabled'] = ALSP_Config_Panel::admin_item('pro_staff_notes_clients_enabled',FALSE,__('Client', 'awedesk'));
            $items['pro_staff_notes_tickets_enabled'] = ALSP_Config_Panel::admin_item('pro_staff_notes_tickets_enabled', FALSE, __('Ticket', 'awedesk'));

            $config['notes-staff-client'] = [
                'id' => 'notes',
                'title' => __('Staff notes', 'awedesk'),
                'icon' => 'alsp-i-file-signature',
                'position' => 'notes-right',
                'items' => $items,
            ];

            return $config;
        }, 10, 2);
    }
}

add_action('init', function() {
    if (!apply_filters('alsp_is_pro', false)) {
        ALSP_Config_Notes_Free::get_instance();
    }
});
// EOF