<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2L0ovSmFJK0I3bktlZ1p4ajUvZ2FCdGl2WllTNm14SW9vTTRwVXpvdDFRN1lia1BxTER2QjNsQ09GWE10WElUdHU0bldnUDJkeG1kUkF3TXJiT2U0UHA5a1B1QmU3Q1VaUkZ3SS8yQ0M3OURFdGkwamlRVFZ6a3F4aWR0TjUxUE1rPQ==*/

class ALSP_Config_Signatures_Free
{
    private static $instance;

    public static function get_instance()
    {
        return isset(self::$instance) ? self::$instance : self::$instance = new self;
    }

    private function __construct()
    {
        add_filter('alsp_config_menu', function ($menu) {
            $menu['signatures'] = [
                'id' => 'signatures',
                'label' => __('Signatures', 'awedesk').ALSP::pro_marker(),
                'icon' => 'alsp-i-signature',
            ];

            return $menu;
        }, PHP_INT_MAX);

        add_filter('alsp_config_description', function ($desc) {
            $desc['signatures_tpl_message'] =
                __('Default signature is used if the staff member has no signature of their own.', 'awedesk')
                .'<br/>'
                .sprintf(__('Empty %s signature falls back to %s.', 'awedesk'),__('Administrator', 'awedesk'),__('Manager', 'awedesk'))
                .'<br/>'
                .sprintf(__('Empty %s signature falls back to %s.', 'awedesk'),__('Manager', 'awedesk'),__('Agent', 'awedesk'))
            ;
            return $desc;
        });

        add_filter('alsp_config', function ($config, $position) {
            if ($position !== 'signatures-left' && $position !== 'signatures-right') {
                return $config;
            }

            $items = [];
            $items['pro_signatures_enabled'] = ALSP_Config_Panel::admin_item('pro_signatures_enabled');

            $config['signatures'] = [
                'id' => 'signatures',
                'title' => __('General', 'awedesk'),
                'icon' => 'alsp-i-settings-sliders',
                'position' => 'signatures-left',
                'items' => $items,
            ];


            return $config;
        }, 10, 2);
    }
}

add_action('init', function() {
    if (!apply_filters('alsp_is_pro', false)) {
        ALSP_Config_Signatures_Free::get_instance();
    }
});