<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2L0Vxc3RJMFV1bDFOT0lxdmJBbXlzRVMxcmE5enUzNENacjhsREViUDRzVHRidlFHelJPUml6ZTJUTDFQNjZXeVdzdlkwdmtwQ0FEWWpranhKcUR4U0NwMTJlSlBYYVlYVmRvTmZ0QTBFWnNRPT0=*/

class ALSP_Pages
{

	private static $instance;

	public static function get_instance()
	{
		return isset(self::$instance) ? self::$instance : self::$instance = new self;
	}

	private function __construct()
	{
		// Rebuild cache if MayFly expired
		add_action('admin_init', function () {

			if(!ALSP_Mayfly::get('license_valid')) {
				return;
			}

			if (NULL === ALSP_Mayfly::get('pages') || 0 === intval(ALSP_Mayfly::get('pages'))) {
				$this->find_pages();
			}
		});

		add_action('admin_notices', function () {

			if(apply_filters('alsp_is_pro', FALSE)) {
				// Don't fire for Pro if license is not configured yet or any of the integrations is enabled
				if(!ALSP_Mayfly::get('license_valid')) { return; }
				// if(ALSP_Config::get('peepso_enabled')) { return; }
				// if(ALSP_Config::get('bb_enabled')) { return; }
				// if(ALSP_Config::get('woo_enabled')) { return; }
			}

			if (!is_array(ALSP_Mayfly::get('pages')) && ALSP_Mayfly::get('pages_did_check')) { ?>
				<div class="alert error"><div>
					<?php $content = [
						'intro' => '<b>Awedesk:</b> please <a target="_blank" href="' . admin_url('/post-new.php?post_type=page') . '">add a page</a> with an Awedesk <b>shortcode or block</b>.',
						'pro' => '',
						'outro' => '</div></div>',//<br/>For more details, please refer to the <a href="https://alsp.com/r/docs-getting-started" target="_blank">getting started guide</a>.
					];

					$content = apply_filters('alsp_getting_started', $content);

					echo implode(' ', $content);
			}
		});

		// Rebuild cache when any post is saved
		add_action('publish_page', function(){
			//new ALSP_Debug('publish_page]');
            ALSP_Pages::get_instance()->find_pages();
        });

		add_action('untrashed_post', function(){
			//new ALSP_Debug('untrashed_post');
			ALSP_Pages::get_instance()->find_pages();
		});
		add_action('trashed_post', function(){
			//new ALSP_Debug('trashed_post');
			ALSP_Pages::get_instance()->find_pages();
		});
		add_action('transition_post_status', function($new, $old, $post) {
            if($post->post_type != 'page') {
                return;
            }

			//new ALSP_Debug('transition_post_status');
            //new ALSP_Debug("$new $old ".$post->ID." ".$post->post_type );
			ALSP_Pages::get_instance()->find_pages();
		},10,3);

        // Or when configuration is modified
        add_action('alsp_config_set', function($name,$value){
            if(strstr($name, 'page_id_')) {
                //new ALSP_Debug('alsp_config_set');
	            ALSP_Pages::get_instance()->find_pages();
            }
        },10,2);
	}

	public function find_pages()
	{
		if(!ALSP_Mayfly::get('license_valid')) {
			return;
		}

		ALSP_Mayfly::del('pages');
		ALSP_Mayfly::del('pages_did_check');

		$pages = ALSP_Config::pages();
        //new ALSP_Debug(print_r($pages, true));

        // Make sure that the CLIENT URL is still available
		$page_id_client = ALSP_Config::get('support_page_client_select', -1);

        if(!array_key_exists($page_id_client, $pages)) {
	        //new ALSP_Debug( 'support_page_client_select 404' );
            if(count($pages)) {

	            $new_page_id_client = array_key_first( $pages );
	            //new ALSP_Debug('Setting to ' . $new_page_id_client);
	            ALSP_Config::set( 'support_page_client_select', $new_page_id_client );
            } else {
              //new ALSP_Debug('No replacement found!');
            }
        }

		// Make sure that the AGENT URL is still available
		$page_id_client = ALSP_Config::get('support_page_client_select', -1);
		$page_id_agent = ALSP_Config::get('support_page_agent_select', $page_id_client, TRUE);
		if(!array_key_exists($page_id_agent, $pages)) {
			//new ALSP_Debug('support_page_agent_select 404');
			//new ALSP_Debug('Setting to Client');
			ALSP_Config::set('support_page_agent_select', '');
		}

        if(!count($pages)) {
            $pages = 0;
        }

		ALSP_Mayfly::set('pages', $pages, 3600);
		ALSP_Mayfly::set('pages_did_check', time(), -1);
	}
}


ALSP_Pages::get_instance();

// EOF
