<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2L0k1U1VoRFhDUjhtaENrU2R4MDArZTRXS1ZsQS84WHJKWk9mbC9XSlJNdWt3S1kvUlRKREczVmF0NDRobTdnQ0xRUUxyZzQ3TUNhZGlpMWx5U1VzQnFjQUJreVdiZExVL1dhM2VIY3E2VkdZcDV4MVNpODJiUTk2cFZiTlRWV2dFPQ==*/

class ALSP_REST_V1_Endpoint_Admin_EP_Forwarder extends ALSP_REST_V1_Endpoint
{
    public function __construct()
    {
        parent::__construct();
    }

    public function create(WP_REST_Request $request)
    {
        $default_receiver = $request['receiver'] ?? '';
        $default_department = $request['department'] ?? '0';

        $multi_inbox = new ALSP_Model_Email_Piping_Forwarder();
        $result = $multi_inbox->create_item($default_receiver, $default_department);
        if (!$result) {
            return [
                'success' => FALSE,
                'error' => 'create_multi_inbox_failed',
                'reason' => 'ALSP_Model_Email_Piping_Forwarder->create_item()',
                'message' => 'Something went wrong'
            ];
        }

        $prefix = 'inboxes' . $result . '_';
        ALSP_Config::set($prefix . 'ep_multi_inbox_receiver_label', $default_receiver);
        ALSP_Config::set($prefix . 'ep_multi_inbox_default_department_select', $default_department);

        $options_departments = [
            ['value' => 0, 'title' => __('None', 'awedesk'), 'label' => __('None', 'awedesk')]
        ];

        $depts_model = new ALSP_Model_Departments($r = new WP_REST_Request());
        $departments = $depts_model->read(1);

        if (count($departments)) {
            foreach ($departments as $department) {
                $options_departments[] = [
                    'value' => $department['id'],
                    'title' => $department['name'],
                    'label' => $department['name']
                ];
            }
        }

        $items = [];
        $request = new WP_REST_Request;
        $forwarders = new ALSP_Model_Email_Piping_Forwarders($request);
        foreach ($forwarders->read() as $key => $forwarder) {
            if (!isset($forwarder['id']) && !$forwarder['id']) {
                continue;
            }

            if ($forwarder['id'] == $result) {
                $prefix = 'inboxes' . $forwarder['id'] . '_';
                $items[$prefix . 'ep_multi_inbox_default_department_separator'] = ALSP_Config_Panel::admin_item('ep_multi_inbox_default_department_separator', FALSE, FALSE);
                $items[$prefix . 'ep_multi_inbox_receiver_label'] = ALSP_Config_Panel::admin_item($prefix . 'ep_multi_inbox_receiver_label', FALSE, __('Ticket was received at', 'awedesk'));
                $items[$prefix . 'ep_multi_inbox_default_department_select'] = ALSP_Config_Panel::admin_item($prefix . 'ep_multi_inbox_default_department_select', FALSE, __('Default department', 'awedesk'), ['options' => $options_departments]);

                $btn_args = ['icon' => 'alsp-i-trash', 'btn_style' => 'delete', 'loading' => TRUE, 'data' => ['forwarder-id' => $forwarder['id']]];
                $items[$prefix . 'ep_multi_inbox_delete_button'] = ALSP_Config_Panel::admin_item($prefix . 'ep_multi_inbox_delete_button', FALSE, FALSE, $btn_args);
            }
        }

        return ['success' => TRUE, 'data' => $items, 'class' => __CLASS__, 'method' => __METHOD__];
    }

    public function delete(WP_REST_Request $request)
    {
        if ($request['id'] && $this->model = new ALSP_Model_Email_Piping_Forwarder($request['id'])) {
            $this->model->delete($request);
        }

        return ['success' => TRUE, 'class' => __CLASS__, 'method' => __METHOD__];
    }
}

// EOF