<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2K0plNzdEUEUxeDZRdStRdGZKVm8yRm52dFM3SUhMdVE0dUJYVmVJVEdSVnJON1M4VVJlQUxWN1BkakVEOTI3NEROS2YwUmdRM0FUMVZRNjlObmJCSmJGQmtIMGppMXd4Z2xJTXQxZnU2UC9Kd3Izci8zb0R5ZWtBNWZ0NmpIR3JRPQ==*/

class ALSP_REST_V1_Endpoint_Admin_EP_Gmail_Check extends ALSP_REST_V1_Endpoint
{
    public function __construct()
    {
        parent::__construct();
    }

    public function create(WP_REST_Request $request)
    {
        $email_address = ALSP_Config::get('ep_gmail_email_label');
        $client_id = ALSP_Config::get('ep_gmail_client_id_label');
        $client_secret = ALSP_Config::get('ep_gmail_client_secret_label');

        // initialize the connection.
        set_transient('alsp_ep_connection_init', 'yes', MINUTE_IN_SECONDS * 10);

        $email_address = sanitize_text_field(wp_unslash($email_address));
        if (!$email_address) {
            wp_send_json_error('Email Address should not be empty!', 400);
        }
        if (!filter_var($email_address, FILTER_VALIDATE_EMAIL)) {
            wp_send_json_error('Invalid email', 400);
        }
        $gmail['email-address'] = $email_address;

        $client_id = sanitize_text_field(wp_unslash($client_id));
        if (!$client_id) {
            wp_send_json_error('Client ID should not be empty!', 400);
        }
        $gmail['client-id'] = $client_id;

        $client_secret = sanitize_text_field(wp_unslash($client_secret));
        if (!$client_secret) {
            wp_send_json_error('Client Secret should not be empty!', 400);
        }
        $gmail['client-secret'] = $client_secret;

        // Google oAuth URL.
        $url = ALSP_Config_EP_Config_Connection_Checker::generate_gmail_auth_url($client_id);

        wp_send_json(['redirectURL' => esc_url_raw($url)], 200);
    }

    public function can_create()
    {
        return $this->alsp_user->is_admin();
    }
}

// EOF