<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2L3lzdldLZE1HZnliT0RsWHZmTE1HdXBhcDh2VnpiZWZyVHFQcU4yV3YxdzQwMHh3WlIzdy8vN0FxVUZ2aUM3Wi9qMm9YbTRzelBZb1c3OElPMFFteHcxSFBnRHNsczJBMDE0SFZiZEJsbi95TlRPbkd0V3RiN3FLYXJDb2RVcXhRPQ==*/

class ALSP_REST_V1_Endpoint_Admin_EP_Imap_Check extends ALSP_REST_V1_Endpoint
{
	public function __construct()
	{
		parent::__construct();
	}

	public function create(WP_REST_Request $request)
	{
		$incoming_mail_server = ALSP_Config::get('ep_imap_incoming_mail_server_label', 'ssl');
		$port = ALSP_Config::get('ep_imap_port_number');
		$email_address = ALSP_Config::get('ep_imap_email_label');
		$password = ALSP_Config::get('ep_imap_email_password');
		$encryption = ALSP_Config::get('ep_imap_encryption_select', 'ssl');
		if(!strlen($encryption)) $encryption = 'ssl';

		// initialize the connection.
		set_transient('alsp_ep_connection_init', 'yes', MINUTE_IN_SECONDS * 10);

		$encryption_text = '';
		if ($encryption == 'none') {
			$encryption_text = '/novalidate-cert';
		} elseif ($encryption == 'ssl') {
			$encryption_text = '/imap/ssl/novalidate-cert';
		} elseif ($encryption == 'tls') {
			$encryption_text = '/imap/tls/novalidate-cert';
		}

		$flag = true;
		if (!extension_loaded('imap')) {
			$flag = false;
			$error = '<strong>php-imap</strong> module not enabled on your server. Enable it from your cPanel or contact to your host provider.';
		}

		$user = get_user_by('email', $email_address);
		if ($flag && $user) {
			$flag = false;
			$error = 'Email account belong to registered user is not allowed.';
		}

		if ($flag) {
			$conn = @imap_open('{' . $incoming_mail_server . ':' . $port . $encryption_text . '}INBOX', $email_address, $password); // phpcs:ignore

			if (!$conn) {
				$flag = false;
				$error = imap_last_error();
			} else {
				$uids = imap_search($conn, 'ALL', SE_UID);
				$last_uid = $uids ? $uids[count($uids) - 1] : 0;
				ALSP_Config::set('ep_imap_uid', $last_uid);
			}
		}

		if (!$flag) {
			return [
				'success' => FALSE,
				'error' => 'imap_connection_failed',
				'reason' => 'imap_open()',
				'message' => $error,
			];
		}

		ALSP_Config::set('ep_imap_is_active', 1);
		delete_transient('alsp_ep_connection_init');

		return ['success' => TRUE, 'class' => __CLASS__, 'method' => __METHOD__];
	}

	public function can_create()
	{
		return $this->alsp_user->is_admin();
	}
}

// EOF
