<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2OURvV21zWDh1MG5kQnBLUEdzeXRCcXlKWHI1WXdHNE11ZVIvb0dhazhXSElkQlRZWjRkNityc200YVkxQWt2bDBNeDlDd2VUTWdHeHRqUkNyK0lFNFVPZ0V5M1A1WG1XbmdYcDdRWDNXUWhsRXAwZ083NzhuVHVtcWlEZGUzMU5jPQ==*/

class ALSP_REST_V1_Endpoint_Admin_EP_Me_Check extends ALSP_REST_V1_Endpoint
{
    public function __construct()
    {
        parent::__construct();
    }

    public function create(WP_REST_Request $request)
    {
        $client_id = ALSP_Config::get('ep_me_client_id_label');
        $client_secret = ALSP_Config::get('ep_me_client_secret_label');
        $tenant_id = ALSP_Config::get('ep_me_tenant_id_label');

        // initialize the connection.
        set_transient('alsp_ep_connection_init', 'yes', MINUTE_IN_SECONDS * 60);

        $client_id = sanitize_text_field(wp_unslash($client_id));
        if (!$client_id) {
            wp_send_json_error('Client ID should not be empty!', 400);
        }

        $tenant_id = sanitize_text_field(wp_unslash($tenant_id));
        if (!$tenant_id) {
            wp_send_json_error('Tenant ID should not be empty!', 400);
        }

        $client_secret = sanitize_text_field(wp_unslash($client_secret));
        if (!$client_secret) {
            wp_send_json_error('Client Secret should not be empty!', 400);
        }

        // MS Graph oAuth URL.
        $url = ALSP_Config_EP_Config_Connection_Checker::generate_me_auth_url($client_id, $tenant_id);

        wp_send_json(['redirectURL' => esc_url_raw($url)], 200);
    }

    public function can_create()
    {
        return $this->alsp_user->is_admin();
    }
}

// EOF