<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2L3dmTmlEVEd1NHFjQitlcFRldm9EcGFqR1ZqWDVpTDZlVUYzcTg3VTBZeWp3Y01pcDI1OHZqVy9ZWFFJL28yQ0xVdEh0My9wcVdoTzBQZXV2M1NrV3lKVDlpT3RrY1pXbEN5a1dOVXFuNDVTNmgyYkZjRnRxTmRWOGxodUdRQXFzPQ==*/

class ALSP_Config_EP_Cron
{
    private static $instance;

    public static function get_instance()
    {
        return isset(self::$instance) ? self::$instance : self::$instance = new self;
    }

    private function __construct()
    {
        add_filter('alsp_config_description', function ($desc) {
            $desc['cron_email_piping_enabled'] = $desc['cron_mailqueue_enabled'];

            return $desc;
        }, 30);

        add_filter('alsp_config', function ($config, $position) {
            if (isset($config['cron'])) {
                $cron_items = $config['cron']['items'];
                if (count($cron_items)) {
                    $cron_items = array_merge($cron_items, [
                        'cron_email_piping_enabled' => ALSP_Config_Panel::admin_item('cron_email_piping_enabled', FALSE, __('Email Piping', 'awedesk')),
                    ]);
                }

                $config['cron']['items'] = $cron_items;
            }
            return $config;
        }, 30, 2);

        add_action('alsp_cron_init', function () {
            if (0 == ALSP_Config::get('cron_email_piping_enabled', 0)) {
                add_action(ALSP_Email_Piping::CRON_EMAIL_PIPING, ['ALSP_Email_Piping', 'process_import_emails']);
            }
        });
    }
}

ALSP_Config_EP_Cron::get_instance();

// EOF