<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2K0RXMUZMWVZ0L1IzVWtmVUo5RzJrMmhGODZoRkJnK2FkQktVOUp4b2swNitFaDNqdWtKemFQYXk3OHNOZ3psak9rZkVxTlRHS1JiQlo5NUlYTEd4Q1JsWitPQ3I5QjJzVkl0WlM3d1puNFRIV1U5eVpXc0F4NnB5Zm85eVptMXdNPQ==*/

class ALSP_Config_EP_General
{
    private static $instance = NULL;

    public static function get_instance()
    {
        return (NULL == self::$instance) ? self::$instance = new self() : self::$instance;
    }

    private function __construct()
    {
        add_filter('alsp_config_menu', function ($menu) {
            $menu['email-piping'] = [
                'id' => 'email-piping',
                'label' => __('Email Piping', 'awedesk'),
                'icon' => 'alsp-i-cloud-download-alt',
            ];

            return $menu;
        }, 30);
        add_filter('alsp_config_description', function ($desc) {
            // $desc['ep_import_cc_enabled'] = _ _ ( ' I m port other emails as additional recipients','awedesk');
            $desc['ep_block_emails_textarea'] = __('One per line', 'awedesk');
            $desc['ep_block_subject_textarea'] = __('One per line', 'awedesk');
            // $desc['ep_forwarding_emails_textarea'] = _ _ ( ' O n e per line','awedesk');
            // $desc['ep_forwarding_as_from_email_enabled'] = _ _ ( ' U s e forwarding address as "From Email" in ticket email notifications','awedesk');

            return $desc;
        });

        add_filter('alsp_config', function ($config, $position) {
            if ($position !== 'email-piping-left' && $position !== 'email-piping-right') {
                return $config;
            }

            $piping_connections = [];
            foreach (ALSP_Email_Piping::$piping_connections as $key => $value) {
                $piping_connections[$key] = $value['label'];
            }

            $allowed_users = [
                'anyone' => __('Anyone (including guest users)', 'awedesk'),
                'registered' => __('Registered users only', 'awedesk'),
            ];

            $allowed_emails = [
                'all' => __('All', 'awedesk'),
                'new' => __('New', 'awedesk'),
                'reply' => __('Reply', 'awedesk'),
            ];

            $options_departments = [
                ['value' => 0, 'title' => __('None','awedesk'), 'label' => __('None','awedesk')]
            ];

            $depts_model = new ALSP_Model_Departments($r=new WP_REST_Request());
            $departments = $depts_model->read(1);

            if(count($departments)) {
                foreach($departments as $department) {
                    $options_departments[] = [
                        'value' => $department['id'],
                        'title' => $department['name'],
                        'label' => $department['name']
                    ];
                }
            }

            $config['email_piping'] = [
                'id' => 'email_piping',
                'title' => __('Email Piping', 'awedesk'),
                'icon' => 'alsp-i-envelope-bulk',
                'position' => 'email-piping-left',
                'items' => [
                    'ep_enabled' => ALSP_Config_Panel::admin_item('ep_enabled', FALSE, __('Enabled', 'awedesk')),
                    'ep_connection_select' => ALSP_Config_Panel::admin_item('ep_connection_select', 'ep_enabled', __('Connection', 'awedesk'), ['options' => apply_filters('alsp_ep_connection_select', $piping_connections)]),
                    'ep_reply_above_label' => ALSP_Config_Panel::admin_item('ep_reply_above_label', 'ep_enabled', __('Reply above text', 'awedesk')),
                    'ep_allowed_users_select' => ALSP_Config_Panel::admin_item('ep_allowed_users_select', 'ep_enabled', __('Allowed users', 'awedesk'), ['options' => apply_filters('alsp_ep_allowed_users_select', $allowed_users)]),
                    'ep_allowed_email_select' => ALSP_Config_Panel::admin_item('ep_allowed_email_select', 'ep_enabled', __('Allowed emails', 'awedesk'), ['options' => apply_filters('alsp_ep_allowed_email_select', $allowed_emails)]),
                    // 'ep_import_cc_enabled' => ALSP_Config_Panel::admin_item('ep_import_cc_enabled', 'ep_enabled', __('Import cc','awedesk')),
                    'ep_block_emails_textarea' => ALSP_Config_Panel::admin_item('ep_block_emails_textarea', 'ep_enabled', __('Blocked email addresses', 'awedesk')),
                    'ep_block_subject_textarea' => ALSP_Config_Panel::admin_item('ep_block_subject_textarea', 'ep_enabled', __('Blocked subject phrases', 'awedesk')),
                    'default_department_select' => ALSP_Config_Panel::admin_item('default_department_select', 'ep_enabled', __('Default department', 'awedesk'), ['options' => $options_departments]),
                    // 'ep_forwarding_emails_textarea' => ALSP_Config_Panel::admin_item('ep_forwarding_emails_textarea', 'ep_enabled', __('Forwarding emails','awedesk')),
                    // 'ep_forwarding_as_from_email_enabled' => ALSP_Config_Panel::admin_item('ep_forwarding_as_from_email_enabled', 'ep_enabled', __('Forwarding as "From Email"','awedesk')),
                ],
            ];

            return $config;
        }, 30, 2);

        add_filter('alsp_mailqueue_before_sending', [&$this, 'prepend_reply_above_text']);
    }

    /**
     * Return piping main email address
     * @param $department_id department ID
     *
     * @return string
     */
    public static function get_piping_email_address($department_id = NULL)
    {
        $prefix = '';
        if ($department_id) {
            $prefix = 'dept' . $department_id . '_';
        }

        $conn = ALSP_Config::get($prefix . 'ep_connection_select', 'imap');
	    if(!strlen($conn)) $conn='imap';
        return ALSP_Email_Piping::$piping_connections[$conn]['class']::get_piping_email_address($department_id);
    }

    public function dashboard()
    {
        wp_enqueue_style('alsp-admin');
        wp_enqueue_script('alsp-admin-email-piping');

        ?>
        <div class="alsp-wrapper" id="alsp_admin_container">
            <?php
            ALSP_Config_Panel::admin_logo();
            $status = ALSP_Config::get('license_status');
            ?>
            <?php if (!apply_filters('alsp_is_pro', FALSE) && $status !== 'valid') {
                // Content for promo codes is loaded from our server, no need for escaping
                // echo ALSP_Remote_Content::get('upsell', TRUE, ['location' => 'dashboard']);
            } ?>
            <div class="alsp-main alsp-main--email" id="alsp_admin_body_container">
                <div class="alsp-column alsp-column--left" id="alsp_admin_body_email-piping">
                    <span class="alsp-loading loading">
                        <?php echo __('Loading', 'awedesk').'...'; ?>
                    </span>
                </div>
                <div class="alsp-column alsp-column--right" id="alsp_admin_body_email-piping-connection">
                    <span class="alsp-loading loading"></span>
                </div>
            </div>
        </div>
        <?php
    }

    /**
     * Prepend reply above text with.
     *
     * @param object $email - email object.
     * @return object
     */
    public function prepend_reply_above_text($email)
    {
        // Only preprend if only email piping was enabled.
        if (!ALSP_Config::get('ep_enabled', 0)) {
            return $email;
        }

        // reply above.
        if (isset($email->message)) {
            $reply_text_above = ALSP_Config::get('ep_reply_above_label', '-- Reply above --');
            $email->message = $reply_text_above . $email->message;
        }

        return $email;
    }
}

ALSP_Config_EP_General::get_instance();

// EOF
