<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2L3Z0MHBMTzNuVGhtc3pYcnFlWEZVdWlOQUNUc2xvNytrN1dZN2x1WmdLNFdmeCtHQ05yb0U1NnVyd0syV1RyS0Q3UUtsNkpod0t4NHJhSmV4TStFWW5HY1ljTTZweEttc2NWa3o5eEhvTVRyV0ZVSXBJVytUMFZJNGVGWitpMVJnPQ==*/

class ALSP_Config_EP_Gmail
{
    private static $instance = NULL;

    public static function get_instance()
    {
        return (NULL == self::$instance) ? self::$instance = new self() : self::$instance;
    }

    private function __construct()
    {
        add_filter('alsp_config_description', function ($desc) {
            $desc['ep_gmail_email_label'] = FALSE;
            $desc['ep_gmail_client_id_label'] = FALSE;
            $desc['ep_gmail_client_secret_label'] = FALSE;
            $desc['ep_gmail_js_origin_label'] = FALSE;
            $desc['ep_gmail_redirect_uri_label'] = FALSE;
            $desc['ep_gmail_is_active_label'] = FALSE;
            $desc['ep_gmail_history_id_label'] = FALSE;
            $desc['ep_gmail_last_error_label'] = FALSE;
            $desc['ep_gmail_message'] = '<div class="alsp-opt__form-actions">
            <button class="alsp-opt__action alsp-btn alsp-btn--action" data-id="ep_gmail_check" data-btn="check" data-tooltip="Check" style="">
                <i class="alsp-i-plug"></i> Check
                <i class="alsp-i-spinner alsp-i-spin" data-loading style="display:none"></i>
            </button>
        </div>';

            return $desc;
        });

        add_filter('alsp_config', function ($config, $position) {
            if ($position !== 'email-piping-right') {
                return $config;
            }

            $url = wp_parse_url(home_url());

            $history_id = ALSP_Config::get('ep_gmail_history_id', 0);
            $is_active = ALSP_Config::get('ep_gmail_is_active', 0);
            $status = $is_active ? __('Connected', 'awedesk') : __('Not Connected', 'awedesk');
            $last_error = ALSP_Config::get('ep_gmail_last_error', '');

            $config['email_piping_gmail_conn'] = [
                'id' => 'email_piping_gmail_conn',
                'title' => 'Gmail',
                'icon' => 'alsp-i-clip',
                'description' => sprintf(__('Configure connection: %s', 'awedesk'), 'GMail'),
                'position' => 'email-piping-right',
                'items' => [
                    'ep_gmail_email_label' => ALSP_Config_Panel::admin_item('ep_gmail_email_label', FALSE, __('Email', 'awedesk')),
                    'ep_gmail_client_id_label' => ALSP_Config_Panel::admin_item('ep_gmail_client_id_label', FALSE, __('Client ID', 'awedesk')),
                    'ep_gmail_client_secret_label' => ALSP_Config_Panel::admin_item('ep_gmail_client_secret_label', FALSE, __('Client Secret', 'awedesk')),
                    'ep_gmail_js_origin_label' => ALSP_Config_Panel::admin_item('ep_gmail_js_origin_label', FALSE, __('Authorized Javascript Origin', 'awedesk'), ['default_value' => esc_url($url['scheme'] . '://' . $url['host']), 'disabled' => TRUE]),
                    'ep_gmail_redirect_uri_label' => ALSP_Config_Panel::admin_item('ep_gmail_redirect_uri_label', FALSE, __('Authorized Redirect URI', 'awedesk'), ['default_value' => esc_url(admin_url('admin.php')), 'disabled' => TRUE]),
                    'ep_gmail_is_active_label' => ALSP_Config_Panel::admin_item('ep_gmail_is_active_label', FALSE, __('Status', 'awedesk'), ['default_value' => $status, 'disabled' => TRUE]),
                    'ep_gmail_history_id_label' => ALSP_Config_Panel::admin_item('ep_gmail_history_id_label', FALSE, __('Last History ID', 'awedesk'), ['default_value' => $history_id, 'disabled' => TRUE]),
                    'ep_gmail_last_error_label' => ALSP_Config_Panel::admin_item('ep_gmail_last_error_label', FALSE, __('Last Error', 'awedesk'), ['default_value' => $last_error, 'disabled' => TRUE]),
                    'ep_gmail_message' => ALSP_Config_Panel::admin_item('ep_gmail_message', FALSE, FALSE),
                ],
            ];

            return $config;
        }, 32, 2);

        // gmail process connection response.
        add_action('admin_init', ['ALSP_Config_EP_Config_Connection_Checker', 'process_response_gmail']);
    }
}

ALSP_Config_EP_Gmail::get_instance();

// EOF
