<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2L0NzellxOW9aVUFLd1llbGsvdFFRSXVkQzBGOEFSeUcvS3ZlVC9FTUt1UTA2T0NCWE40QUtqMVVhWndWb0FVWGpVUVBJcHNFT3QySXRSWVo0OHhoNER6eE5JTTRCWFRFQ0Vac05lVlozTk5aU0RUQ0FpTGF3SGVwRXNXbXlDb0RnPQ==*/

if (!defined('ABSPATH')) {
    exit; // Exit if accessed directly!
}

class ALSP_Config_EP_Imap
{
    private static $instance = NULL;

    public static function get_instance()
    {
        return (NULL == self::$instance) ? self::$instance = new self() : self::$instance;
    }

    private function __construct()
    {
        add_filter('alsp_config_description', function ($desc) {
            $desc['ep_imap_email_label'] = FALSE;
            $desc['ep_imap_incoming_mail_server_label'] = FALSE;
            $desc['ep_imap_is_active_label'] = FALSE;
            $desc['ep_imap_message'] = '<div class="alsp-opt__form-actions">
            <button class="alsp-opt__action alsp-btn alsp-btn--action" data-id="ep_imap_check" data-btn="check" data-tooltip="Check" style="">
                <i class="alsp-i-plug"></i> Check
                <i class="alsp-i-spinner alsp-i-spin" data-loading style="display:none"></i>
            </button>
        </div>';

            return $desc;
        });

        add_filter('alsp_config', function ($config, $position) {
            if ($position !== 'email-piping-right') {
                return $config;
            }

            $imap_encryption = [
                'ssl' => 'SSL',
                'tls' => 'TLS',
                'none' => __('Disabled',  'awedesk'),
            ];

            $is_active = ALSP_Config::get('ep_imap_is_active', 0);
            $status = $is_active ? __('Connected', 'awedesk') : __('Not Connected', 'awedesk');

            $config['email_piping_imap_conn'] = [
                'id' => 'email_piping_imap_conn',
                'title' => 'IMAP',
                'icon' => 'alsp-i-clip',
                'description' => sprintf(__('Configure connection: %s', 'awedesk'), 'IMAP'),
                'position' => 'email-piping-right',
                'items' => [
                    'ep_imap_email_label' => ALSP_Config_Panel::admin_item('ep_imap_email_label', FALSE, __('Email', 'awedesk')),
                    'ep_imap_email_password' => ALSP_Config_Panel::admin_item('ep_imap_email_password', FALSE, __('Password', 'awedesk')),
                    'ep_imap_encryption_select' => ALSP_Config_Panel::admin_item('ep_imap_encryption_select', FALSE, __('Encryption', 'awedesk'), ['options' => $imap_encryption]),
                    'ep_imap_incoming_mail_server_label' => ALSP_Config_Panel::admin_item('ep_imap_incoming_mail_server_label', FALSE, __('Server', 'awedesk')),
                    'ep_imap_port_number' => ALSP_Config_Panel::admin_item('ep_imap_port_number', FALSE, __('Port', 'awedesk')),
                    'ep_imap_is_active_label' => ALSP_Config_Panel::admin_item('ep_imap_is_active_label', FALSE, __('Status', 'awedesk'), ['default_value' => $status, 'disabled' => TRUE]),
                    'ep_imap_message' => ALSP_Config_Panel::admin_item('ep_imap_message', FALSE, FALSE),
                ],
            ];

            return $config;
        }, 31, 2);

        add_action('admin_notices', [&$this, 'connection_error_admin_notice']);
    }

    /**
     * IMAP Connection error admin notice
     *
     * @return void
     */
    public static function connection_error_admin_notice()
    {
        if (!is_admin()) {
            return;
        }

        $connection = ALSP_Config::get('ep_connection_select', 'imap');
        $connection_notice = ALSP_Config::get('ep_imap_connection_notice');
        $imap_is_active = ALSP_Config::get('ep_imap_is_active', 0);
        // return if either connection is active or notice dismissed.
        if (!($connection == 'imap' && !$imap_is_active && $connection_notice)) {
            return;
        }
        ?>
        <div class="alsp imap connection-error notice notice-error">
            <p>
                Awedesk: Email Piping encountered a connection error
            </p>
            <p>
                <a
                    href="<?php echo esc_url_raw(admin_url('admin.php?page=alsp#email-piping')); ?>">
                    <?php echo esc_attr__('View Details', 'awedesk'); ?>
                </a>
            </p>
        </div>
        <?php
    }
}

ALSP_Config_EP_Imap::get_instance();

// EOF
