<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2OEZJYVJpSUpMQU5obVFSTU1IcmpMRy9HRjR3TzVKY2dFWmdURllUOXpodFVyNGczYmwvNk5ocEkrSTdoRVVKbG12TmdpdHlQSDJkWVFvK2IrbUI1TVJGRytyQmRpZm5HcCtjNzdiczV6aDRwV1luOWtwemV0TkZkcFpncHZXMUw0PQ==*/

class ALSP_One_Click_Unsubscribe {

    private $user_id;
    private $keys = []; // User key pair used to validate the unsubscribe operation without logging in

    public function __construct($user_id) {

        $this->user_id = $user_id;

        $mayfly = 'unsubscribe_keys_user_'.$this->user_id;

        $keys = ALSP_Mayfly::get($mayfly);

        if(!is_array($keys) || !isset($keys['secret']) || !isset($keys['public'])) {
            $keys = [];

            $keys['secret'] = substr(md5(uniqid(rand(), true)), 0, 16);
            $keys['public'] = substr(md5($keys['secret'].$this->user_id), 0, 16);

            ALSP_Mayfly::set($mayfly, $keys);
        }

        $this->keys = $keys;
    }

    public function link() {
        $link = get_bloginfo('wpurl');
        $link = add_query_arg(ALSP_One_Click_Unsubscribe_Handler::get_instance()->url_key, $this->keys['public'], $link);
        $link = add_query_arg('user', $this->user_id, $link);

        return $link;
    }

    public function verify($key) {
        return $key === $this->keys['public'];
    }
}

class ALSP_One_Click_Unsubscribe_Handler {

    private static $instance;
    public $url_key;
    public static function get_instance() {
        return self::$instance ?? (self::$instance = new self());
    }

    private function __construct() {

        $this->url_key = substr(md5('alsp_unsubscribe'), 0, 16);

        add_action('template_redirect', function(){

            // Link handler
            if(isset($_GET[$this->url_key]) && isset($_GET['user'])) {

                $user = intval($_GET['user']);
                $destination = get_permalink(ALSP_Config::get('support_page_client_select', -1));

                if( (new ALSP_One_Click_Unsubscribe($user))->verify($_GET[$this->url_key])) {

                    global $wpdb;
                    $sql = "DELETE FROM {$wpdb->prefix}alsp_user_preferences WHERE `user`=$user AND `pref_key`='receive_emails'";
                    $wpdb->query($sql);

                    $sql = "INSERT INTO {$wpdb->prefix}alsp_user_preferences (`user`,`pref_key`,`pref_value`) VALUES ($user, 'receive_emails', 0)";
                    $wpdb->query($sql);

                    $destination = $destination . '#unsubscribe/all:success';
                } else {
                    $destination = $destination . '#unsubscribe/all:error';
                }

                wp_safe_redirect($destination);
            }
        });
    }
}

ALSP_One_Click_Unsubscribe_Handler::get_instance();