<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2K2xhazhmbnBWZVY1QU5HRXAyTktMQ0paeS9ya3krbGFHcEFhdXNYcHdyTVpEeGxIZFBKc1JOcmZIckVhNG1SL3pabjFCSmRsSmxxYTFLNTBZeWp0ZEdsdTdiN2N5L00weENMdkU0emlDc0pVcGJXLzE3WG1GMEZPeHg0SGRnSXlVPQ==*/
/*
 * Model for listing items
 */
abstract class ALSP_Model_List
{

    public $id;
    public $author;

    protected $model = '';
    protected $request;
    protected $wpdb;
    protected $query;
    protected $query_count;
    protected $table;

    /** INIT **/

    public function __construct(WP_REST_Request $request)
    {
        global $wpdb;
        $this->wpdb = $wpdb;
        $this->request = $request;
    }

    protected function init($model)
    {
        $this->model = 'ALSP_model_' . $model;
        $this->table = $this->model::config_table();
    }

    /** CREATE **/

    /** READ **/
    protected function prepare_result($data)
    {
        if (count($data)) {
            foreach ($data as $key => $id) {
                $model = new $this->model($id);
                $data[$key] = $model->get_item();
            }
            return $data;
        }

        return [];
    }

    protected function query_init($where = [], $order = [], $page = 1, $per_page = 10)
    {
        $this->query_start();
        $this->query_where($where);
        $this->query_order($order);
        $this->query_limit($page, $per_page);
    }

    protected function query_count()
    {
        $this->query_count = "SELECT count(id) FROM {$this->table}";
    }

    protected function query_start()
    {
        $this->query = "SELECT id FROM {$this->table}";
    }

    protected function query_join($join = [])
    {
        if (count($join)) {
            foreach ($join as $key => $value) {
                $this->query .= " " . $value;
                $this->query_count .= " " . $value;
            }
        }
    }

    // Add shared WHERE statements
    protected function query_where($where = [])
    {
        global $wpdb;

        if ($this->request['id']) {
            $where['id'] = $wpdb->prepare('id=%d', intval($this->request['id']));
        }

        $where_clauses = '';
        if (count($where)) {
            $where_clauses = " WHERE " . implode(' AND ', $where);
        }

        $this->query .= is_string($where_clauses) ? $where_clauses : FALSE;
        $this->query_count .= is_string($where) ? $where : FALSE;
    }

    // Add shared LIMIT statements
    protected function query_limit($page = 1, $per_page = 10)
    {
        $offset = ($page - 1) * $per_page;

        if ($page < 1) {
            $page = 1;
            $offset = 0;
        }

        $limit = " LIMIT $offset, $per_page";

        $this->query .= is_string($limit) ? $limit : FALSE;
    }

    // Add default ORDER statement
    protected function query_order($order = [])
    {
        if (count($order) > 0) {
            $order_by = [];
            foreach ($order as $key => $value) {
                $order_by[] = " `$key` $value";
            }
            $this->query .= " ORDER BY " . implode(',', $order_by);
        } else {
            $this->query .= " ORDER BY `id` DESC";
        }
    }

    /** UPDATE **/
    public function reorder()
    {
        if (count($this->request['ids'])) {
            $order = 1;
            foreach ($this->request['ids'] as $id) {
                $model = new $this->model($id);
                $model->set('order', $order);
                $order++;
            }
        }
    }

}

// EOF
