<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2L2dBVVovTXhWQ0c3aWxQQ2NsVDhZV1RsL2tjNlNMYkFqUDg3eXh2RGpjYmllR21ublNwL1Z4T0hwZWVPVFF0VnBUL1FqZ212aWVaZ3k1WkIrSjhIeWZHZ2djb3lZU3pqTmlJa0RuaEdPTnRsRWNFVnBzaUhQR1V0NlZVTld3cngwPQ==*/
/*
 * Model for listing items
 */
abstract class ALSP_Model_Single
{

    public $id;
    public $editable_properties;
    public $wpdb;

    public function __construct($id = NULL)
    {
        global $wpdb;
        $this->wpdb = $wpdb;

        // No ID means we are creating a new item
        if ($id) {
            $this->id = $id;

            $query = $this->wpdb->prepare("SELECT * FROM " . $this->config_table() . " WHERE id=%d", $this->id);
            $result = $this->wpdb->get_row($query, ARRAY_A);

            if (is_array($result)) {
                foreach ($result as $k => $v) {
                    if (property_exists($this, $k)) {
                        $this->$k = $v;
                    }
                }
            }
        }

        return;
    }

    public static function config_table()
    {
        return NULL;
    }

    public function get_item($return = ARRAY_A)
    {
        $item = $this;
        unset($item->wpdb);
        unset($item->editable_properties);

        return ($return == ARRAY_A) ? (array) $item : $item;
    }

    public function set($property, $value)
    {
        if (property_exists($this, $property)) {

            $validation = new ALSP_Value_Validation();
            $value = $validation->_($property, $value);


            if (!$value instanceof ALSP_Value_Validation_Error) {
                $this->$property = $value;

                $set = [$property => $value, 'updated' => current_time('mysql', TRUE)];

                $this->wpdb->update($this->config_table(), $set, ['id' => $this->id]);
            } else {
                // ALSP_Value_Validation_Error...
                //new ALSP_Debug('Invalid data: ' . print_r($value, true));
                throw new Exception('Invalid data');
            }
        } else {
            throw new Exception('Invalid property');
        }
    }

    public function delete()
    {
        global $wpdb;
        $sql = $wpdb->prepare('DELETE FROM ' . $this->config_table() . ' WHERE id=%d', $this->id);
        $result = $wpdb->query($sql);

        return $result;
    }
}

// EOF