<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2OU1PM0VUcHdWajYrOU9Fa1FSdHAwMXQvR250VU1ValpoTTJwenowR1NobDUyMHN0QUFybk1vVHdOenpmYzVrU2xVbUxIOC9Fb0g0elNtZzhYOFlYMlQxdUtYWDRQMDd6MjFmVHBOUS9LMDBBPT0=*/

class ALSP_Model_Agent extends ALSP_Model_Single
{
    public $id;
    public $agent;
    public $author;
    public $role;
    public $created;
    public $updated;
    public $edit_profile_url;

    public function __construct($id = NULL)
    {
        parent::__construct($id);
    }

    public static function config_table()
    {
        global $wpdb;

        return $wpdb->prefix . 'alsp_users';
    }

    public function get_item($return = ARRAY_A)
    {
        if (is_numeric($this->id) && $this->id > 0) {
            $item = parent::get_item($return);

            if ($item['id'] !== NULL) {
                $agent = ALSP_User::get_instance($item['id']);
                $item['agent'] = $agent->get_details();
            }

            if ($item['author'] > 0) {
                $author = ALSP_User::get_instance($item['author']);
                $item['author'] = $author->get_details();
            } else {
                $item['author'] = NULL;
            }

            $agent_department = new ALSP_Model_Agent_Department(NULL);
            $item['department'] = $agent_department->get_by_agent($item['id']);

            $signature = new ALSP_Signature($item['id']);
            $item['signature'] = [
                'can_use_custom' => $signature->can_use_custom(),
                'has_custom' => $signature->has_custom(),
                'signature' => $signature->render(),
            ];
            $item['edit_profile_url'] = get_edit_user_link($item['id']);

            return $item;
        }

        return [];
    }

    public function delete($request = NULL)
    {
        parent::delete();

        // Remove additional alsp agent/manager role.
        $user = get_user_by('ID', $this->id);

        // Clean up roles alsp

        $wprole_alsp_agent = 'alsp_' . ALSP_User::ROLE_AGENT;
        $wprole_alsp_manager = 'alsp_' . ALSP_User::ROLE_MANAGER;

        $user->remove_role($wprole_alsp_agent);
        $user->remove_role($wprole_alsp_manager);

        return (TRUE);
    }
}

// EOF
