<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2OHMzRmlUOEFsTFZaWHQ1a21kU2ZVeXd3ZTVTZU0rZURXVWVNQ0YwZVdtWjNML3hTUEpJMFNqTHVNd1N1K3JNR1RSU3Bud0tKaFkrQ21hM21ub2ROV04rVXVBRGRKZTIwWHNjdmJnV3k3V3BBPT0=*/

class ALSP_Model_Agents extends ALSP_Model_List
{

    public function __construct(WP_REST_Request $request)
    {
        parent::__construct($request);
    }

    protected function query_start()
    {
        $this->query = "SELECT DISTINCT alsp_users.id FROM {$this->table} alsp_users";
    }

    public function read()
    {
        $this->init('agent');
        $this->query_start();

        $join = [];
        $join['agent'] = "LEFT JOIN {$this->wpdb->users} agent ON alsp_users.id = agent.id";
        $join['agent_department'] = "LEFT JOIN {$this->wpdb->prefix}alsp_agent_department agent_department ON alsp_users.id = agent_department.agent";
        $this->query_join($join);

        $where = [];
        $role = $this->request['role'] ?? 'all';
        if ($role == 'all') {
            $where['role'] = " `alsp_users`.`role` IN ('admin', 'manager', 'agent')";
        } else {
            $arr_role = explode(',', $role);
            $where['role'] = " `alsp_users`.`role` IN ('" . implode("','", $arr_role) . "')";
        }

        $department = $this->request['department'];
        if ($department) {
            if ($role == "all") {
                $where['role'] = " (`alsp_users`.`role` IN ('admin', 'manager') OR (`alsp_users`.`role` = 'agent' AND `agent_department`.`department` = " . $department . "))";
            } else {
                $where['agent_department'] = " `agent_department`.`department` = " . $department . "";
            }
        }

        $where = apply_filters('alsp_agents_query_where', $where, $this->request);
        $this->query_where($where);

        $order = [
            'id' => 'ASC',
        ];
        $this->query_order($order);

        $ids = [];
        $result = $this->wpdb->get_results($this->query, ARRAY_A);
        foreach ($result as $id) {
            $ids[] = $id;
        }

        return $this->prepare_result($ids);
    }

    // Add shared WHERE statements
    public function query_where($where = [])
    {
        global $wpdb;

        if ($this->request['id']) {
            $where['id'] = $wpdb->prepare('alsp_users.id=%d', $this->request['id']);
        }

        if (count($where)) {
            $where = " WHERE " . implode(' AND ', $where);
        }

        $this->query .= is_string($where) ? $where : FALSE;
        $this->query_count .= is_string($where) ? $where : FALSE;
    }

    public function after_department_delete($department)
    {
        global $wpdb;
        // This will eventually remove department from agents
        $sql = $wpdb->prepare("UPDATE {$wpdb->prefix}alsp_users SET department=NULL WHERE department=%d", $department);
        $wpdb->query($sql);
    }
}

// EOF