<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2K0V4ZUNCSTBDVUZyWXJkeVkzZEhDYTFjdGphWHpvem9lMlhmUGpEYmphU0NQK0ZUNE9wNU1hUklUVEU4NS9DZjBPQ3h0TGljOXFHajQxVFAzVm13WXFZWGUzY2VCV1Y0VWdvMmp4V1RzWnBYRFNUWGl0MzNSM0hvOGIxaFJYYnI0PQ==*/

class ALSP_Model_Departments extends ALSP_Model_List
{

    public function __construct(WP_REST_Request $request)
    {
        parent::__construct($request);
    }

    public function read($published = 'all')
    {
        $this->init('department');
        $this->query_start();

        $where = [];
        if ($published !== 'all') {
            $where['published'] = '`published`=' . $published;
        }

        // agent only
        $user = ALSP_User::get_instance(get_current_user_id());
        if (!is_user_logged_in() || ($user->is_client())) {
            $where['agent_only'] = '`agent_only`=0';
        }

        $where = apply_filters('alsp_departments_query_where', $where, $this->request);
        $this->query_where($where);

        $qorder = [
            'order' => 'ASC',
            'id' => 'ASC',
        ];
        $this->query_order($qorder);

        $ids = [];
        $result = $this->wpdb->get_results($this->query, ARRAY_A);
        foreach ($result as $id) {
            $ids[] = $id;
        }

        return $this->prepare_result($ids);
    }
}

// EOF
