<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2OGF5NDNySGZkc2djMHBiejZhd1QxOCtTLzhsR0JTWGhNNHRyZVJ3ZmtTT1JEci8zcVNnYXo4cVozMEM4K3FtV3FHR0Y1NVdveVZpYmgvcDdub0duNjR5WmwySVBSZjkvR3FjRE1VaEJwQUZhM1dmaVM2b1RScHdZL3M1L1diUWdZPQ==*/

class ALSP_Model_Email_Piping_Forwarder extends ALSP_Model_Single
{
    public $id;
    public $receiver;
    public $department;
    public $created;

    public function __construct($id = NULL)
    {
        $this->editable_properties = ['receiver', 'department'];

        parent::__construct($id);
    }

    public static function config_table()
    {
        global $wpdb;

        return $wpdb->prefix . 'alsp_multi_inbox';
    }

    public function get_item($return = ARRAY_A)
    {
        if (is_numeric($this->id) && $this->id > 0) {
            $item = parent::get_item($return);
            if ($item['department'] > 0) {
                $dept = new ALSP_Model_Department($item['department']);
                $item['department'] = $dept->get_item();
            } else {
                $item['department'] = NULL;
            }

            return $item;
        }

        return [];
    }

    /**
     * Create multi inbox
     * @param int $receiver receiver email
     * @param int $department department ID
     * 
     * @return int|bool Last insert ID. Boolean false on error.
     */
    public function create_item($receiver, $department)
    {
        // create the ALSP department
        global $wpdb;

        $now = current_time('mysql', TRUE);
        $data = [
            'receiver' => $receiver,
            'department' => $department,
            'author' => get_current_user_id(),
            'created_at' => $now,
        ];
        $ret = $wpdb->insert($this->config_table(), $data);

        $lastid = FALSE;
        if ($ret) {
            $lastid = $wpdb->insert_id;
        }

        return $lastid;
    }

    public function update_item($id, $receiver, $department)
    {
        $ret = FALSE;
        // update the ALSP department
        global $wpdb;
        $sql = "SELECT * FROM `" . $this->config_table() . "` " .
            " WHERE `id`=%d ";
        $res = $wpdb->get_results($wpdb->prepare($sql, $id), ARRAY_A);
        if (count($res) > 0) {
            // if alsp_departments record exist, update it
            $now = current_time('mysql', TRUE);
            $data = [
                'receiver' => $receiver,
                'department' => $department,
            ];
            $ret = $wpdb->update($this->config_table(), $data, ['id' => $id]);
        }

        return $ret;
    }

    public function delete($request = NULL)
    {
        parent::delete();
    }
}

// EOF