<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2K0ZYZS93WHUxaGg4dGJNWUp4NFZtRWdCM2hncGpEK2kwcndQR1pDUmtDandoR3l4NFQzV2I0VjZLSDJxZWtQMEtRM2Z2QzZlanhEeXZYVjR3UDFOOUo3UDVBcGFqOWl2M3F5OE00SGNoSjdwRUg0cSswdGRJdDRQZHNJT2lyTFpNPQ==*/

class ALSP_Value_Validation
{

    public $property;
    public $value;

    public function _($property, $value)
    {

        $this->property = $property;
        $this->value = $value;

        $sanitize_method = 'sanitize_' . $property;
        $validate_method = 'validate_' . $property;

        if (method_exists($this, $sanitize_method)) {
            $value = $this->$sanitize_method($value);
        }

        if (method_exists($this, $validate_method)) {
            $value = $this->$validate_method($value);
        }

        return $value;
    }

    /** INT - ID **/
    private function sanitize_id($value)
    {
        return $this->sanitize_int($value);
    }

    private function validate_id($value)
    {
        return $this->validate_int_positive($value);
    }

    /** INT - SHARED METHODS **/
    private function sanitize_int($value)
    {
        return intval($value);
    }

    private function validate_int_positive($value)
    {
        if (is_numeric($value) && $value > 0) {
            return $value;
        } else {
            return new ALSP_Value_Validation_Error($this->property, $this->value, 'Value must be a positive number');
        }
    }

    private function validate_int_not_negative($value)
    {
        if (is_numeric($value) && $value >= 0) {
            return $value;
        } else {
            return new ALSP_Value_Validation_Error($this->property, $this->value, 'Value must be zero or a positive number');
        }
    }

    /** STRING - SHARED METHODS */
    public function validate_string_not_empty($value)
    {
        if (is_string($value) && strlen($value) > 0) {
            return $value;
        } else {
            return new ALSP_Value_Validation_Error($this->property, $this->value, 'Value cannot be empty');
        }
    }
}

class ALSP_Value_Validation_Error
{

    public $property;
    public $value;
    public $message;
    public function __construct($property, $value, $message)
    {
        $this->message = $message;
        $this->value = $value;
        $this->property = $property;
    }
}

// EOF