<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2ODFkckJUU3U5a2Y0S1A4UWhLZTlOcE8vNWhna2VjMG15c3BMS3EyYjZvSDBQbkY5eWVsVVBpNFgxS1ZIM211dTllczYzNlFYd0UyOE1TcngwZnFPdDBod003aVQwQ0pjRUl5cXNaTXVCcWxlVjB2UzZnLy9ONUxmVWhnZTk0UmRFPQ==*/

class ALSP_Signature {

    private $user;


    public function __construct($user_id = NULL) {

        if(!$user_id) {
            $user_id = get_current_user_id();
        }

        $this->user = ALSP_User::get_instance($user_id);
    }

    public function render() {

        $signature = FALSE;

        if($this->user->is_staff() && ALSP_Config::get('signatures_enabled', 1)) {

            $signature = $this->get_custom();

            if(!$signature || !strlen($signature)) {
                $signature = $this->get_default();
            }
        }

        return ($signature && strlen($signature)) ? str_ireplace('{agent_name}',$this->user->get_details()['display_name'], $signature) : FALSE;
    }

    public function get_default() {

        if($this->user->is_admin()) {
            $template = $this->get_default_admin();
        } elseif($this->user->is_manager()) {
            $template = $this->get_default_manager();
        } elseif($this->user->is_agent()) {
            $template = $this->get_default_agent();
        }

        return ($template && strlen($template)) ? $template : FALSE;
    }

    public function get_default_admin() {

        $template = ALSP_Config::get('signature_admin_template');

        if($template && strlen($template)) return $template;

        return $this->get_default_manager();
    }

    public function get_default_manager() {

        $template = ALSP_Config::get('signature_manager_template');

        if($template && strlen($template)) return $template;

        return $this->get_default_agent();
    }

    public function get_default_agent() {
        return ALSP_Config::get('signature_agent_template');
    }

    public function get_custom() {

        $template = FALSE;

        if($this->can_use_custom()) {
            $template = get_user_meta($this->user->user_id, 'alsp_signature', TRUE);
        }

        return ($template && strlen($template)) ? $template : FALSE;
    }

    public function has_custom() {
        $custom = get_user_meta($this->user->user_id, 'alsp_signature', TRUE);
        return $this->can_use_custom() && is_string($custom) && strlen($custom);
    }
    public function can_use_custom() {

        $custom = FALSE;

        if($this->user->is_staff() && ALSP_Config::get('signatures_enabled', 1)) {

            if ($this->user->is_admin()) {
                $custom = ALSP_Config::get('signatures_custom_admin_enabled', 1);
            } elseif ($this->user->is_manager()) {
                $custom = ALSP_Config::get('signatures_custom_manager_enabled', 1);
            } else {
                $custom = ALSP_Config::get('signatures_custom_agent_enabled', 1);
            }
        }

        return $custom;
    }
}
