<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2OTlTK2wzcnZFcTBhMzZpa2NkQjVTZ1lrWUwxTHFUWXRJWGorc3JjVGwrRU1VRjNpd0NNZ0RPZ1ZDekFIcVB1SnpEbC9yVkVjQ0V5SWw2RXA0UGxDZy9IQzA2cmNIaVp4TlBxUkNRQWl1RTZoUCs0d0hSaUEzWFpOTE56Z1FHb21VPQ==*/

// @TODO we don't want this to extend any abstract class
class ALSP_Model_Staff_Notes
{
    private $wpdb;
    private $table;
    private $client_id;
    private $ticket_id;

    public function __construct($client_id, $ticket_id = FALSE)
    {
        global $wpdb;

        $this->client_id = (int) $client_id;
        $this->ticket_id = (int) $ticket_id;
        $this->wpdb = $wpdb;
        $this->table = $this->wpdb->prefix . 'alsp_staff_notes';
    }

    public function read()
    {
        $data = [];

        $sql = "SELECT  id, author, message, created FROM {$this->table} WHERE client_id=" . $this->client_id . " AND ticket_id IS NULL ORDER BY id ASC";
        $client_notes = $this->wpdb->get_results($sql);

        $data['client'] = [];
        foreach ($client_notes as $key => $notes) {
            if ($notes->author !== NULL) {
                $notes->author = (ALSP_User::get_instance($notes->author))->get_details();
            }
            $notes->created_absolute = ALSP_Utility_String::date_absolute($notes->created);
            $notes->created_relative = ALSP_Utility_String::date_relative($notes->created);

            $data['client'][] = $notes;
        }

        if ($this->ticket_id) {
            $data['ticket'] = [];
            $sql = "SELECT  id, author, message, created FROM {$this->table} WHERE ticket_id=" . $this->ticket_id . " ORDER BY id ASC";
            $ticket_notes = $this->wpdb->get_results($sql);

            foreach ($ticket_notes as $key => $tnotes) {
                if ($tnotes->author !== NULL) {
                    $tnotes->author = (ALSP_User::get_instance($tnotes->author))->get_details();
                }
                $tnotes->created_absolute = ALSP_Utility_String::date_absolute($tnotes->created);
                $tnotes->created_relative = ALSP_Utility_String::date_relative($tnotes->created);

                $data['ticket'][] = $tnotes;
            }
        }

        return $data;
    }

    public function create($message, $type = 'ticket', $user_id = NULL)
    {
        $user_id = $user_id ?? get_current_user_id();

        $key = 'ticket_id';
        if ($type == 'client') {
            $key = 'client_id';
        }

        $now = current_time('mysql', TRUE);
        $this->wpdb->insert(
            $this->table,
            [
                $key => $this->$key,
                'message' => ALSP_Utility_String::sanitize_message($message, FALSE),
                'author' => $user_id,
                'created' => $now,
            ]
        );

        return $this->read();
    }

    public function delete($id, $type = 'ticket')
    {
        $key = 'ticket_id';
        if ($type == 'client') {
            $key = 'client_id';
        }

        $this->wpdb->delete($this->table, ['id' => $id, $key => $this->$key]);

        return $this->read();
    }

    /**
     * Delete staff notes by ticket_id
     * @param int $ticket_id Ticket ID
     *
     * @return int|bool Number of rows affected/selected for all other queries. Boolean false on error.
     */
    public function delete_by_ticket($ticket_id)
    {
        global $wpdb;

        $sql = $wpdb->prepare('DELETE FROM ' . $this->table . ' WHERE ticket_id=%d', $ticket_id);
        $result = $wpdb->query($sql);

        return $result;
    }
}