<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2ODYra2swNTYyTG9SZ1hiWlROWmR2MFE1eXhKbEJvaVJ2YVlsakIzMlJPR01iaDhtRWtLeWZ2cXVHSk9PVzhYQ2dKZkFsZXhYRk1zTjBHUEIxdkh5bVRzL3g3RW5IVWozT3VDWm5KR1V3SjgxMGp0d1lGaEU5U2k0M1pndjdEOC8wPQ==*/

class ALSP_Model_Ticket_Messages extends ALSP_Model_List
{

    public function __construct(WP_REST_Request $request)
    {
        parent::__construct($request);
    }

    public function read()
    {
        $this->init('ticket_message');
        $this->query_start();

        $where = [];
        // filter by ticket number
        if ($this->request['ticket']) {
            if (is_numeric($this->request['ticket']) && $this->request['ticket'] > 0) {
                // Specific collection
                $where['ticket'] = $this->wpdb->prepare('ticket=%d', $this->request['ticket']);

                // only get messages before/after a specific ID
                if (is_numeric($this->request['before'])) {
                    $where['before'] = $this->wpdb->prepare('id<%d', $this->request['before']);
                } else if (is_numeric($this->request['after'])) {
                    $where['after'] = $this->wpdb->prepare('id>%d', $this->request['after']);
                }
            }
        }

        $where = apply_filters('alsp_ticket_messages_query_where', $where, $this->request);

        $this->query_where($where);

        $order = [ 'id' => (int) $this->request['desc'] ? 'DESC' : 'ASC' ];
        $this->query_order($order);

        $page = 1;
        $per_page = 10;
        if ($this->request['page'] && $this->request['per_page']) {
            $page = $this->request['page'];
            $per_page = $this->request['per_page'];
        }
        $this->query_limit($page, $per_page);

        $ids = [];
        $result = $this->wpdb->get_results($this->query, ARRAY_A);
        foreach ($result as $id) {
            $ids[] = $id['id'];
        }

        $data = $this->prepare_result($ids);

        return $data;
    }

    /**
     * Get list ticket messages by user.
     * Currently, it is used for export personal data in GDPR
     *
     * @param $user_id user id of ticket author
     * @return array array of list ticket ID
     */
    public static function get_ticket_message_by_user($user_id)
    {
        global $wpdb;

        $sql = $wpdb->prepare("SELECT id FROM {$wpdb->prefix}alsp_ticket_messages WHERE author = %d ORDER BY id asc", $user_id);
        $result = $wpdb->get_results($sql);

        $ids = [];
        foreach ($result as $row) {
            $ids[] = $row->id;
        }

        return $ids;
    }
}

// EOF