<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2KzlrNFlMRGZxcWZSNDJJMXlRdm5tWHVVZjRlR29GS3pIU09vUm1hSVRxTWMxeGpOTkpMOEpsQ1MyTXVFOWd1bG5xbkpMNEd4MGc2a1ZkYlpIZFR4N0ZsSExWTWNVaFM4SkcyeUlVcGR6cjhBPT0=*/
class ALSP_Pro
{

	private static $instance;

	public static function get_instance()
	{
		return isset(self::$instance) ? self::$instance : self::$instance = new self;
	}

	private function __construct()
	{
        add_filter('alsp_is_pro', function($is_pro){
            return defined('ALSP_IS_PRO') ? ALSP_IS_PRO : 1;
        });

		add_filter('alsp_is_pro_valid', function () {
			$result = ALSP_Mayfly::get('license_valid');

			if (NULL === $result) {
				$result = ALSP_License::edd_check_license();
			}

			return $result;
		});

		add_action('init',[&$this, 'init']);
//		add_filter('alsp_getting_started', function ($content) {
//			$content['pro'] = 'Alternatively, you can <a target="_blank" href="' . admin_url('/admin.php?page=alsp#integrations') . '">enable one of the integrations</a> instead.';
//			return $content;
//		});

		add_filter('plugin_action_links_almighty-support/alsp.php',[&$this, 'update_plugin_links'], 10, 2);
	}

	public function init()
	{
		// Only display if current is admin
		if (ALSP_Utility_WP::user_is_admin()) {
			add_action('admin_notices', function () {
				if (apply_filters('alsp_is_pro', FALSE) &&!apply_filters('alsp_is_pro_valid', FALSE)) { ?>
					<div class="error alert">
						<strong>
							<a href="<?php echo admin_url('admin.php?page=alsp#license'); ?>">Please activate your license for Awedesk Pro!</a>
						</strong>
					</div>
					<?php
				}
			});
		}
	}

	/**
	 * Removes the activation link from the plugins table.
	 *
	 * @since 1.0.0
	 * @param array  $links
	 * @param string $plugin_file
	 * @return array
	 */
	public static function update_plugin_links($links, $plugin_file)
	{
		$plugin_file = explode('/', $plugin_file);
		$slug = reset($plugin_file);

		if ('almighty-support' === $slug) {
			$links['activate'] = __('Inactive &mdash; You\'ve got Awedesk (Pro)!', 'awedesk');
		}

		return $links;
	}
}


ALSP_Pro::get_instance();
