<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2OGpja2p6eXJ0SDI2cm1aWU54V2tXVjdqUW1EOUJGNzRWRmQ3Z2IyQ292RzNkcHhuODRBb2dSYkorUUNTMVNtd2J3b24wbmNSa0hhN1U1bTBYSzQzaDFHekx2ZXJBWVd5RGttbUlXWkZnY1I4OHhZdU5KY3J2OHk5aS9wb1l3Y2tzPQ==*/

class ALSP_Advanced_Email_Piping
{
    private static $instance = NULL;
    const CRON_EMAIL_PIPING = 'alsp_ep_import_emails_departments_event';

    public static function get_instance()
    {
        return (NULL == self::$instance) ? self::$instance = new self() : self::$instance;
    }

    private function __construct()
    {
        // Respect config attachment
        if (1 == ALSP_Config::get('attachment_enabled', 1)) {
            add_filter('alsp_ep_gmail_importer_attachments', ['ALSP_EP_Gmail_Importer_Attachments', 'parse_attachments'], 10, 3);
            add_filter('alsp_ep_imap_importer_attachments', ['ALSP_EP_Imap_Importer_Attachments', 'parse_attachments']);
            add_filter('alsp_ep_microsoft_exchange_importer_attachments', ['ALSP_EP_Microsoft_Exchange_Importer_Attachments', 'parse_attachments']);
        }

        // add_action('wp', function () {
        //     if (isset($_GET['alsp_process_import_emails_department'])) {
        //         ALSP_Advanced_Email_Piping::process_import_emails_departments();
        //         die();
        //     }
        // }, -1);

        // add_action('admin_init', function () {
        //     if (0 == ALSP_Config::get('cron_email_piping_department_enabled')) {
        //         if (!stristr(json_encode(_get_cron_array()), ALSP_Advanced_Email_Piping::CRON_EMAIL_PIPING)) {
        //             add_action('admin_notices',[$this, 'cron_email_piping_notice']);
        //         }
        //     }
        // });
    }

    public static function cron_email_piping_notice()
    {
        $result = FALSE;
        if (!wp_next_scheduled(ALSP_Advanced_Email_Piping::CRON_EMAIL_PIPING)) {
            $result = wp_schedule_event(current_time('timestamp', TRUE), 'five_minutes', ALSP_Advanced_Email_Piping::CRON_EMAIL_PIPING);
        }

        if (!$result || $result instanceof WP_Error) {
            echo '<div class="error alsp">' .
                 'Awedesk: "Department Based Email Piping" cron encountered some problems and was re-initialized.<br><small>If you see this message repeatedly, there might be something wrong with your WordPress Cron. Consider deactivating and re-activating Awedesk or contacting Support.</small>'
                . '</strong></div>';
        }
    }

    public static function process_import_emails_departments()
    {
        // Get list department
        $request = new WP_REST_Request;
        $model_department = new ALSP_Model_Departments($request);
        foreach ($model_department->read(1) as $key => $dept) {
            $prefix = 'dept' . $dept['id'] . '_';
            // Do not import while initialization process.
            if ('yes' === get_transient($prefix . 'alsp_ep_connection_init')) {
                continue;
            }

            if (!ALSP_Config::get($prefix . 'ep_enabled', 0)) {
                continue;
            }

            $ep_connection = ALSP_Config::get($prefix . 'ep_connection_select', 'imap');
            $connection_class = isset(ALSP_Email_Piping::$piping_connections[$ep_connection]) ? ALSP_Email_Piping::$piping_connections[$ep_connection]['class'] : '';
            if ($connection_class && class_exists($connection_class)) {
                $connection_class::import($dept['id']);
            }
        }
    }
}

ALSP_Advanced_Email_Piping::get_instance();

// EOF
