<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2OElTUFNJT21qQzJoY01rWXNFakpqZ3NiUnprOU9nS0h3a21pci95NmsxOUtiZXdiQ1NRMWRTdDZSUldPdGlxS09yOEVNRDlUMUZUaW1kZGVyems4cmpqUkp5RUdCTENKak4yTldWSXRyR3drMEt2WU9BYlB2RnovYjdoc1lINlVVNzRLQXNpS2FwZVFOLytzWTF6NG9E*/

class ALSP_EP_Gmail_Importer_Attachments
{
    /**
     * Return attachments for email
     *
     * @param object        $payload - payload.
     * @param string        $message_id - id.
     * @return array
     */
    public static function parse_attachments($access_token, $payload, $message_id)
    {

        $attachments = [];
        $parts = isset($payload->parts) ? $payload->parts : [];

        foreach ($parts as $part) {

            if (isset($part->filename) && $part->filename) {
                $file_name = $part->filename;
                $attachment_id = $part->body->attachmentId;

                // $key = array_search('Content-Id', array_column($part->headers, 'name'));
                // if (!empty($key) || $key > 0) {
                //     $content_id = $part->headers[$key]['value'];
                //     $content_id = trim(str_replace(array('<', '>'), ['', ''], $content_id));
                // }

                // if ($body_preference == 'html' && $content_id && preg_match('/cid:' . $content_id . '/', $email->html_body)) { //phpcs:ignore
                //     self::upload_embeded_img($file_name, $attachment_id, $message_id, $email, $content_id);
                // } else {
                $attachments[] = self::get_attachment_id($access_token, $file_name, $attachment_id, $message_id);
                // }
            }

            if (isset($part->parts)) {

                foreach ($part->parts as $prt) {
                    if (isset($prt->filename) && $prt->filename) {
                        $file_name = $prt->filename;
                        $attachment_id = $prt->body->attachmentId;

                        // $key = array_search('Content-Id', array_column($prt->headers, 'name'));
                        // if (!empty($key) || $key > 0) {
                        //     $content_id = $prt->headers->$key['value'];
                        //     $content_id = trim(str_replace(array('<', '>'), ['', ''], $content_id));
                        // }

                        // if ($body_preference == 'html' && $content_id && preg_match('/cid:' . $content_id . '/', $email->html_body)) { //phpcs:ignore
                        //     self::upload_embeded_img($file_name, $attachment_id, $message_id, $email, $content_id);
                        // } else {
                        $attachments[] = self::get_attachment_id($access_token, $file_name, $attachment_id, $message_id);
                        // }
                    }
                }

                if (isset($prt->parts)) {

                    foreach ($prt->parts as $p1) {
                        if (isset($p1->filename) && $p1->filename) {
                            $file_name = $p1->filename;
                            $attachment_id = $p1->body->attachmentId;

                            // $key = array_search('Content-Id', array_column($p1['headers'], 'name'));
                            // if (!empty($key) || $key > 0) {
                            //     $content_id = $p1['headers'][$key]['value'];
                            //     $content_id = trim(str_replace(array('<', '>'),['', ''], $content_id));
                            // }

                            // @TODO: import embeded image
                            // if ($body_preference == 'html' && $content_id && preg_match('/cid:' . $content_id . '/', $email->html_body)) { //phpcs:ignore
                            //     self::upload_embeded_img($file_name, $attachment_id, $message_id, $email, $content_id);
                            // } else {
                            $attachments[] = self::get_attachment_id($access_token, $file_name, $attachment_id, $message_id);
                            // }
                        }
                    }
                }
            }
        }

        return $attachments;
    }

    /**
     * Return ALSP Attachment id for parsed attachments
     *
     * @param string $file_name - file_name.
     * @param string $attachment_id - attachment_id.
     * @param string $message_id - message_id.
     * @return array id
     */
    private static function get_attachment_id($access_token, $file_name, $attachment_id, $message_id)
    {
        $email_address = ALSP_Config::get('ep_gmail_email_label');
        $response = wp_remote_post(
            'https://www.googleapis.com/gmail/v1/users/' . $email_address . '/messages/' . $message_id . '/attachments/' . $attachment_id,
            [
                'method' => 'GET',
                'timeout' => 45,
                'redirection' => 5,
                'httpversion' => '1.0',
                'blocking' => true,
                'headers' => [],
                'body' => [
                    'access_token' => $access_token,
                ],
                'cookies' => [],
            ]
        );

        if (is_wp_error($response)) {
            return ['file_name' => $file_name, 'status' => FALSE, 'error' => 'wp_remote_post()'];
        }
        $attachment = json_decode($response['body'], true);

        // saperate file name and extension.
        $filename = explode('.', $file_name);
        $extension = strtolower($filename[count($filename) - 1]);
        unset($filename[count($filename) - 1]);
        $filename = implode('.', $filename);
        $filename = str_replace(' ', '_', $filename);
        $filename = str_replace(',', '_', $filename);
        $filename = uniqid() . '_' . preg_replace('/[^A-Za-z0-9\-]/', '', $filename);

        // allowed file extenstions.
        $allowed_file_extensions = ALSP_Config::get('attachment_allowed_file_types_textarea');
        $allowed_file_extensions = explode(',', $allowed_file_extensions);
        $allowed_file_extensions = array_map('trim', $allowed_file_extensions);
        $allowed_file_extensions = array_map('strtolower', $allowed_file_extensions);
        if (!(in_array($extension, $allowed_file_extensions))) {
            return ['file_name' => $file_name, 'status' => FALSE, 'error' => __('File extension not allowed!', 'awedesk')];
        }

        // Write to temp folder
        $tmp_dir = ALSP_Attachments::get_tmp_dir();
        if (!file_exists($tmp_dir)) {
            mkdir($tmp_dir, 0755, true);
        }
        $destination = $tmp_dir . $filename . '.' . $extension;

        // write file.
        $file_contents = strtr(
            $attachment['data'],
            [
                '-' => '+',
                '_' => '/',
            ]
        );

        $filesize = (int) (strlen(rtrim($file_contents, '=')) * 3 / 4);

        // check for allowed file size.
        $max_upload_size = ALSP_Config::get('attachment_max_filesize_number');

        // use WP max upload size if it is smaller than PeepSo max upload size
        $wp_max_size = max(wp_max_upload_size(), 0);
        $wp_max_size /= pow(1024, 2);
        if ($wp_max_size < $max_upload_size) {
            $max_upload_size = $wp_max_size;
        }

        $allowed_file_size = intval($max_upload_size) * 1048576;
        if ($filesize >= $allowed_file_size) { //phpcs:ignore
            return ['file_name' => $file_name, 'status' => FALSE, 'error' => __('File size exceeds allowed limit!', 'awedesk')];
        }

        file_put_contents($destination, base64_decode($file_contents)); //phpcs:ignore

        return ['file_name' => $filename . '.' . $extension, 'status' => TRUE];
    }

    /**
     * Return ALSP Attachment id for parsed attachments
     *
     * @param string        $file_name - file_name.
     * @param string        $attachment_id - attachment_id.
     * @param string        $message_id - message_id.
     * @return void|string
     */
    private static function upload_embeded_img($access_token, $file_name, $attachment_id, $message_id)
    {
        $email_address = ALSP_Config::get('ep_gmail_email_label');
        $response = wp_remote_post(
            'https://www.googleapis.com/gmail/v1/users/' . $email_address . '/messages/' . $message_id . '/attachments/' . $attachment_id,
            [
                'method' => 'GET',
                'timeout' => 45,
                'redirection' => 5,
                'httpversion' => '1.0',
                'blocking' => true,
                'headers' => [],
                'body' => [
                    'access_token' => $access_token,
                ],
                'cookies' => [],
            ]
        );

        if (is_wp_error($response)) {
            return;
        }
        $attachment = json_decode($response['body'], true);

        // saperate file name and extension.
        $filename = explode('.', $file_name);
        $extension = strtolower($filename[count($filename) - 1]);
        unset($filename[count($filename) - 1]);
        $filename = implode('.', $filename);
        $filename = str_replace(' ', '_', $filename);
        $filename = str_replace(',', '_', $filename);
        $filename = uniqid() . '_' . preg_replace('/[^A-Za-z0-9\-]/', '', $filename);

        // allowed file extenstions.
        $img_extensions = ['png', 'jpeg', 'jpg', 'gif'];
        if (!(in_array($extension, $img_extensions))) {
            self::get_attachment_id($access_token, $file_name, $attachment_id, $message_id);
        }

        // Write to temp folder
        $tmp_dir = ALSP_Attachments::get_tmp_dir();
        if (!file_exists($tmp_dir)) {
            mkdir($tmp_dir, 0755, true);
        }
        $destination = $tmp_dir . $filename . '.' . $extension;

        // write file.
        $file_contents = strtr(
            $attachment['data'],
            [
                '-' => '+',
                '_' => '/',
            ]
        );
        file_put_contents($destination, base64_decode($file_contents)); //phpcs:ignore

        // insert db record and return id.
        // $attach = ALSP_Attachment::insert($data);
        // if ($attach->id) {
        //     $img_url = home_url('/') . '?wpsc_attachment=' . $attach->id;
        //     $email->html_body = str_replace('cid:' . $content_id, $img_url, $email->html_body); //phpcs:ignore
        // }

        return $filename . '.' . $extension;
    }

}

// EOF