<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2OFFRdG14Q2gxdER3aEZYNUdsNHl4b0hKcU1FZlN6cUFuSzQ5Rjd3dWZLY0kwanJIWnpOVVFybi8vNllFL1pPeWNPbzg2Uk1FcnRFRWlYVm05czUzcDI5dllGOFAwOVBKYzl3b0J2T3JDYUI2Ulk2bnFvY1RjMFZLZ0VMeXcrM21VPQ==*/

class ALSP_Config_Department_EP
{
    private static $instance = NULL;

    public static function get_instance()
    {
        return (NULL == self::$instance) ? self::$instance = new self() : self::$instance;
    }

    private function __construct()
    {
        add_action('alsp_template_insert', [&$this, 'insert_template']);

        add_filter('alsp_config', function ($config, $position) {
            if (strpos($position, 'department-config-' === FALSE)) {
                return $config;
            }

            $piping_connections = [];
            foreach (ALSP_Email_Piping::$piping_connections as $key => $value) {
                $piping_connections[$key] = $value['label'];
            }

            $request = new WP_REST_Request;
            $model_department = new ALSP_Model_Departments($request);
            foreach ($model_department->read() as $key => $dept) {
                if (!isset($dept['id']) && !$dept['id']) {
                    continue;
                }

                $prefix = 'dept' . $dept['id'] . '_';
                $config['email_piping_' . $dept['id']] = [
                    'id' => 'email_piping_' . $dept['id'],
                    'title' => __('Email Piping', 'awedesk'),
                    'icon' => 'alsp-i-inbox-in',
                    'position' => 'department-config-' . $dept['id'],
                    'items' => [
                        $prefix . 'ep_enabled' => ALSP_Config_Panel::admin_item($prefix . 'ep_enabled', FALSE, __('Enabled', 'awedesk')),
                        $prefix . 'ep_connection_select' => ALSP_Config_Panel::admin_item($prefix . 'ep_connection_select', $prefix . 'ep_enabled', __('Connection', 'awedesk'), ['options' => apply_filters('alsp_ep_connection_select', $piping_connections)]),
                    ],
                ];
            }

            return $config;
        }, 10, 2);
    }

    public function insert_template($template)
    {
        if ('admin_departments_item' === $template) {
            $assets = ALSP_Frontend_Assets::get_instance();
            echo $assets->get_template('pro/admin/departments_item_ep');
        }
    }
}

// ALSP_Config_Department_EP::get_instance();

// EOF
