<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2OFFRdG14Q2gxdER3aEZYNUdsNHl4b1FBNW43ZCtEQlhUMk1hYm0rQkwzZ0tTSEhCVE5yZDluaGVCdllRM0YrZ1lQR2pMZnpDVHduVEVhb2Zmc3RzWml0OEhEbUVmR0tWTktlMVJyV2VJZm1TSkJZNVlTTm15V0hJR29MUVVNQlkrdzFZU0xCZjlXakN0R1orU0NyWWJK*/

class ALSP_Config_Department_EP_Cron
{
    private static $instance;

    public static function get_instance()
    {
        return isset(self::$instance) ? self::$instance : self::$instance = new self;
    }

    private function __construct()
    {
        add_filter('alsp_config_description', function ($desc) {
            $desc['cron_email_piping_department_enabled'] = $desc['cron_mailqueue_enabled'];

            return $desc;
        }, 30);

        add_filter('alsp_config', function ($config, $position) {
            if (isset($config['cron'])) {
                $cron_items = $config['cron']['items'];
                if (count($cron_items)) {
                    $cron_items = array_merge($cron_items, [
                        'cron_email_piping_department_enabled' => ALSP_Config_Panel::admin_item('cron_email_piping_department_enabled', FALSE, __('Email piping for department', 'awedesk')),
                    ]);
                }

                $config['cron']['items'] = $cron_items;
            }

            return $config;
        }, 30, 2);

        add_action('alsp_cron_init', function () {
            if (0 == ALSP_Config::get('cron_email_piping_department_enabled', 0)) {
                add_action(ALSP_Advanced_Email_Piping::CRON_EMAIL_PIPING, ['ALSP_Advanced_Email_Piping', 'process_import_emails_departments']);
            }
        });
    }
}

// ALSP_Config_Department_EP_Cron::get_instance();

// EOF