<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2OFFRdG14Q2gxdER3aEZYNUdsNHl4bzAwNm5iL2U2bWtGVUllcnN0aEt0cmtqTTB6SGVDMzJRVWUzU2t2OG5kME9VUFFGVVJ1dC9XUm1lNXFENUZkZHBTc0ZUMmdUK1VuYi9rUGFUcEpJZGlKdE9kOTVraVFVQlRwYnB3eC9BQ2VZazg3eUJlREJ5bHFGc3RkK0VCMktv*/

class ALSP_Config_Department_EP_Gmail
{
    private static $instance = NULL;

    public static function get_instance()
    {
        return (NULL == self::$instance) ? self::$instance = new self() : self::$instance;
    }

    private function __construct()
    {
        add_filter('alsp_config_description', function ($desc) {

            $request = new WP_REST_Request;
            $model_department = new ALSP_Model_Departments($request);
            foreach ($model_department->read() as $key => $dept) {
                if (!isset($dept['id']) && !$dept['id']) {
                    continue;
                }

                $prefix = 'dept' . $dept['id'] . '_';
                $desc[$prefix . 'ep_gmail_email_label'] = FALSE;
                $desc[$prefix . 'ep_gmail_client_id_label'] = FALSE;
                $desc[$prefix . 'ep_gmail_client_secret_label'] = FALSE;
                $desc[$prefix . 'ep_gmail_js_origin_label'] = FALSE;
                $desc[$prefix . 'ep_gmail_redirect_uri_label'] = FALSE;
                $desc[$prefix . 'ep_gmail_is_active_label'] = FALSE;
                $desc[$prefix . 'ep_gmail_history_id_label'] = FALSE;
                $desc[$prefix . 'ep_gmail_last_error_label'] = FALSE;
                $desc[$prefix . 'ep_gmail_message'] = '<div class="alsp-opt__form-actions">
                    <button class="alsp-opt__action alsp-btn alsp-btn--action" data-id="ep_gmail_check" data-btn="check" data-tooltip="Check" style="">
                        <i class="alsp-i-plug"></i> Check
                        <i class="alsp-i-spinner alsp-i-spin" data-loading style="display:none"></i>
                    </button>
                </div>';
            }

            return $desc;
        });

        add_filter('alsp_config', function ($config, $position) {
            if (strpos($position, 'department-config-' === FALSE)) {
                return $config;
            }

            $url = wp_parse_url(home_url());

            $request = new WP_REST_Request;
            $model_department = new ALSP_Model_Departments($request);
            foreach ($model_department->read() as $key => $dept) {
                if (!isset($dept['id']) && !$dept['id']) {
                    continue;
                }

                $prefix = 'dept' . $dept['id'] . '_';
                $dep = $prefix . 'ep_connection_select=gmail';
                $history_id = ALSP_Config::get($prefix . 'ep_gmail_history_id', 0);
                $is_active = ALSP_Config::get($prefix . 'ep_gmail_is_active', 0);
                $status = $is_active ? __('Connected', 'awedesk') : __('Not Connected', 'awedesk');
                $last_error = ALSP_Config::get($prefix . 'ep_gmail_last_error', '');

                $config['department-config-gmail-conn-' . $dept['id']] = [
                    'id' => 'department_config_gmail_conn-' . $dept['id'],
                    'title' => 'Gmail',
                    'icon' => 'alsp-i-clip',
                    'description' => sprintf(__('Configure connection: %s', 'awedesk'), 'GMail'),
                    'position' => 'department-config-' . $dept['id'],
                    'items' => [
                        $prefix . 'ep_gmail_email_label' => ALSP_Config_Panel::admin_item($prefix . 'ep_gmail_email_label', $dep, __('Email', 'awedesk')),
                        $prefix . 'ep_gmail_client_id_label' => ALSP_Config_Panel::admin_item($prefix . 'ep_gmail_client_id_label', $dep, __('Client ID', 'awedesk')),
                        $prefix . 'ep_gmail_client_secret_label' => ALSP_Config_Panel::admin_item($prefix . 'ep_gmail_client_secret_label', $dep, __('Client Secret', 'awedesk')),
                        $prefix . 'ep_gmail_js_origin_label' => ALSP_Config_Panel::admin_item($prefix . 'ep_gmail_js_origin_label', $dep, __('Authorized Javascript Origin', 'awedesk'), ['default_value' => esc_url($url['scheme'] . '://' . $url['host']), 'disabled' => TRUE]),
                        $prefix . 'ep_gmail_redirect_uri_label' => ALSP_Config_Panel::admin_item($prefix . 'ep_gmail_redirect_uri_label', $dep, __('Authorized Redirect URI', 'awedesk'), ['default_value' => esc_url(admin_url('admin.php')), 'disabled' => TRUE]),
                        $prefix . 'ep_gmail_is_active_label' => ALSP_Config_Panel::admin_item($prefix . 'ep_gmail_is_active_label', $dep, __('Status', 'awedesk'), ['default_value' => $status, 'disabled' => TRUE]),
                        $prefix . 'ep_gmail_history_id_label' => ALSP_Config_Panel::admin_item($prefix . 'ep_gmail_history_id_label', $dep, __('Last History ID', 'awedesk'), ['default_value' => $history_id, 'disabled' => TRUE]),
                        $prefix . 'ep_gmail_last_error_label' => ALSP_Config_Panel::admin_item($prefix . 'ep_gmail_last_error_label', $dep, __('Last Error', 'awedesk'), ['default_value' => $last_error, 'disabled' => TRUE]),
                        $prefix . 'ep_gmail_message' => ALSP_Config_Panel::admin_item($prefix . 'ep_gmail_message', $dep, FALSE),
                    ],
                ];
            }

            return $config;
        }, 32, 2);

        // gmail process connection response.
        add_action('admin_init', ['ALSP_Config_EP_Config_Connection_Checker', 'process_response_gmail']);
    }
}

// ALSP_Config_Department_EP_Gmail::get_instance();

// EOF
