<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2OGJEanNERENKOXYyTGp0VFhSWDkzTmlYY1BTWXBXSWNhMUJxS2ZtVFVURWhkTkNscUlDbUlaSXhtSEt5MG0xYVRHWDJ3L1pJUEQwOXVHUC9ncDJoTHduTVdMV1B6S2VRbVdYV1RWSWxNeFkwNmUxR2oxVVhhbStTNUlMTlY2ZXRzPQ==*/

class ALSP_Config_App
{
    private static $instance;

    public static function get_instance()
    {
        return isset(self::$instance) ? self::$instance : self::$instance = new self;
    }

    private function __construct()
    {

        add_filter('alsp_config_menu', function ($menu) {
            $menu['app'] = [
                'id' => 'app',
                'label' => __('App', 'awedesk'),
                'icon' => 'alsp-i-mobile-notch',
            ];

            return $menu;
        }, 10);

        add_filter('alsp_config_description', function ($desc) {
            $desc['app_name_label'] = __('Leave empty for the default value', 'awedesk'). ' ('.__('defaults to site title', 'awedesk').')';
            $desc['app_logo_image'] = __('Square PNG or JPG. Will be cropped to a circle', 'awedesk').'. <br>'.__('Must be compatible with dark and light backgrounds', 'awedesk');
	        $desc['app_color'] = __('Must be compatible with dark and light backgrounds', 'awedesk');
	        $desc['app_push_enabled'] = __('Requires a subscription to Awedesk Push Service', 'awedesk');
            return $desc;
        });

        add_filter('alsp_config', function ($config, $position) {
            if ($position !== 'app-left') {
                return $config;
            }

            $config['app'] = [
                'id' => 'app',
                'title' => __('App', 'awedesk'),
                'icon' => 'alsp-i-mobile-notch',
                'position' => 'app-left',
                'items' => [
                    'app_enabled' => ALSP_Config_Panel::admin_item('app_enabled'),
                    'app_name_label' => ALSP_Config_Panel::admin_item('app_name_label','app_enabled', __('Name', 'awedesk')),
                    'app_logo_image' => ALSP_Config_Panel::admin_item('app_logo_image', 'app_enabled', __('Logo', 'awedesk')),
                    'app_color' => ALSP_Config_Panel::admin_item('app_color', 'app_enabled', __('Color', 'awedesk')),
	                'app_push_enabled' => ALSP_Config_Panel::admin_item('app_push_enabled', 'app_enabled', __('Push notifications', 'awedesk')),
                ],
            ];


            return $config;
        }, 20, 2);
    }
}
add_action('init', function() {
    if (apply_filters('alsp_is_pro', FALSE)) {
        ALSP_Config_App::get_instance();
    }
});
// EOF
