<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2OHoxRlVXV0FCZ0tYd0dFM1pWcVlGNGl3U00zSlo2MjhGYk1kRml5TWdXSUNyY2MzYkpnYzNzOVVGTjNLSzdTdTdpMWx2MTRpakU4RVZhbnA0c0VrT21HRDl4L013OFBQeVlpL2RQUE9ReVVnPT0=*/

class ALSP_Config_Attachment_Cron
{
    private static $instance;

    public static function get_instance()
    {
        return isset(self::$instance) ? self::$instance : self::$instance = new self;
    }

    private function __construct()
    {
        add_filter('alsp_config_description', function ($desc) {
            $desc['cron_attachment_cleanup_enabled'] = $desc['cron_mailqueue_enabled'];
            $desc['cron_temp_cleanup_enabled'] = $desc['cron_mailqueue_enabled'];

            return $desc;
        }, 30);

        add_filter('alsp_config', function ($config, $position) {
            if (isset($config['cron']) && apply_filters('alsp_is_pro', FALSE)) {
                $cron_items = $config['cron']['items'];
                if (count($cron_items)) {
                    $cron_items = array_merge($cron_items, [
                        'cron_attachment_cleanup_enabled' => ALSP_Config_Panel::admin_item('cron_attachment_cleanup_enabled', FALSE, __('Cleanup Attachments', 'awedesk')),
                        'cron_temp_cleanup_enabled' => ALSP_Config_Panel::admin_item('cron_temp_cleanup_enabled', FALSE, __('Cleanup Temp Folder', 'awedesk')),
                    ]);
                }

                $config['cron']['items'] = $cron_items;
            }
            return $config;
        }, 30, 2);

        add_filter('alsp_cron_interval_config', function ($config) {

            if(apply_filters('alsp_is_pro', FALSE)) {
                $config = array_merge($config, [
                    'cron_temp_cleanup_interval_number' => ALSP_Config_Panel::admin_item(
                        'cron_temp_cleanup_interval_number',
                        FALSE,
                        __('Temp folder cleanup after', 'awedesk'),
                        ['default_value' => 3, 'min' => 1, 'max' => 365, 'after' => __('days', 'awedesk')],
                    ),
                ]);
            }
            return $config;
        }, 10, 1);

        add_action('alsp_cron_init', function () {
            if (0 == ALSP_Config::get('cron_attachment_cleanup_enabled', 0)) {
                add_action(ALSP_Attachments::CRON_ATTACHMENT_CLEANUP,['ALSP_Attachments', 'attachment_cleanup']);
            }

            if (0 == ALSP_Config::get('cron_temp_cleanup_enabled', 0)) {
                add_action(ALSP_Attachments::CRON_TEMP_CLEANUP, ['ALSP_Attachments', 'temp_cleanup']);
            }
        });
    }
}

ALSP_Config_Attachment_Cron::get_instance();

// EOF