<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2OEdoUE4vK0p3cG5RWmtXOFJnWU1RVVB1UnBZVVFNdXRUS0VaZ2FJbUc3NFRoeTY3VDFEZTMrRWRlRkF3QzFzV2ptZHhlZnRyS3RpcVZzSExNNkhjV0p1UGlUcCtoNDZGVTFuU1pLTUdjbGlGcUZHYkdlM3pLOE1PYWgyV2p6RzRrPQ==*/

class ALSP_Config_Ticket_Attachments
{
    private static $instance;

    public static function get_instance()
    {
        return isset(self::$instance) ? self::$instance : self::$instance = new self;
    }

    private function __construct()
    {
        add_filter('alsp_config_description', function ($desc) {
            $desc['attachment_allowed_file_types_textarea'] = sprintf(__('Comma-separated list: %s. Case insensitive.', 'awedesk'), '<code>pdf, jpg, zip</code>');
            $desc['attachment_delete_file_interval_day_number'] = __('Countdown starts when a ticket is closed.', 'awedesk');
            $desc['attachment_max_filesize_number'] = __('Limits the size of a single attachment.', 'awedesk'). ' ' .__('Does not apply to agents, managers and admins','awedesk');
            $desc['attachment_max_user_quota_number'] = __('How many attachments each user is allowed total, in all their tickets.', 'awedesk'). ' ' .__('Does not apply to agents, managers and admins','awedesk');

            return $desc;
        }, 30);

        add_filter('alsp_config', function ($config, $position) {
            if ($position !== 'advanced-left') {
                return $config;
            }

            $config['attachment'] = [
                'id' => 'attachment',
                'title' => __('Attachments', 'awedesk'),
                'icon' => 'alsp-i-clip',
                'position' => 'advanced-left',
                'items' => [
                    'attachment_enabled' => ALSP_Config_Panel::admin_item('attachment_enabled', FALSE, __('Enabled', 'awedesk')),
                    'attachment_max_filesize_number' => ALSP_Config_Panel::admin_item('attachment_max_filesize_number', 'attachment_enabled', __('Maximum size', 'awedesk'), ['after' => 'MB', 'min' => 1]),
                    'attachment_max_user_quota_number' => ALSP_Config_Panel::admin_item('attachment_max_user_quota_number', 'attachment_enabled', __('User storage limit', 'awedesk'), ['after' => 'files', 'min' => 1]),
                    'attachment_allowed_file_types_textarea' => ALSP_Config_Panel::admin_item('attachment_allowed_file_types_textarea', 'attachment_enabled', __('Allowed file types', 'awedesk')),
                    'attachment_delete_file_interval_day_number' => ALSP_Config_Panel::admin_item('attachment_delete_file_interval_day_number', 'attachment_enabled', __('Delete after', 'awedesk'), ['after' => __('days', 'awedesk'), 'min' => 1, 'max' => 90]),
                ],
            ];
            return $config;
        }, 30, 2);
    }
}
add_action('init', function() {
    if (apply_filters('alsp_is_pro', FALSE)) {
        ALSP_Config_Ticket_Attachments::get_instance();
    }
});
// EOF
