<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2LzR4WUhCMmZkV0NEM3B4OGVpSlE0U2E4YXlnUkUrcDFZdWZZMHluaG44L2cvOCtsUzBRWFlWU3lxQXZOR0hmR1ZlU2hXaXRJTHB6VCs2SVo1WHJwTzdFb0hqOFNPSW9Sc2JyQkpNRVNEVEtyWW9xejAvMXhuc3NXb2JCQkZiVTdJPQ==*/

class ALSP_EDD_Integrations
{
    private static $instance = NULL;

    public static function get_instance()
    {
        return (NULL == self::$instance) ? self::$instance = new self() : self::$instance;
    }

    private function __construct()
    {
        if(apply_filters('awecloud_is_client', FALSE)) { return; }
        add_filter('alsp_config_menu', function ($menu) {

            $menu['integrations'] = [
                'id' => 'integrations',
                'label' => __('Integrations', 'awedesk'),
                'icon' => 'alsp-i-code-compare',
            ];

            return $menu;
        }, 30);

        add_filter('alsp_config_description', function ($desc) {
            $desc['edd_integration_rest_public_key_label'] = '';
            $desc['edd_integration_rest_token_label'] = '';

            return $desc;
        }, 30);

        add_filter('alsp_config', function ($config, $position) {
            if ($position !== 'integrations-left') {
                return $config;
            }

            $config['integrations_edd'] = [
                'id' => 'integrations_edd',
                'title' => 'Easy Digital Downloads',
                'icon' => 'alsp-i-inbox-in',
                'position' => 'integrations-left',
                'items' => [
                    'edd_integration_enabled' => ALSP_Config_Panel::admin_item('edd_integration_enabled'),
                ],
            ];
            return $config;
        }, 30, 2);

        add_filter('edd_customer_tabs', function($tabs){
            $page_id_client = ALSP_Config::get('support_page_client_select', -1);
            $page_id_agent = ALSP_Config::get('support_page_agent_select', $page_id_client, TRUE);
            $user_id = (new EDD_Customer(intval($_GET['id'])))->user_id;
            $user_tickets = home_url() . '/?page_id=' . $page_id_agent . '#tickets/open,client=' . $user_id;

            $tabs['alsp'] = [
                'dashicon' => 'sos',
                'title' => __('Tickets', 'awedesk')
                . '<span data-alsp="link-user-tickets" data-href="' . esc_attr($user_tickets) . '"></span>',
            ];

            return $tabs;
        }, PHP_INT_MAX-10,1);

        add_filter('edd_customer_views', function($views){
            $views['alsp'] = ['ALSP_EDD_Integrations','profile_tab'];
            return $views;
        });


        if (ALSP_Config::get('edd_integration_enabled', 0)) {
            add_action('alsp_template_insert', [&$this, 'insert_template']);
        }

        add_action('admin_enqueue_scripts', function() {
            if (ALSP_Config::get('edd_integration_enabled', 0)) {
                $current_screen = get_current_screen();
                if ($current_screen && $current_screen->id === 'download_page_edd-customers') {
                    $assets = ALSP_Frontend_Assets::get_instance();
                    wp_enqueue_script('alsp-edd-customer', $assets->get_assets_url("pro/js/admin/external-edd-customer.js"),
                        ['jquery'], ALSP::PLUGIN_VERSION, true);
                }
            }
        });
    }

    public  static function profile_tab($customer) {}

    public function insert_template($template)
    {
        if ('ticket/sidebar/1' === $template) {
            $assets = ALSP_Frontend_Assets::get_instance();
            echo $assets->get_template('pro/ticket/sidebar_edd_summary');
        } else if ('ticket/sidebar/2' === $template) {
            $assets = ALSP_Frontend_Assets::get_instance();
            echo $assets->get_template('pro/ticket/sidebar_edd_detail');
        }
    }
}
add_action('init', function() {
    if (apply_filters('alsp_is_pro', FALSE)) {
        ALSP_EDD_Integrations::get_instance();
    }
});
// EOF
