<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2OHFxM0hzQ1hqbmsxVTlBWUhYaUtDdXRldTNUeVhpTG1hRXVlRTZPQmJCUGNkMnB2RWZ5dlBQVExyb25CQzFYbU1aVHh5RS93N2daN0Z0WVpZUjUzYlM0eHJsc3I0TG9qQ09ZeUNqQnR2NHlHczdwQkJiWDlNN1BTVm5xWDRqbDlVPQ==*/

class ALSP_Config_Slack
{
    private static $instance = NULL;

    public static function get_instance()
    {
        return (NULL == self::$instance) ? self::$instance = new self() : self::$instance;
    }

    private function __construct()
    {
        add_filter('alsp_config_menu', function ($menu) {
            $menu['integrations'] = [
                'id' => 'integrations',
                'label' => __('Integrations', 'awedesk'),
                'icon' => 'alsp-i-code-compare',
            ];

            return $menu;
        }, 30);

        add_filter('alsp_config_description', function ($desc) {
            $desc['slack_webhook_label'] = sprintf(__('You can create an "incoming webhook" in %s.','awedesk'), '<a href="https://api.slack.com/apps" target="_blank">Slack</a>');
            return $desc;
        });

        add_filter('alsp_config', function ($config, $position) {
            if ($position !== 'integrations-left' && $position !== 'integrations-right') {
                return $config;
            }

            $config['slack'] = [
                'id' => 'slack',
                'title' => __('Slack', 'awedesk'),
                'icon' => 'alsp-i-slack',
                'position' => 'integrations-left',
                'items' => [
                    'slack_separator'  => ALSP_Config_Panel::admin_item('slack_separator', FALSE, __('General', 'awedesk')),
                    'slack_enabled' => ALSP_Config_Panel::admin_item('slack_enabled'),
                    'slack_webhook_label' => ALSP_Config_Panel::admin_item('slack_webhook_label', 'slack_enabled', 'Webhook URL'),
//                    'events_separator'  => ALSP_Config_Panel::admin_item('events_separator', FALSE, __('Events', 'awedesk')),
                ],
            ];

            $events = [
                'ticket_new' => __('New ticket', 'awedesk'),
                'ticket_reply' => __('New reply', 'awedesk'),
                'ticket_closed' => __('Ticket closed', 'awedesk'),
                'ticket_reopened' => __('Ticket re-opened', 'awedesk'),
                'agent_changed' => __('Assignee changed', 'awedesk'),
                'department_changed' => __('Department changed', 'awedesk'),
            ];
            $config['slack_events'] = [
                'id' => 'slack_events',
                'title' => __('Events', 'awedesk'),
                'icon' => 'alsp-i-slack',
                'position' => 'integrations-left',
                'items' => [
                ],
            ];

            foreach($events as $key => $label) {
                $separator = 'events_separator_'.$key.'_separator';
                $enabled = 'slack_event_'.$key.'_enabled';
                $template = 'slack_event_'.$key.'_template';
                $config['slack']['items'][$separator] = ALSP_Config_Panel::admin_item($separator, 'slack_enabled', $label);
                $config['slack']['items'][$enabled] = ALSP_Config_Panel::admin_item($enabled, 'slack_enabled');
                $config['slack']['items'][$template] = ALSP_Config_Panel::admin_item($template, $enabled);

            }

            return $config;
        }, 99, 2);
    }

}
add_action('init', function() {
    if (apply_filters('alsp_is_pro', FALSE)) {
        ALSP_Config_Slack::get_instance();
    }
});

// EOF
