<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2K1czMEhJYkdnZ2ZTZjc0bmVtcE1BaDRPVEtUaGoxcDFFUmQvR3lQbG5LUk50aGxmblJYbmE0SEI0RGg0OFFwWm9KdzQ5bDRwb3VkcXV4TVpFb0Q3WGJTZCtySDdGdGY0bmViZ20rbTY0QStXVXphZUgrUE55cHc0Umh0RVdZMURVPQ==*/

class ALSP_Config_Notes
{
    private static $instance;

    public static function get_instance()
    {
        return isset(self::$instance) ? self::$instance : self::$instance = new self;
    }

    private function __construct()
    {
        add_filter('alsp_config_menu', function ($menu) {
            $menu['notes'] = [
                'id' => 'notes',
                'label' => __('Notes', 'awedesk'),
                'icon' => 'alsp-i-signature-pencil',
            ];

            return $menu;
        }, 10);

        add_filter('alsp_config_description', function ($desc) {

            $desc['secret_enabled_message'] = ''
                .__('Ticket will have a private note field visible and editable by the client and the staff.','awedesk')
                .'<br/>'
                .__('Clients can use this feature to provide sensitive information such as passwords.','awedesk')
                .'<br/>'
                .__('Private notes are deleted after the ticket is closed.','awedesk')
                ;

            $desc['staff_notes_message'] = ''
                .__('Staff notes are visible and editable only by the staff.','awedesk')
                .'<br/>'
                .__('Notes about the client show in all the client\'s tickets.','awedesk')
                .'<br/>'
                .__('Notes about the ticket show only in this specific ticket.','awedesk')
            ;

            return $desc;
        });

        add_filter('alsp_config', function ($config, $position) {
            if ($position !== 'notes-left' && $position !== 'notes-right') {
                return $config;
            }

			// LEFT
	        $items = [];
            $items['secret_enabled_message'] = ALSP_Config_Panel::admin_item('secret_enabled_message');
            $items['secret_enabled'] = ALSP_Config_Panel::admin_item('secret_enabled');
            $items['secret_delete_interval_number'] = ALSP_Config_Panel::admin_item(
                        'secret_delete_interval_number',
                        'secret_enabled',
                        __('Delete after', 'awedesk'),
                        ['min' => 1, 'max' => 365, 'after' => __('days', 'awedesk')],
                    );

            $config['notes'] = [
                'id' => 'notes',
                'title' => __('Private Notes', 'awedesk'),
                'icon' => 'alsp-i-file-signature',
                'position' => 'notes-left',
                'items' => $items,
            ];

            // RIGHT
            $items = [];

            $items['staff_notes_message'] = ALSP_Config_Panel::admin_item('staff_notes_message');

            $items['staff_notes_clients_separator'] = ALSP_Config_Panel::admin_item('staff_notes_clients_separator', FALSE, __('Client', 'awedesk'));
            $items['staff_notes_clients_enabled'] = ALSP_Config_Panel::admin_item('staff_notes_clients_enabled');

            $items['staff_notes_tickets_separator'] = ALSP_Config_Panel::admin_item('staff_notes_tickets_separator', FALSE, __('Ticket', 'awedesk'));
            $items['staff_notes_tickets_enabled'] = ALSP_Config_Panel::admin_item('staff_notes_tickets_enabled');

            $config['notes-staff-client'] = [
                'id' => 'notes',
                'title' => __('Staff notes', 'awedesk'),
                'icon' => 'alsp-i-file-signature',
                'position' => 'notes-right',
                'items' => $items,
            ];

            return $config;
        }, 10, 2);
    }
}

add_action('init', function() {
    if (apply_filters('alsp_is_pro', FALSE)) {
        ALSP_Config_Notes::get_instance();
    }
});
// EOF