<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2OGx0aEFhdVJVMjhTNVovRUY1eTdmRUpVVER2dXNxUG9aODVGSTdyU1F0SllmcFNKRkh1T1RsZ3gxQTZ0NVFYZVF1enR6ZEpYQndRQTRIU2diUFBwdkxIT0hkR0lwbktGMkIzU3ZEcEMxbmZrNUdYREdEbm9kUjVnMGtmZUp5enlZPQ==*/

class ALSP_Config_Signatures
{
    private static $instance;

    public static function get_instance()
    {
        return isset(self::$instance) ? self::$instance : self::$instance = new self;
    }

    private function __construct()
    {
        add_filter('alsp_config_menu', function ($menu) {
            $menu['signatures'] = [
                'id' => 'signatures',
                'label' => __('Signatures', 'awedesk'),
                'icon' => 'alsp-i-signature',
            ];

            return $menu;
        }, 10);

        add_filter('alsp_config_description', function ($desc) {
            $desc['signatures_tpl_message'] =
                __('Default signature is used if the staff member has no signature of their own.','awedesk')
                .'<br/>'
                .sprintf(__('Empty %s signature falls back to %s.','awedesk'),__('Administrator','awedesk'),__('Manager','awedesk'))
                .'<br/>'
                .sprintf(__('Empty %s signature falls back to %s.','awedesk'),__('Manager','awedesk'),__('Agent','awedesk'))
                ;
            return $desc;
        });

        add_filter('alsp_config', function ($config, $position) {
            if ($position !== 'signatures-left' && $position !== 'signatures-right') {
                return $config;
            }

			// LEFT
	        $items = [];
            $items['signatures_enabled'] = ALSP_Config_Panel::admin_item('signatures_enabled');
            $items['signatures_custom_agent_separator'] = ALSP_Config_Panel::admin_item('signatures_custom_agent_separator','signatures_enabled',__('Custom signatures','awedesk'));
            $items['signatures_custom_agent_enabled'] = ALSP_Config_Panel::admin_item('signatures_custom_agent_enabled','signatures_enabled',__('Agent','awedesk'));
            $items['signatures_custom_manager_enabled'] = ALSP_Config_Panel::admin_item('signatures_custom_manager_enabled','signatures_enabled',__('Manager','awedesk'));
            $items['signatures_custom_admin_enabled'] = ALSP_Config_Panel::admin_item('signatures_custom_admin_enabled','signatures_enabled',__('Administrator','awedesk'));


            $config['signatures'] = [
                'id' => 'signatures',
                'title' => __('General', 'awedesk'),
                'icon' => 'alsp-i-settings-sliders',
                'position' => 'signatures-left',
                'items' => $items,
            ];

            // RIGHT
            $items = [];
            $items['signatures_tpl_message'] = ALSP_Config_Panel::admin_item('signatures_tpl_message');
            $signature_type = [
                'signature_agent' => __('Agent', 'awedesk'),
                'signature_manager' => __('Manager', 'awedesk'),
                'signature_admin' => __('Administrator', 'awedesk'),
            ];

            foreach ($signature_type as $key => $label) {
                $items[$key . '_template'] = ALSP_Config_Panel::admin_item($key . '_template', FALSE, $label);
            }

            $config['signatures-templates'] = [
                'id' => 'signatures',
                'title' => __('Defaults', 'awedesk'),
                'icon' => 'alsp-i-file-signature',
                'position' => 'signatures-right',
                'items' => $items,
            ];

            return $config;
        }, 10, 2);
    }
}
add_action('init', function() {
    if (apply_filters('alsp_is_pro', FALSE)) {
        ALSP_Config_Signatures::get_instance();
    }
});
// EOF