<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2OVVZcjd2TjlJMElZMG5QdmVZelMzZzRtV1kreTg5blVpQ2NHdXlqUTBaUUR3S0dIY2FMcmw2WGp0MU5OMFNBdlFaNDhRaWoyaitZTi9RU2J5TkI4UE5wQUlDUWJ6UHdJK1dzaXZWRDRtSGJGR3d3bHZYNXFpODFvWHdzRDBlT2FvPQ==*/

class ALSP_Ticket_Preferences
{
    private static $instances = NULL;

    private $ticket;
    private $prefs = [];

    public static function get_instance($ticket)
    {
        if (!isset(self::$instances[$ticket])) {
            self::$instances[$ticket] = new self($ticket);
        }

        return self::$instances[$ticket];
    }

    private function __construct($ticket)
    {
        global $wpdb;

        $this->ticket = $ticket;

        if (isset($_GET['alsp_ticket_preferences_reset'])) {
            $wpdb->query("TRUNCATE TABLE {$wpdb->prefix}alsp_ticket_preferences");
        }

        $sql = $wpdb->prepare("SELECT `pref_key`, `pref_value` FROM {$wpdb->prefix}alsp_ticket_preferences WHERE `ticket`=%d", $ticket);
        $rows = $wpdb->get_results($sql, ARRAY_A);

        if ($wpdb->num_rows > 0) {
            foreach ($rows as $row) {
                $this->prefs[$row['pref_key']] = maybe_unserialize($row['pref_value']);
            }
        }
    }

    public function set($key, $value)
    {
        global $wpdb;

        $value = maybe_serialize($value);

        // Insert
        if (!isset($this->prefs[$key])) {
            $sql = $wpdb->prepare("INSERT INTO {$wpdb->prefix}alsp_ticket_preferences (`ticket`,`pref_key`,`pref_value`) VALUES (%d, %s, %s)", $this->ticket, $key, $value);
            $wpdb->query($sql);
        }

        // Update
        $sql = $wpdb->prepare("UPDATE {$wpdb->prefix}alsp_ticket_preferences SET `pref_value`=%s WHERE `ticket`=%d AND `pref_key`=%s", $value, $this->ticket, $key);
        $wpdb->query($sql);
        $this->prefs[$key] = $value;
    }

    public function get($key, $default = NULL)
    {

        if (isset($this->prefs[$key])) {
            return $this->prefs[$key];
        }

        return $default;
    }

}

// EOF
