<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2OUlCSGNpTGFVSnZpZDRPK1ZTcHRJQytmbHptcllkMHpYZ2I3UVd1OXBvUnpGQVpUQzNVRytBQWs3YklSd3dKNm96MFZTK0c0UXNwL3N4SGl1Sm1GZk1jWnBjNWFQNi9WYWJxbmpGcUI0Y21TaVNpT21zNS95SkRSem9rOTdZdXc4PQ==*/

class ALSP_Recent_Tickets
{
    private static $instances = [];
    private $user_id;
    private $wpdb;
    private $table_name;

    public static function get_instance($user_id = null)
    {
        if (!$user_id) {
            $user_id = get_current_user_id();
        }

        if (!isset(self::$instances[$user_id])) {
            self::$instances[$user_id] = new self($user_id);
        }

        return self::$instances[$user_id];
    }

    private function __construct($user_id)
    {
        global $wpdb;
        $this->wpdb = $wpdb;
        $this->user_id = $user_id;
        $this->table_name = $this->wpdb->prefix . "alsp_recent_tickets";
    }

    public function insert_or_update($ticket_id)
    {
        $user_id = $this->user_id;


        $sql = "SELECT * FROM {$this->table_name} WHERE user = %d AND ticket = %d";
        $sql = $this->wpdb->prepare($sql, $user_id, $ticket_id);
        $res = $this->wpdb->get_results($sql, ARRAY_A);

        if (count($res) == 0) {
            $data = [
                'user' => $user_id,
                'ticket' => $ticket_id,
                'updated' => current_time('mysql'),
            ];
            $this->wpdb->insert($this->table_name, $data);
        }

        $data = [
            'updated' => current_time('mysql'),
        ];
        $sql = "UPDATE {$this->table_name} SET updated=\"%s\" WHERE user=%d AND ticket=%d";
        $sql = $this->wpdb->prepare($sql, $data['updated'], $user_id, $ticket_id);
        $this->wpdb->query($sql);

    }

    public function delete($ticket_id) {
        $this->wpdb->query( $this->wpdb->prepare("DELETE FROM {$this->table_name} WHERE user = %d AND ticket = %d", $this->user_id, $ticket_id) );
    }
}

// EOF
