<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2OVVZcjd2TjlJMElZMG5QdmVZelMzZzRtV1kreTg5blVpQ2NHdXlqUTBaUUR3S0dIY2FMcmw2WGp0MU5OMFNBdlFaNDhRaWoyaitZTi9RU2J5TkI4UE5wQUlDUWJ6UHdJK1dzaXZWRDRtSGJGR3d3bHZYNXFpODFvWHdzRDBlT2FvPQ==*/

class ALSP_User_Preferences
{
	private static $instances = NULL;
    private $user_id;

    private $default_preferences = [
        'receive_emails' => 1,
        'signature'=>'',
    ];

    private $prefs = [];

	public static function get_instance($user_id=NULL)
	{
        if(NULL === $user_id) {
            $user_id = ALSP_User::get_id();
        }

		return (!isset(self::$instances[$user_id])) ? self::$instances[$user_id] = new self($user_id) : self::$instances[$user_id];
	}

	private function __construct($user_id)
	{
		global $wpdb;

        $this->user_id = $user_id;

		$sql = $wpdb->prepare("SELECT `pref_key`, `pref_value` FROM {$wpdb->prefix}alsp_user_preferences WHERE `user`=%d", $this->user_id);
		$rows = $wpdb->get_results($sql, ARRAY_A);

		if ($wpdb->num_rows > 0) {
			foreach ($rows as $row) {
				$this->prefs[$row['pref_key']] = maybe_unserialize($row['pref_value']);
			}
		}

        $signature=new ALSP_Signature();
        $this->prefs['signature'] = $signature->get_custom();
	}

	public function set($key, $value)
	{
        if('signature'==$key) {
            $signature = new ALSP_Signature();

            if($signature->can_use_custom()) {
                update_user_meta($this->user_id, 'alsp_signature', $value);
            }
        }

		global $wpdb;

		$value = maybe_serialize($value);

		// Insert
		if (!isset($this->prefs[$key])) {
			$sql = $wpdb->prepare("INSERT INTO {$wpdb->prefix}alsp_user_preferences (`user`,`pref_key`,`pref_value`) VALUES (%d, %s, %s)", $this->user_id, $key, $value);
			$wpdb->query($sql);
		}

		// Update
		$sql = $wpdb->prepare("UPDATE {$wpdb->prefix}alsp_user_preferences SET `pref_value`=%s WHERE `user`=%d AND `pref_key`=%s", $value, $this->user_id, $key);
		$wpdb->query($sql);
		$this->prefs[$key] = $value;
	}

	public function get($key)
	{
        if('signature'==$key) {
            $signature = new ALSP_Signature();
            return $signature->get_custom();
        }
		if (isset($this->prefs[$key])) {
			return $this->prefs[$key];
		}

        if(isset($this->default_preferences[$key])){
            return $this->default_preferences[$key];
        }

		return NULL;
	}

}

// EOF
