<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2OHoxRlVXV0FCZ0tYd0dFM1pWcVlGNGl3U00zSlo2MjhGYk1kRml5TWdXSUNyY2MzYkpnYzNzOVVGTjNLSzdTdTdpMWx2MTRpakU4RVZhbnA0c0VrT21HRDl4L013OFBQeVlpL2RQUE9ReVVnPT0=*/

class ALSP_Cron
{

	private static $instance;

	public static function get_instance()
	{
		return isset(self::$instance) ? self::$instance : self::$instance = new self;
	}

	public static function initialize()
	{
		if (0 == ALSP_Config::get('cron_mailqueue_enabled', 0)) {
			add_action(ALSP::CRON_MAILQUEUE, ['ALSP_Email_Queue', 'process_mailqueue']);
		}

		if (0 == ALSP_Config::get('cron_autoclosed_ticket_enabled', 0)) {
			add_action(ALSP::CRON_AUTOCLOSED_TICKET, ['ALSP_Tickets', 'process_autoclosed']);
		}

		if (0 == ALSP_Config::get('cron_needs_attention_ticket_enabled', 0)) {
			add_action(ALSP::CRON_NEEDS_ATTENTION_TICKET, ['ALSP_Tickets', 'process_needs_attention']);
		}

		if (0 == ALSP_Config::get('cron_remove_private_notes_ticket_enabled', 0)) {
			add_action(ALSP::CRON_REMOVE_PRIVATE_NOTES_TICKET, ['ALSP_Tickets', 'process_remove_private_notes']);
		}

		if (0 == ALSP_Config::get('cron_empty_trash_enabled', 0)) {
			add_action(ALSP::CRON_EMPTY_TRASH, ['ALSP_Tickets', 'process_empty_trash']);
		}

		do_action('alsp_cron_init');
	}

	/*
	 * Adds needed intervals
	 * @param array $schedules
	 * @return array $schedules
	 */
	public static function filter_cron_schedules($schedules)
	{
		// adds an interval called 'one_minute' to cron schedules
		$schedules['one_minute'] = [
			'interval' => 60,
			'display' => 'Every Minute'
		];

		// adds an interval called 'five_minutes' to cron schedules
		$schedules['five_minutes'] = [
			'interval' => 300,
			'display' => 'Every Five Minutes'
		];

		// Adds once weekly to the existing schedules.
		$schedules['weekly'] = [
			'interval' => 604800,
			'display' => 'Weekly'
		];

		return ($schedules);
	}
}

// EOF