<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2L2Y3R3AvbEg3TGhkOFJFa09IZy9CMXc4TDZPN3RQUlltcUJHTmc3U0VtaHM2blVJeGZvbDZJQUM3UkdpTXcwNEE5SnRSa1hJQVpSdHFLUGtaWTJGbHA5bkU1dGxpb0ZMWE5ZTDRwRFRTRXRyNVBqZ3Uzb0Q4YVNpYi9qNTJKRjA4PQ==*/

class ALSP_License
{

    public static function edd_check_license()
    {

        $license = trim(ALSP_Config::get('license_key'));
        if (strlen($license) != 32) {
            // Don't bother the API if it's obviously wrong
            return 0;
        }
        $api_params = [
            'edd_action' => 'check_license',
            'license' => $license,
            'item_id' => Awedesk_License_Helper::get_item_id(),
            'url' => home_url(),
            'environment' => function_exists('wp_get_environment_type') ? wp_get_environment_type() : 'production',
        ];

        // Call the custom API.
        $response = wp_remote_post(
            Awedesk_License_Helper::get_url(),
            [
                'timeout' => 15,
                'sslverify' => false,
                'body' => $api_params,
            ]
        );

        if (is_wp_error($response)) {
            // Error in communication, assume good intentions
            ALSP_Mayfly::set('myalmightysupportcom_maybe_offline', 1, 3600);
            ALSP_Mayfly::set('license_valid', 1, 3600);
            ALSP_Mayfly::set('license_valid_override', 1, 3600);
            return TRUE;
        }

        ALSP_Mayfly::del('myalmightysupportcom_maybe_offline');


        $license_data = json_decode(wp_remote_retrieve_body($response));
        //        //new ALSP_Debug(print_r($license_data,TRUE));
        if ('valid' === $license_data->license) {
            ALSP_Mayfly::set('license_valid', 1, 3600 * 24 * 7);
            ALSP_Mayfly::del('myalmightysupportcom_maybe_offline', 1, 3600);
            ALSP_Mayfly::del('license_valid_override', 1, 3600);
            return TRUE;
            // this license is still valid
        } else {
            return FALSE;
        }
    }
}

add_action('init', function () { {
    $doing_cron = defined('DOING_CRON') && DOING_CRON;
    if (!current_user_can('manage_options') && !$doing_cron) {
        return;
    }

    $license = ALSP_Config::get('license_key');
    $item_id = Awedesk_License_Helper::get_item_id();

    if(!apply_filters('alsp_is_pro', FALSE)) {

        $license = '79d30e244fe56b5bbaef8844c884765c';
        $item_id = 2999;

        if (!ALSP_Mayfly::get('free_activated')) {

            $response = wp_remote_post(
                Awedesk_License_Helper::get_url(),
                    [
                    'timeout' => 15,
                    'sslverify' => false,
                    'body' => [
                        'edd_action' => 'activate_license',
                        'license' => $license,
                        'item_id' => $item_id,
                        'url' => home_url(),
                        'environment' => function_exists('wp_get_environment_type') ? wp_get_environment_type() : 'production',
                    ],
                ]
            );

            // We will call the endpoint once a week to keep tabs on what is active
            ALSP_Mayfly::set('free_activated', 1, 3600 * 24 * 7);
        }
    }

    $edd_updater = new ALSP_EDD_Updater(
        Awedesk_License_Helper::get_url(),
        dirname(dirname(dirname(__FILE__))) . '/alsp.php',
        [
            'version' => ALSP::PLUGIN_VERSION,
            'license' => $license,
            'item_id' => $item_id,
            // ID of the product,
            'author' => 'Matt Jaworski'
        ]
    );

}
});
