<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2OFhIeThwc2xndkxMaFk3L25pWThvMFNRTU1oMWJoWTF2TWhhc2ZtZXNtR2krZjErZi9IM0JRbWQvdmRpemRXRVBOb0NzcEFDMFNYd3ZlRnhoczZDVHN5RUdKR2VyTmptSDZTQnpwbDE1L0hRPT0=*/

class ALSP_Upsell {
    private static $instance = NULL;

    public static function instance() {
        return self::$instance ?? self::$instance = new self;
    }

    private function __construct() {
        add_action('admin_notices', function() {

            if(!current_user_can('manage_options')) { return; }

            // Get the plugin installation date from the options
            $install_date = ALSP_Config::get('install_date');
            $install_date_timestamp = strtotime($install_date);

            // Calculate the age of the plugin installation in days
            $plugin_age_in_days = $install_date ? round((time() - $install_date_timestamp) / (60 * 60 * 24)) : 0;
            if($plugin_age_in_days < 30) { return; }

            $url = 'https://awedesk.com/upsell.php?show_peepso='.intval(!class_exists('PeepSo')).'&show_alsp='.intval(!apply_filters('alsp_is_pro',  FALSE));

            $upsell = '';
            $cached = '';
            $cache_key ='upsell_'.md5($url);

            // Dismiss functionality
            $mayfly = 'user_'.get_current_user_id().'upsell_dismiss';

            if(isset($_GET['alsp_upsell_dismiss'])) {
                ALSP_Mayfly::set($mayfly,1,7*24*3600);
                ALSP_Utility_Redirect::_(remove_query_arg('alsp_upsell_dismiss'));
            }

            if(isset($_GET['alsp_upsell_dismiss_reset'])) {
                ALSP_Mayfly::del($mayfly);
                ALSP_Utility_Redirect::_(remove_query_arg('alsp_upsell_dismiss_reset'));
            }

            if(ALSP_Mayfly::get($mayfly)) { return; }


            // Optional cache reset
            if(isset($_GET['alsp_upsell_nocache'])) {
                ALSP_Mayfly::del($cache_key);
            }


            if($cache = ALSP_Mayfly::get($cache_key)) {
                // Cached result
                $cached = "<!--From Cache-->\n";
                $upsell = $cache;
            } else {

                $curl = curl_init($url);
                $curl_options = [
                    CURLOPT_RETURNTRANSFER => true,
                ];

                curl_setopt_array($curl, $curl_options);

                if ($response = curl_exec($curl)) {
                    $upsell = $response;
                }

                ALSP_Mayfly::set($cache_key, $upsell, 7 * 24 * 3600);
            }

            if(strlen($upsell) && !stristr($upsell,'upsell_is_empty')) {
                echo $cached;
                echo '<br><br><a href="'.add_query_arg('alsp_upsell_dismiss',1).'">Dismiss</a><br>';
                echo "\n".$upsell;
            }
        });
    }
}

ALSP_Upsell::instance();
