<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2OG8vcVB0TkUvMGE5eE9hUWRKNXBxV204Q1pnS1hiZTNkOC9PYVY0ZjVyalp4Tll6QWpTbzRDOVNPYzJVMVkvdkRIYXh3MHJwUDdoRFF1ZDR3T1N2bUk5SHdiUVc2S0pIY2xkcDl5RXNKMHNYNndyZ0JMZWJYTlIxT09nM3VocXM4PQ==*/

class ALSP_Utility_WP
{

    public static function user_is_admin()
    {

        static $is_admin = NULL;

        if (NULL !== $is_admin) {
            return $is_admin;
        }

        // WP admins
        if (current_user_can('manage_options')) {
            return $is_admin = TRUE;
        }


        if (!get_current_user_id()) {
            return $is_admin = FALSE;
        }

        // TODO: use current_user_can() when we create capabilities

        return $is_admin = FALSE;
    }

    public static function get_option($option, $default = FALSE)
    {
        $return = get_option($option, $default);

        if (is_multisite()) {
            $id = get_current_blog_id();

            switch_to_blog($id);
            $return = get_option($option, $default);
            restore_current_blog();
        }

        return $return;
    }

    public static function add_option($option, $value)
    {
        $return = add_option($option, $value);
        if (is_multisite()) {
            $id = get_current_blog_id();

            switch_to_blog($id);
            $return = add_option($option, $value);
            restore_current_blog();
        }

        return $return;
    }

    public static function update_option($option, $value, $autoload = null)
    {
        $return = update_option($option, $value, $autoload);
        if (is_multisite()) {
            $id = get_current_blog_id();

            switch_to_blog($id);
            $return = update_option($option, $value, $autoload);
            restore_current_blog();
        }

        return $return;
    }

    public static function delete_option($option)
    {
        $return = delete_option($option);
        if (is_multisite()) {
            $id = get_current_blog_id();

            switch_to_blog($id);
            $return = delete_option($option);
            restore_current_blog();
        }

        return $return;
    }
}

// EOF