<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2OWtXRjAvRFZ5dGNWMGRrYmQ2MXdjdnF2K2ZyNy9Delk0TG9EbnhkRHg1TWdxcnN3dXZMYmRqbjFJSXpyT0RrK3lsK1h3Z3RKSDdNZkpMMlg3MUl5Y0htSVN3M21xQ1pVa1VpK1ZPakhhUzJPMlZxTmRtbjhsMWZQSi9Ma1NpZzgwPQ==*/

class ALSP_Activation
{

    private static $instance = NULL;

    /**
     * Fired when the plugin is activated.
     *
     * @since    1.0.0
     *
     * @param    boolean $network_wide       True if WPMU superadmin uses
     *                                       "Network Activate" action, false if
     *                                       WPMU is disabled or plugin is
     *                                       activated on an individual blog.
     */
    public static function _($network_wide)
    {

        /**
         * Setup directory for file debug.
         */
        @mkdir(WP_CONTENT_DIR . DIRECTORY_SEPARATOR . 'alsp');
        if (!ALSP_Config::get('debug_file')) {
            $file = md5(microtime() . $_SERVER['HTTP_HOST']);
            ALSP_Config::set('debug_file', $file);
        }
        $fh = fopen(WP_CONTENT_DIR . DIRECTORY_SEPARATOR . 'alsp' . DIRECTORY_SEPARATOR . ALSP_Config::get('debug_file') . '.log', 'w');
        fclose($fh);
        $fh = fopen(WP_CONTENT_DIR . DIRECTORY_SEPARATOR . 'alsp' . DIRECTORY_SEPARATOR . 'index.html', 'w');
        fclose($fh);self::install($network_wide);

        return TRUE;
    }

        /**
     * Install
     *
     * Runs on plugin install by setting up the post types, custom taxonomies,
     * flushing rewrite rules to initiate the new 'downloads' slug and also
     * creates the plugin and populates the settings fields for those plugin
     * pages.
     *
     * @since 1.0
     * @param  bool $network_wide If the plugin is being network-activated
     * @return void
     */
    public static function install($network_wide = false)
    {
        // Multi-site install
        if (is_multisite() && !empty($network_wide)) {
            self::run_multisite_install();

            // Single site install
        } else {
            self::run_install();
        }
    }

    public static function run_multisite_install()
    {
        global $wpdb;

        // Get site count
        $network_id = get_current_network_id();
        $query = $wpdb->prepare("SELECT COUNT(*) FROM {$wpdb->blogs} WHERE site_id = %d", $network_id);
        $count = $wpdb->get_var($query);

        // Bail if no sites (this is really strange and bad)
        if (empty($count) || is_wp_error($count)) {
            return;
        }

        // Setup the steps
        $per_step = 100;
        $total_steps = ceil($count / $per_step);
        $step = 1;
        $offset = 0;

        // Step through all sites in this network in groups of 100
        do {

            // Get next batch of site IDs
            $query = $wpdb->prepare("SELECT blog_id FROM {$wpdb->blogs} WHERE site_id = %d LIMIT %d, %d", $network_id, $offset, $per_step);
            $site_ids = $wpdb->get_col($query);

            // Proceed if site IDs exist
            if (!empty($site_ids)) {
                foreach ($site_ids as $site_id) {
                    self::run_install($site_id);
                }
            }

            // Bump the limit for the next iteration
            $offset = ($step * $per_step) - 1;

            // Bump the step
            ++$step;

            // Bail when steps are greater than or equal to total steps
        } while ($total_steps > $step);
    }

    public static function run_install($site_id = false)
    {
        // Not switched
        $switched = false;

        // Maybe switch to a site
        if (!empty($site_id)) {
            switch_to_blog($site_id);
            $switched = true;
        }

        ALSP_Activation::setup_config();
        ALSP_Activation::setup_tables();
        ALSP_Activation::setup_roles();
        ALSP_Activation::setup_department();
        ALSP_Activation::setup_email_config();
        ALSP_Activation::setup_scheduled_events();

        // Maybe switch back
        if (true === $switched) {
            restore_current_blog();
        }
    }

    public static function deactivate()
    {
        return TRUE;
    }

    public static function setup_config()
    {
        /**
         * Default config.
         */
        $config = [
            'powered_by_enabled' => 1,
            'default_theme_select' => 'light',
            'light_accent_color' => 'rgb(37, 74, 255)',
            'dark_accent_color' => 'rgb(37, 74, 255)',
	        'auto_focus_select' => 'never',
            'loadmore_select' => 0,
            'loadmore_repeat_select' => 10,

            'site_emails_sender_label' => '{site_name} Support',
            'site_emails_admin_email_label' => 'no-reply@alsp.com',

            'ep_enabled' => 0,
            'ep_connection_select' => 'imap',
            'ep_reply_above_label' => '-- Reply Above --',
            'ep_allowed_email_select' => 'all',
            'ep_allowed_users_select' => 'anyone',
            'ep_import_cc_enabled' => 0,
            'ep_block_emails_textarea' => implode(
                "\r\n",
                [
                    '/no(t)?(\\-|_)?reply@/i',
                    // noreply.
                    '/mail(er)?[\\-_]daemon@/i',
                    // mailer daemon.
                ]
            ),
            'ep_block_subject_textarea' => implode(
                "\r\n",
               [
                    '/^[\\[\\(]?Auto(mat(ic|ed))?[\\s\\-]?reply/i',
                    // automatic reply.
                    '/^Out of Office/i',
                    // out of office.
                    '/Delivery Status Notification \\(Failure\\)/i',
                    // delevery failure.
                    '/Returned mail\\: see transcript for details/i',
                    // delevery failure.
                    'DELIVERY FAILURE',
                    // delevery failure.
                    'Undelivered Mail Returned to Sender',
                    // delevery failure.
                ]
            ),

            'cron_autoclosed_interval_number' => 7,
            'cron_auto_delete_from_trash_interval_number' => 30,
            'cron_needs_attention_interval_number' => 1,
            'chars_limit_subject_number' => 150,
            'chars_limit_content_number' => 10000,

            'ep_forwarding_emails_textarea' => "",
            'ep_forwarding_as_from_email_enabled' => 0,

            'support_page_client_select' => -1,
            'support_page_agent_select' => '',

            'attachment_enabled' => 1,

            'signatures_enabled' => 1,
            'signatures_custom_admin_enabled' => 1,
            'signatures_custom_manager_enabled' => 1,
            'signatures_custom_agent_enabled' => 1,

            'secret_enabled' => 1,
            'secret_delete_interval_number' => 7,

            'staff_notes_clients_enabled' => 1,
            'staff_notes_tickets_enabled' => 1,

            'on_behalf_enabled' => 1,
            'on_behalf_roles_select' => 1,
            'on_behalf_register_role_select' => 1,

            'login_guest_enabled' => 1,
            'login_forgot_enabled' => 1,
            'login_register_enabled' => 0,

            'docs_cpt_words_number' => 10,
            'docs_cpt_results_number' => 3,

            'license_legacy_enabled'=>1,
        ];

        foreach ($config as $name => $value) {
            // Don't set default if it's exists
            if('AWEDESK_EMPTY_SETTING' == ALSP_Config::get($name,'AWEDESK_EMPTY_SETTING')) {
                ALSP_Config::set($name, $value);
            }
        }

        if (NULL === ALSP_Config::get('install_date', NULL)) {
            ALSP_Config::add('install_date', date('Y-m-d'));
        }
    }

    public static function setup_tables()
    {
        global $wpdb;
        require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
        $charset_collate = $wpdb->get_charset_collate();

        $prefix = $wpdb->prefix;
        $table_name = $prefix . 'alsp_tickets';
        $sql = "CREATE TABLE $table_name (
                  `id` BIGINT(20) NOT NULL AUTO_INCREMENT,
                  `subject` VARCHAR(255) NOT NULL,
                  `secret` TEXT NULL,
                  `client` BIGINT(20) NOT NULL,
                  `author` BIGINT(20) NOT NULL,
                  `agent` BIGINT(20),
                  `department` INT,
                  `status` VARCHAR(64) NOT NULL DEFAULT 'agent',
                  `agent_reply_count` INT NOT NULL DEFAULT 0,
                  `client_reply_count` INT NOT NULL DEFAULT 0,
                  `auth_code` VARCHAR(64),
                  `last_reply_by` BIGINT NOT NULL DEFAULT 0,
                  `needs_attention` TINYINT(1) NOT NULL DEFAULT '0',
                  `prevent_autoclose` TINYINT(1) NOT NULL DEFAULT '0',
                  `prevent_clientclose` TINYINT(1) NOT NULL DEFAULT '0',
                  `prevent_reopen` TINYINT(1) NOT NULL DEFAULT '0',
                  `created` DATETIME DEFAULT CURRENT_TIMESTAMP,
                  `updated` DATETIME DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
                  `last_reply_time_client` DATETIME DEFAULT CURRENT_TIMESTAMP,
                  `last_reply_time_agent` DATETIME DEFAULT NULL,
                  `last_reply_time` DATETIME DEFAULT CURRENT_TIMESTAMP,
                  `closed` DATETIME,
                  PRIMARY KEY (id),
                  INDEX agent_index (agent),
                  INDEX client_index (client),
                  INDEX department_index (department),
                  INDEX status_index (status),
                  INDEX created_index (created),
                  INDEX updated_index (updated)
                ) $charset_collate;";
        if (defined('ALSP_WIPE')) {
            $wpdb->query("DROP TABLE $table_name");
        }
        dbDelta($sql);

        /**
         * created_by - who wrote the message
         * message_type - examples: customer_reply, agent_reply, internal_note etc
         * author
         *      if author is "0" it means a system message for example "System has auto closed the ticket"
         *      otherwise it identifies a user, eg "Matt (agent) closed the ticket" or "Steve (client) has reopened the ticket"
         */
        $table_name = $prefix . 'alsp_ticket_messages';
        $sql = "CREATE TABLE $table_name (
                    `id` BIGINT(20) NOT NULL AUTO_INCREMENT,
                    `ticket` BIGINT(20) NOT NULL,
                    `author` BIGINT(20) NOT NULL,
                    `type` VARCHAR(255) DEFAULT 'customer_reply',
                    `message` TEXT NOT NULL,
                    `created` DATETIME DEFAULT CURRENT_TIMESTAMP,
                  PRIMARY KEY (id),
                  INDEX ticket_index (ticket),
                  INDEX author_index (author),
                  INDEX type_index (type)
                ) $charset_collate;";
        if (defined('ALSP_WIPE')) {
            $wpdb->query("DROP TABLE $table_name");
        }
        dbDelta($sql);


        $table_name = $prefix . 'alsp_app_push';
        $sql = "CREATE TABLE $table_name (
                    `id` BIGINT(20) NOT NULL AUTO_INCREMENT,
                    `user` BIGINT(20) NOT NULL,
                    `token` VARCHAR(255) NOT NULL,
                    `device` VARCHAR(255) NOT NULL,
                    `created` DATETIME DEFAULT CURRENT_TIMESTAMP,   
                    `updated` DATETIME DEFAULT NULL,   
                    `used` DATETIME DEFAULT NULL,        
                  PRIMARY KEY (id)
                ) $charset_collate;";
        if (defined('ALSP_WIPE')) {
            $wpdb->query("DROP TABLE $table_name");
        }
        dbDelta($sql);

        $table_name = $prefix . 'alsp_log';
        $sql = "CREATE TABLE $table_name (
                    `id` BIGINT(20) NOT NULL AUTO_INCREMENT,
                    `created` DATETIME DEFAULT CURRENT_TIMESTAMP,        
                    `event` VARCHAR(64) NULL,
                    `extra` VARCHAR(64) NULL,
                  PRIMARY KEY (id),
                  INDEX created_index (created),
                  INDEX event_index (event)
                ) $charset_collate;";
        if (defined('ALSP_WIPE')) {
            $wpdb->query("DROP TABLE $table_name");
        }
        dbDelta($sql);

        /**
         * Used to store Staff Notes for Tickets and Clients
         * type - examples: customer, ticket
         */
        $table_name = $prefix . 'alsp_staff_notes';
        $sql = "CREATE TABLE $table_name (
                    `id` BIGINT(20) NOT NULL AUTO_INCREMENT,        
                    `client_id` BIGINT(20) NULL,
                    `ticket_id` BIGINT(20) NULL,
                    `author` BIGINT(20) NOT NULL,
                    `message` TEXT NOT NULL,
                    `created` DATETIME DEFAULT CURRENT_TIMESTAMP,
                  PRIMARY KEY (id),
                  INDEX client_index (client_id),
                  INDEX ticket_index (ticket_id),
                  INDEX author_index (author),
                  INDEX created_index (created)
                ) $charset_collate;";
        if (defined('ALSP_WIPE')) {
            $wpdb->query("DROP TABLE $table_name");
        }
        dbDelta($sql);

        /**
         * Departments will be configurable, including a default department
         * Examples: tech support, billing, etc
         */
        $table_name = $prefix . 'alsp_departments';
        $sql = "CREATE TABLE $table_name (
                  `id` BIGINT(20) NOT NULL AUTO_INCREMENT,
                  `name` VARCHAR(255) NOT NULL,
                  `description` TEXT NOT NULL,
                  `author` BIGINT(20) NOT NULL,
                  `default_assignee` BIGINT(20),
                  `agent_only` TINYINT(1) NOT NULL DEFAULT '0',
                  `published` TINYINT(1) NOT NULL DEFAULT '0',
                  `order` BIGINT(20) NOT NULL DEFAULT '0',
                  `created` DATETIME DEFAULT CURRENT_TIMESTAMP,
                  `updated` DATETIME DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
                  PRIMARY KEY (id),
                  INDEX name_index (name),
                  INDEX order_index (`order`),
                  INDEX agent_only_index (agent_only),
                  INDEX published_index (published)
                ) $charset_collate;";
        if (defined('ALSP_WIPE')) {
            $wpdb->query("DROP TABLE $table_name");
        }
        dbDelta($sql);

        /**
         * Users will be stored user information.
         * Examples: role
         */
        $table_name = $prefix . 'alsp_users';
        $sql = "CREATE TABLE $table_name (
                  `id` BIGINT(20) NOT NULL,
                  `author` BIGINT(20) NOT NULL,
                  `role` ENUM('admin', 'manager', 'agent', 'client') DEFAULT 'client',
                  `created` DATETIME DEFAULT CURRENT_TIMESTAMP,
                  `updated` DATETIME DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
                  PRIMARY KEY (id),
                  INDEX role_index (role)
                ) $charset_collate;";
        if (defined('ALSP_WIPE')) {
            $wpdb->query("DROP TABLE $table_name");
        }
        dbDelta($sql);

        /**
         * It will be relation for agent and department.
         */
        $table_name = $prefix . "alsp_agent_department";
        $sql = "CREATE TABLE $table_name (
                    `id` BIGINT(20) NOT NULL AUTO_INCREMENT,
                    `agent` BIGINT(20) UNSIGNED NOT NULL,
                    `department` BIGINT(20) UNSIGNED NOT NULL,
                    `created` DATETIME DEFAULT CURRENT_TIMESTAMP,
                    PRIMARY KEY (id),
                    INDEX agent_index (agent),
                    INDEX department_index (department)
                ) $charset_collate;";
        if (defined('ALSP_WIPE')) {
            $wpdb->query("DROP TABLE $table_name");
        }
        dbDelta($sql);

        /**
         * It will be key values pair for user preferences.
         */
        $table_name = $prefix . "alsp_user_preferences";
        $sql = "CREATE TABLE $table_name (
                    `id` BIGINT(20) NOT NULL AUTO_INCREMENT,
                    `user` BIGINT(20) UNSIGNED NOT NULL,
                    `pref_key` VARCHAR(64) NOT NULL,
                    `last_activity` DATETIME DEFAULT NULL,
                    `pref_value` VARCHAR(256),
                    PRIMARY KEY (id),
                    INDEX user_index (user),
                    INDEX pref_key_index (pref_key)
                ) $charset_collate;";
        if (defined('ALSP_WIPE')) {
            $wpdb->query("DROP TABLE $table_name");
        }
        dbDelta($sql);

        /**
         * It will be key values pair for user preferences.
         */
        $table_name = $prefix . "alsp_ticket_preferences";
        $sql = "CREATE TABLE $table_name (
                    `id` BIGINT(20) NOT NULL AUTO_INCREMENT,
                    `ticket` BIGINT(20) UNSIGNED NOT NULL,
                    `pref_key` VARCHAR(64) NOT NULL,
                    `last_activity` DATETIME DEFAULT NULL,
                    `pref_value` VARCHAR(256),
                    PRIMARY KEY (id),
                    INDEX ticket_index (ticket),
                    INDEX pref_key_index (pref_key)
                ) $charset_collate;";
        if (defined('ALSP_WIPE')) {
            $wpdb->query("DROP TABLE $table_name");
        }
        dbDelta($sql);

        $table_name = $wpdb->prefix . "alsp_recent_tickets";
        $sql = "CREATE TABLE $table_name (
                    `id` BIGINT(20) NOT NULL AUTO_INCREMENT,
                    `ticket` BIGINT(20) UNSIGNED NOT NULL,
                    `user` BIGINT(20) UNSIGNED NOT NULL,
                    `created` DATETIME DEFAULT CURRENT_TIMESTAMP,
                    `updated` DATETIME DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
                    PRIMARY KEY (id)
                ) $charset_collate;";
        if (defined('ALSP_WIPE')) {
            $wpdb->query("DROP TABLE $table_name");
        }
        dbDelta($sql);

        /**
         * It will be tables for storing mail queue.
         */
        $table_name = $prefix . "alsp_mail_queue";
        $sql = "CREATE TABLE $table_name (
                    `id` BIGINT(20) NOT NULL AUTO_INCREMENT,
					`user_id` BIGINT(20) UNSIGNED NULL DEFAULT '0',
					`created_at` TIMESTAMP DEFAULT CURRENT_TIMESTAMP,
					`recipient` VARCHAR(128) NOT NULL,
					`subject` VARCHAR(200) NOT NULL,
					`message` TEXT NOT NULL,
					`status` TINYINT(1) NOT NULL DEFAULT '0',
					`attempts` TINYINT(1) NOT NULL DEFAULT '0',
					`error_log` TEXT,
					PRIMARY KEY (id),
					INDEX `alsp_mail_user_index` (user_id),
					INDEX `alsp_mail_status_index` (status)
                ) $charset_collate;";
        if (defined('ALSP_WIPE')) {
            $wpdb->query("DROP TABLE $table_name");
        }
        dbDelta($sql);

        /**
         * It will be tables for storing multi inbox config.
         */
        $table_name = $prefix . "alsp_multi_inbox";
        $sql = "CREATE TABLE $table_name (
                    `id` BIGINT(20) NOT NULL AUTO_INCREMENT,
					`department` BIGINT(20) UNSIGNED NULL DEFAULT '0',
					`receiver` VARCHAR(512) NOT NULL,
					`author` BIGINT(20) NOT NULL,
					`created_at` TIMESTAMP DEFAULT CURRENT_TIMESTAMP,
					PRIMARY KEY (id),
					INDEX `alsp_multi_inbox_department_index` (department)
                ) $charset_collate;";
        if (defined('ALSP_WIPE')) {
            $wpdb->query("DROP TABLE $table_name");
        }
        dbDelta($sql);


        /**
         * It will be tables for storing cache.
         */
        $table_name = $wpdb->prefix . "alsp_mayfly";
        $sql = "CREATE TABLE $table_name (
                    `id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
                    `created` DATETIME DEFAULT CURRENT_TIMESTAMP,
                    `name` VARCHAR(256),
                    `value` MEDIUMTEXT NULL,
                    `expires` DATETIME DEFAULT CURRENT_TIMESTAMP,
                    PRIMARY KEY (id),
                    UNIQUE INDEX id (id),
                    INDEX name (name),
                    INDEX expires_index (expires)
                ) ENGINE=InnoDB";
        if (defined('ALSP_WIPE')) {
            $wpdb->query("DROP TABLE $table_name");
        }
        dbDelta($sql);

		// Old notifications table
	    $wpdb->query("DROP TABLE IF EXISTS {$wpdb->prefix }alsp_notifications");



        if (defined('ALSP_DEMO_MODE')) {
            $sql = "CREATE TABLE " . $wpdb->prefix . "alsp_demo (
            `id` bigint(20) NOT NULL AUTO_INCREMENT,
            `last_activity` DATETIME DEFAULT NULL,
            `secret` VARCHAR(64) NOT NULL,
			PRIMARY KEY (id)
		) $charset_collate;";
            dbDelta($sql);

            if (!ALSP_Config::get('did_auto_increment')) {
                $sql = "ALTER TABLE {$wpdb->prefix}alsp_demo AUTO_INCREMENT=1000000000";
                $wpdb->query($sql);
                ALSP_Config::set('did_auto_increment', 1);
            }
        }

        if (!ALSP_Config::get('did_add_fulltext_indexes')) {
            $sql = "ALTER TABLE {$wpdb->prefix}posts ADD FULLTEXT INDEX ft_post_title_content (post_title, post_content)";
            $wpdb->query($sql);
            ALSP_Config::set('did_add_fulltext_indexes', 1);
        }

        $user_query = new WP_User_Query(array('fields' => 'ID', 'role' => 'Administrator'));
        $results = $user_query->results;
        if (count($results)) {
            foreach ($results as $user_id) {
                $user = ALSP_User::get_instance($user_id);
                $user->set_user_role(ALSP_User::ROLE_ADMIN);
            }
        }

        $user_query = new WP_User_Query(array('fields' => 'ID', 'role' => 'Subscriber'));
        $results = $user_query->results;
        if (count($results)) {
            foreach ($results as $user_id) {
                $user = ALSP_User::get_instance($user_id);
                if ($user->get('role') === NULL) {
                    $user->set_user_role(ALSP_User::ROLE_CLIENT);
                }
            }
        }

        return TRUE;
    }

    public static function setup_roles()
    {
        /**
         * Full list of capabilities.
         *
         * This is the full list of capabilities
         * that will be given to administrators.
         *
         * @var array
         */
        $full_cap = apply_filters(
            'alsp_user_capabilities_full',
           [
                'alsp_list_ticket',
                'alsp_view_ticket',
                'alsp_view_private_ticket',
                'alsp_edit_ticket',
                'alsp_edit_other_ticket',
                'alsp_edit_private_ticket',
                'alsp_edit_private_notes',
                'alsp_delete_ticket',
                'alsp_delete_reply',
                'alsp_delete_private_ticket',
                'alsp_delete_other_ticket',
                'alsp_assign_ticket',
                'alsp_assign_ticket_creator',
                'alsp_close_ticket',
                'alsp_reopen_ticket',
                'alsp_reply_ticket',
                'alsp_settings_tickets',
                'alsp_ticket_taxonomy',
                'alsp_create_ticket',
                'alsp_attach_files',
                'alsp_view_edd',
                'alsp_lock_ticket',
                'alsp_view_all_tickets',
                'alsp_view_unassigned_tickets',
                'alsp_manage_licenses',
                'alsp_ticket_list_agents',
                'alsp_ticket_manage_agents',
                'alsp_ticket_edit_agents',
                'alsp_ticket_delete_agents',
                'alsp_ticket_list_tags',
                'alsp_ticket_manage_tags',
                'alsp_ticket_edit_tags',
                'alsp_ticket_delete_tags',
                'alsp_ticket_list_products',
                'alsp_ticket_manage_products',
                'alsp_ticket_edit_products',
                'alsp_ticket_delete_products',
                'alsp_ticket_list_departments',
                'alsp_ticket_manage_departments',
                'alsp_ticket_edit_departments',
                'alsp_ticket_delete_departments',
                'alsp_ticket_list_priorities',
                'alsp_ticket_manage_priorities',
                'alsp_ticket_edit_priorities',
                'alsp_ticket_delete_priorities',
                'alsp_ticket_list_channels',
                'alsp_ticket_manage_channels',
                'alsp_ticket_edit_channels',
                'alsp_ticket_delete_channels',
                'alsp_ticket_manage_privacy',
                'alsp_ticket_manage_ticket_type',
                'alsp_ticket_edit_ticket_type',
                'alsp_ticket_delete_ticket_type',
                'alsp_ticket_manage_ticket_templates'
            ]
        );

        /**
         * Partial list of capabilities.
         *
         * A partial list of capabilities given to agents in addition to
         * the author capabilities. Agents should be used if no other access
         * than the tickets is required.
         *
         * @var array
         */
        $agent_cap = apply_filters(
            'alsp_user_capabilities_agent',
           [
                'alsp_list_ticket',
                'alsp_view_ticket',
                'alsp_view_private_ticket',
                'alsp_edit_ticket',
                'alsp_edit_other_ticket',
                'alsp_edit_private_ticket',
                'alsp_edit_private_notes',
                'alsp_assign_ticket',
                'alsp_assign_ticket_creator',
                'alsp_close_ticket',
                'alsp_reopen_ticket',
                'alsp_reply_ticket',
                'alsp_create_ticket',
                'alsp_delete_reply',
                'alsp_attach_files',
                'alsp_view_edd',
                'alsp_lock_ticket',
                'alsp_ticket_manage_tags',
                'alsp_ticket_manage_products',
                'alsp_ticket_manage_departments',
                'alsp_ticket_manage_priorities',
                'alsp_ticket_manage_channels',
                'alsp_ticket_manage_privacy',
                'alsp_ticket_manage_ticket_type'
            ]
        );

        /**
         * Very limited list of capabilities for the clients.
         */
        $client_cap = apply_filters(
            'alsp_user_capabilities_client',
           [
                'alsp_list_ticket',
                'alsp_view_ticket',
                'alsp_create_ticket',
                'alsp_close_ticket',
                'alsp_reopen_ticket',
                'alsp_reply_ticket',
                'alsp_attach_files',
                'alsp_edit_private_notes'
            ]
        );


        /* Get roles to copy capabilities from */
        $subscriber = get_role('subscriber');
        $admin = get_role('administrator');

        /* Add the new roles */
        $manager = add_role('alsp_manager', 'Awedesk - ' . __('Manager', 'awedesk'), $subscriber->capabilities); // Has full capabilities for the plugin in addition to editor capabilities
        $agent = add_role('alsp_agent', 'Awedesk - ' . __('Agent', 'awedesk'), $subscriber->capabilities); // Has limited capabilities for the plugin in addition to author's capabilities

        // Check if role exists
        if (null == $manager) {
            $manager = get_role('alsp_manager');
        }

        if (null == $agent) {
            $agent = get_role('alsp_agent');
        }

        /**
         * Add full capacities to admin roles
         */
        foreach ($full_cap as $cap) {

            // Add all the capacities to admin in addition to full WP capacities
            if (null != $admin)
                $admin->add_cap($cap);

            // Add full plugin capacities to manager in addition to the editor capacities
            if (null != $manager)
                $manager->add_cap($cap);
        }

        /**
         * Add limited capacities to agents
         */
        foreach ($agent_cap as $cap) {
            if (null != $agent) {
                $agent->add_cap($cap);
            }
        }

        /**
         * Add limited capacities to users
         */
        foreach ($client_cap as $cap) {
            if (null != $subscriber) {
                $subscriber->add_cap($cap);
            }
        }

        /**
         * Check if there are any custom roles and add the client capabilities to them.
         */
        $all_roles = wp_roles()->roles;
        foreach ($all_roles as $key => $details) {
            if (!in_array($key, ['administrator', 'alsp_manager', 'alsp_agent', 'subscriber'])) {
                $role = get_role($key);
                foreach ($client_cap as $cap) {
                    $role->add_cap($cap);
                }
            }
        }
    }

    public static function setup_department()
    {
        global $wpdb;
        $sql = "SELECT * FROM `{$wpdb->prefix}alsp_departments` ";
        $res = $wpdb->get_results($sql, ARRAY_A);
        if (count($res) == 0) {
            // if alsp_departments record doesn't exist, create it
            $default_departments = [
                __('Sales', 'awedesk'),
                __('Billing', 'awedesk'),
                __('Technical Support', 'awedesk'),
            ];

            foreach ($default_departments as $key => $value) {
                $data = [
                    'name' => $value,
                    'author' => get_current_user_id(),
                    'published' => 1,
                ];
                $wpdb->insert($wpdb->prefix . "alsp_departments", $data);
            }
        }
    }

    public static function setup_email_config($reset = FALSE)
    {

        if (in_array(ALSP::PLUGIN_VERSION, ['1.0.2', '1.0.3', '1.0.4'])) {
            $reset = TRUE;
        }

        /**
         *
         * 'submission_confirmation',
         * 'new_ticket',
         * 'ticket_assigned',
         * 'agent_reply',
         * 'client_reply',
         * 'ticket_closed',
         * 'ticket_closed_agent',
         * 'ticket_closed_client',
         */

        // write the email content settings
        $emails = [


            'email_signature_template' => "

Thank you!
Your <strong>{site_name} Support Team</strong>

",

            'email_link_template' => "

<a href='{ticket_url}' target='_blank'>#{ticket_number} - {ticket_title}</a>

",

            'email_submission_confirmation_template' => "

Hello {recipient_name}

Thank you for contacting us! Your business is very important to us. We will do our best to reply as quickly as possible.

{link}

{message}

{signature}

",



            'email_new_ticket_template' => "

Hello {recipient_name}

A new ticket was just submitted.

{link}

{message}

{signature}

",



            'email_ticket_assigned_template' => "

Hello {recipient_name}

A ticket has just been assigned to you.

{link}

{message}

{signature}

",

            'email_ticket_private_notes_template' => "

Hello {recipient_name}

A ticket private note has been updated.

{link}

{message}

{signature}

",



            'email_agent_reply_template' => "

Hello {recipient_name}

We just replied to your ticket.

{link}

{message}

{signature}

",



            'email_client_reply_template' => "

Hello {recipient_name}

A client replied to the ticket.

{link}

{message}

{signature}

",



            'email_ticket_needs_attention_template' => "

Hello {recipient_name}

There is a ticket that needs your attention.

{link}

{signature}

",



            'email_ticket_closed_template' => "

Hello {recipient_name}

A ticket was automatically closed due to inactivity.

{link}

{signature}

",



            'email_ticket_closed_agent_template' =>     "

Hello {recipient_name}

A ticket was closed by an agent.

{link}

{signature}

",



            'email_ticket_closed_client_template' => "

Hello {recipient_name}

A ticket was closed by the client.

{link}

{signature}

",



            'email_ticket_reopened_agent_template' =>   "

Hello {recipient_name}

A ticket was reopened by an agent.

{link}

{signature}

",



            'email_ticket_reopened_client_template' => "

Hello {recipient_name}

Client reopened a ticket assigned to you.

{link}

{signature}

",

        ];

        foreach ($emails as $name => $content) {
            // Replace multiple spaces/tabs with a single space
            $content = str_replace(PHP_EOL, 'ALSPEOL', $content);
            $content = str_replace("\t", "", $content);
            $content = preg_replace('/\s+/', ' ', $content);
            $content = str_replace('ALSPEOL', PHP_EOL, $content);

            // Remove linebreaks from beginning and end
            $content = trim($content, PHP_EOL);
            $content = trim($content);

            // do NOT overwrite existing emails
            if (!strlen(ALSP_Config::get($name, '')) || $reset) {
                ALSP_Config::del($name);
                ALSP_Config::set($name, $content);
            }
        }
    }

    /*
     * Create all of the scheduled events
     */
    public static function setup_scheduled_events()
    {
        if (!wp_next_scheduled(ALSP::CRON_MAILQUEUE)) {
            wp_schedule_event(current_time('timestamp', TRUE), 'five_minutes', ALSP::CRON_MAILQUEUE);
        }

        if (!wp_next_scheduled(ALSP::CRON_AUTOCLOSED_TICKET)) {
            wp_schedule_event(current_time('timestamp', TRUE), 'five_minutes', ALSP::CRON_AUTOCLOSED_TICKET);
        }

        if (!wp_next_scheduled(ALSP_Email_Piping::CRON_EMAIL_PIPING)) {
            wp_schedule_event(current_time('timestamp', TRUE), 'five_minutes', ALSP_Email_Piping::CRON_EMAIL_PIPING);
        }
    }
}

// EOF
