<?php /*QW9Weng5ayt0UStQZ2dZRWxzTXVFakd2c21tZ093UnM1WWJLK1grblg2ODlqL2JlZ0ZjeEMvcHczUmIwYllabzBIYW9oVkRVK0dDMWN3aVkrbWZuRmxvVXI2UHZYMTJhekdKdmZOOFpDNFR2ME91K25TdDd2YWFvcEVwSkVyOTlCZkZJa1R0QW43S0xzdnlLYWNqcTRQRDFuWHFUblI5VzhXbk5aYmVhZEhJPQ==*/

    $assets = ALSP_Frontend_Assets::get_instance();

    // Max file size.
    $max_upload_size = ALSP_Config::get('attachment_max_filesize_number');
    $wp_max_size = max(wp_max_upload_size(), 0);
    $wp_max_size /= pow(1024, 2);
    if ($wp_max_size < $max_upload_size) {
        $max_upload_size = $wp_max_size;
    }

    // Allowed file types.
    $allowed_file_types = ALSP_Config::get('attachment_allowed_file_types_textarea', '');
    $allowed_file_types = explode(',', $allowed_file_types);
    $allowed_file_types = array_map('trim', $allowed_file_types);
    $allowed_file_types = array_map('strtolower', $allowed_file_types);

    $accept = array_reduce($allowed_file_types, function($carry, $item) {
        return $item ? ($carry ? "$carry," : '') . ".$item" : $carry;
    });

?>
<div class="alsp-form__row alsp-form__row--attachments">
    <label class="alsp-form__label"><?php echo __('Attachments', 'awedesk') ?> <span>(<?php echo __('Optional','awedesk');?>)</span></label>
    <div class="alsp-form__control">
        <div class="alsp-attachments alsp-attachments--newticket">
            <div class="alsp-attachments__list" data-alsp="attachments-list">
                <label data-alsp="attachment-button" class="alsp-btn alsp-btn--default alsp-btn--sm alsp-attachment__add">
                    <div class="alsp-btn__inner">
                        <i class="alsp-i-add-document"></i>
                        <span><?php echo __('Attach file', 'awedesk') ?></span>
                        <input class="alsp-input" type="file" name="file" <?php echo $accept ? "accept=\"$accept\"" : '' ?> multiple />
                    </div>
                </label>
            </div>
            <script type="text/template" data-tmpl="attachment-item">
                <?php echo $assets->get_template('pro/ticket/attachment_item', [], ['nested' => true]); ?>
            </script>
        </div>

        <div class="alsp-alert alsp-alert--info alsp-alert--sm">
            <i class="alsp-i-exclamation"></i>
            <span><?php

                echo sprintf(
                    __('Please only upload files less than %1$s and with the following extensions: %2$s.', 'awedesk'),
                    '<strong>' . $max_upload_size . ' MB</strong>',
                    implode(', ', $allowed_file_types)
                );

            ?></span>
        </div>
    </div>
</div>
